=== Start merge of feature-branch 2007-10-12 ===

2007-10-03  Andrew Wellington  <proton@wiretapped.net>

        Reviewed by Mark Rowe.
        
        Mac build fix for issue introduced in r26027

        * WebCoreSupport/WebSystemInterface.m:
        (InitWebCoreSystemInterface):

2007-10-01  Eric Seidel  <eric@webkit.org>

        Reviewed by Oliver Hunt.
        
        SVG Subresources will not be saved when creating WebArchives
        http://bugs.webkit.org/show_bug.cgi?id=15280
        
        Implement _subresourceURLs methods for more SVGElement types
        more such methods will be needed as we add support for other
        external references (such as use, mpath, tref, etc.)

        * DOM/WebDOMOperations.mm:
        (-[DOMSVGScriptElement _subresourceURLs]): added.
        (-[DOMSVGCursorElement _subresourceURLs]): added.
        (-[DOMSVGFEImageElement _subresourceURLs]): added.

2007-10-01  Eric Seidel  <eric@webkit.org>

        Reviewed by Oliver Hunt.
        
        WebArchives do not embed stylesheets referenced by xml-stylesheeet
        http://bugs.webkit.org/show_bug.cgi?id=15320

        * DOM/WebDOMOperations.mm:
        (-[DOMProcessingInstruction _stylesheetURL]): needed to access [[self sheet] href]
        (-[DOMProcessingInstruction _subresourceURLs]): call and return _stylesheetURL

2007-10-01  Eric Seidel  <eric@webkit.org>

        Reviewed by Oliver Hunt.

        * DOM/WebDOMOperations.mm: added DOMSVGElementImage _subresources implementation
        (-[DOMNode _URLsFromSelectors:]): now handles DOMSVGAnimatedString return values
        (-[DOMSVGImageElement _subresourceURLs]): added.
        * MigrateHeaders.make: copies DOMSVG* headers into WebKit/PrivateHeaders

2007-10-01  Oliver Hunt  <oliver@apple.com>

        Reviewed by Mark.

        Enable Experimental SVG features by default when building from Xcode

        * Configurations/WebKit.xcconfig:

=== End merge of feature-branch 2007-10-12 ===

2007-10-11  Mark Rowe  <mrowe@apple.com>

        Reviewed by Tim Hatcher.

        Fix for <rdar://problem/5488678>.  Disable debugging symbols in production builds for 10.4
        PowerPC to prevent a huge STABS section from being generated.

        * Configurations/Base.xcconfig:

2007-10-10  Alice Liu  <alice.liu@apple.com>

        Reviewed by Geoff Garen.

        Fixed <rdar://5464402> Crash when running fast/frames/onload-remove-iframe-crash.html in DRT
        createFrame() now returns a RefPtr instead of a raw Frame pointer. 
        Making this change improves the way we handle frames on Windows WebKit. 

        * WebCoreSupport/WebFrameLoaderClient.h:
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::createFrame):

2007-10-04  Beth Dakin  <bdakin@apple.com>

        Reviewed by John Sullivan.

        Fix for <rdar://problem/5441823> REGRESSION (r25142, Tiger only): 
        Vertical scroll bar not redrawn properly when going back in history 
        (15033)

        This fix if-defs r25142 to be Leopard-only since it causes 
        correctness issues on Tiger and does not seem to have any 
        performance impact on Tiger either.

        * WebView/WebDynamicScrollBarsView.m:
        (-[WebDynamicScrollBarsView setScrollBarsSuppressed:repaintOnUnsuppress:]):
        (-[WebDynamicScrollBarsView reflectScrolledClipView:]):

2007-10-04  Mark Rowe  <mrowe@apple.com>

        Reviewed by Oliver.

        Switch to default level of debugging symbols to resolve <rdar://problem/5488678>.
        The "full" level appears to offer no observable benefits even though the documentation
        suggests it be used for dead code stripping.  This should also decrease link times.

        * Configurations/Base.xcconfig:

2007-10-04  Adele Peterson  <adele@apple.com>

        Reviewed by Darin.

        WebKit part of fix for <rdar://problem/5369017> REGRESSION: Can't tab to webview that doesn't have editable content

        * WebView/WebHTMLView.mm: (-[WebHTMLView becomeFirstResponder]): Pass in the FocusDirection.

2007-10-04  Darin Adler  <darin@apple.com>

        * WebView/WebHTMLView.mm: (-[WebHTMLView _updateActiveState]):
        Removed a bogus comment.

2007-10-02  Kevin Decker  <kdecker@apple.com>

        Reviewed by Mark Rowe.

        Re-added _minimumRequiredSafariBuildNumber. It turns out older version of Safari still rely
        on this method, so we need to keep it around at least until the next major Safari release.

        * StringsNotToBeLocalized.txt:
        * WebView/WebView.mm:
        (+[WebView _minimumRequiredSafariBuildNumber]):
        * WebView/WebViewPrivate.h:

2007-10-02  Kevin Decker  <kdecker@apple.com>

        Reviewed by John Sullivan.

        <rdar://problem/5517710> 

        * WebView/WebView.mm: Removed -[WebView _minimumRequiredSafariBuildNumber] because newer
         versions of Safari no longer use this method. This won't break existing Safaris because
         they always use a respondsToSelector check before calling this.
         
        * WebView/WebViewPrivate.h: Ditto. 

2007-09-27  John Sullivan  <sullivan@apple.com>

        Reviewed by Ollie
        
        - fixed <rdar://problem/5408186> REGRESSION (5522-5523.9): Safari leaks every browser window
        
        The leak started occurring when we removed the code to clear the delegates and the host window
        from Safari as part of the fix for 5479443. But it turns out that Safari code was masking a
        bug here in WebView: setHostWindow:nil needs to be called before setting _private->closed to
        YES, or it will do nothing at all, causing a world leak due to a circular reference between
        the window and the WebView.
        
        I toyed with a more complex fix, but this is the simplest one that retains the fix for 5479443
        while otherwise restoring the code order to be as close as possible to what it was before
        5479443 was fixed.

        * WebView/WebView.mm:
        (-[WebView _close]):
        Moved the call that sets _private->closed to YES to be after the code that clears the delegates
        and the host window. Added a comment about this order.

2007-09-27  Kevin Decker  <kdecker@apple.com>

        Rubber stamped by Darin.

        <rdar://problem/5493093>

        * WebKit.order: Added.
        * WebKit.xcodeproj/project.pbxproj:  We're changing from using an order file built by
         another team to using one we actually check into our project repository. Linker settings for
         Symbol Ordering Flags have been updated accordingly.

2007-09-26  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Adele Peterson.
        
        Fixed <rdar://problem/5507476> Promote cache model SPI to API
        
        Promoted cache model SPI to API. This was just a move, with some small 
        edits to the documentation (changing 'application' to 'WebView' in 
        some cases, since the interface is now per-WebView).

        * WebView/WebPreferences.h:
        * WebView/WebPreferences.m:
        (-[WebPreferences setCacheModel:]):
        (-[WebPreferences cacheModel]):
        * WebView/WebPreferencesPrivate.h:

2007-09-24  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Darin.

        <rdar://problem/5498016> Photoshop CS3: Adobe Help Viewer 1.1 crashes in 9A553

        WebKit started calling the mouseDidMoveOverElement delegate method with a nil dictionary in r14982.
        We originally intended to call this delegate method sometimes with a nil dictionary, but due to
        a bug dating back to WebKit 1.0 this delegate was never called with nil! Unfortunately we can't
        start calling this with nil since it will break Adobe Help Viewer, and possibly other clients.

        * WebView/WebView.mm:
        (-[WebView _mouseDidMoveOverElement:modifierFlags:]):

2007-09-21  Kevin Decker  <kdecker@apple.com>

        * Plugins/WebBaseNetscapePluginView.mm: Build fix. 
        The first argument of aglChoosePixelFormat() has changed from const AGLDevice *gdevs on Tiger to
        const void *gdevs on Leopard.

2007-09-20  Kevin Decker  <kdecker@apple.com>

        Reviewed by Darin Adler.

        <rdar://problem/5493093>

        Reduced launch time by lazily linking both the AGL and OpenGL frameworks until they are really needed.

        * Plugins/WebBaseNetscapePluginView.mm: Soft link all AGL and OpenGL functions used by
        WebBaseNetscapePluginView.

        * WebKit.xcodeproj/project.pbxproj: Removed AGL and OpenGL from the project.

2007-09-20  John Sullivan  <sullivan@apple.com>

        Build fix for stoooopid old PPC gcc compiler

        * WebCoreSupport/WebEditorClient.mm:
        (WebEditorClient::checkSpellingOfString):
        replace perfectly valid ?: syntax with if/else

2007-09-19  John Sullivan  <sullivan@apple.com>

        Reviewed by Darin Adler.

        - WebKit part of speculative fix for <rdar://problem/5490627>, about crashes constructing a
          String using the values filled in by checkSpellingOfString()

        * WebCoreSupport/WebEditorClient.mm:
        (WebEditorClient::checkSpellingOfString):
        convert NSNotFound to -1, since WebCore code expects -1 for this purpose. We already do this
        in checkGrammarOfString.

2007-09-19  Kevin Decker  <kdecker@apple.com>

        Reviewed by Darin Adler.

        <rdar://problem/5491066> soft link Accelerate.framework
        
        * Misc/WebGraphicsExtras.c:
        (WebConvertBGRAToARGB): Improve launch time performance and reduce vsize
        footprint by soft linking the Accelerate.framework.
        * WebKit.xcodeproj/project.pbxproj: Remove no longer needed frameworks.

2007-09-18  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Darin Adler.
        
        Fixed <rdar://problem/5490204> In some cases, WebKit can make the 
        Foundation disk cache way too big or way too small
        
        Use the actual location of the foundation disk cache, rather than 
        the user's home directory, when determining how big to make it.

        * WebView/WebView.mm:
        (+[WebView _setCacheModel:]):

2007-09-17  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Darin Adler.

        Fixed a hang due to an infinite script running in the window's unload 
        event handler, which may be the cause of <rdar://problem/5479443> 
        REGRESSION: Hang due to infinite JS recursion on close @ engadget.com 
        (onunload-based ad)

        * WebView/WebUIDelegatePrivate.h: Added FIXME.
        
        * WebView/WebView.h: Clarified headerdoc ambiguity about when delegate 
        methods stop firing.

        * WebView/WebView.mm:
        (-[WebView _close]): The fix: don't nil out our delegates until after
        detaching the FrameLoader, because the act of detaching the FrameLoader
        might fire important delegate methods, like webViewShouldInterruptJavaScript:.
        Don't do other tear-down either, because the unload event handler needs 
        to run in a fully constructed page.
        
        This change is fairly low risk because niling out our delegates is a 
        very recent, never-shipped feature in WebKit, so it's unlikely that any 
        apps rely on it in a crazy way.

2007-09-15  Darin Adler  <darin@apple.com>

        Reviewed by John Sullivan.

        - fix <rdar://problem/5391540> REGRESSION: Can't drag images from Safari to applications
          in the dock (Tiger Preview, others in Leopard)

        * Misc/WebNSPasteboardExtras.mm:
        (-[NSPasteboard _web_declareAndWriteDragImageForElement:URL:title:archive:source:]):
        Re-implement code here that has been missing for the last couple of years since we
        did some image refactoring. Was pretty easy now that we can freely call C++ code
        in WebKit.

2007-09-14  Mark Rowe  <mrowe@apple.com>

        Build fix for Tiger.

        * WebView/WebArchive.m:
        (-[WebArchive initWithCoder:]): Use @catch(id) rather than @catch(...).
        * WebView/WebPreferences.m:
        (-[WebPreferences initWithCoder:]): Ditto.
        * WebView/WebResource.mm:
        (-[WebResource initWithCoder:]): Ditto.
        (-[WebResource _initWithPropertyList:]): Ditto.

2007-09-14  Darin Adler  <darin@apple.com>

        Reviewed by Geoff Garen and Tim Hatcher.

        - fixed <rdar://problem/5482745> initFromCoder: and initWithPropertyList: functions
          should guard against incorrect types

        * WebView/WebArchive.m:
        (isArrayOfClass): Added helper function.
        (-[WebArchive _initWithPropertyList:]): Tweaked function to remove the need for a
        type cast.
        (-[WebArchive initWithCoder:]): Added type checking for the main resource,
        subresources array, and subframe archives array. Also replaced NS_DURING with @try.
        * WebView/WebPreferences.m: (-[WebPreferences initWithCoder:]): Added type checking
        for the identifier and the values dictionary, including ensuring that it's a mutable
        dictionary.
        * WebView/WebResource.mm:
        (-[WebResource initWithCoder:]): Added type checking for all the fields.
        (-[WebResource _initWithPropertyList:]): Added type checking for the NSURLResponse.

        * WebKit.exp: Removed accidentally exported internal symbol; I checked and it's not
        used anywhere.

2007-09-13  Darin Adler  <darin@apple.com>

        Reviewed by Oliver.

        - fix <rdar://problem/5470457> REGRESSION: Input method inline hole is mishandled in text
          <input> elements with maxlength limit

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _selectionChanged]): Tweaked code a bit.
        (-[WebHTMLView markedRange]): Simplified logic, since markedTextNSRange works when there's
        no composition range.
        (-[WebHTMLView hasMarkedText]): Call directly to Editor instead of bridge.
        (-[WebHTMLView unmarkText]): Call new confirmComposition to make it clear that this is
        confirming text, not just unmarking it to discard it.
        (extractUnderlines): Added. Converts directly from an NSAttributedString to the
        CompositionUnderline vector that's used by WebCore.
        (-[WebHTMLView setMarkedText:selectedRange:]): Changed to use the new setComposition.
        (-[WebHTMLView insertText:]): Changed to use confirmComposition when appropriate, instead
        of relying on special behavior of Editor::insertText.
        (-[WebHTMLView _updateSelectionForInputManager]): Rewrote to use getCompositionSelection
        and confirmCompositionWithoutDisturbingSelection.

        * WebCoreSupport/WebEditorClient.h:
        * WebCoreSupport/WebEditorClient.mm:
        Removed obsolete markedTextAbandoned function.
 
2007-09-12  David Kilzer  <ddkilzer@apple.com>

        Rubber-stamped by Darin and reviewed by Adam.

        Removed import of unused icon database headers.

        * WebCoreSupport/WebFrameBridge.mm:

2007-09-11  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Darin.

        Remove the unused class_getMethodImplementation function.

        * Misc/WebNSObjectExtras.h:

2007-09-11  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Oliver Hunt.
        
        Fixed CFNetwork version check so it actually works.

        * Misc/WebKitVersionChecks.h:
        * WebView/WebView.mm:
        (+[WebView _setCacheModel:]): Don't use NSVersionOfLinkTimeLibrary because
        we don't link against CFNetwork directly, so it returns -1. Also, use
        the proper hex encoding instead of decimal numbers.

2007-09-11  Darin Adler  <darin@apple.com>

        - redo fix for <rdar://problem/5472899> REGRESSION (TOT): Crash in FrameLoadDelegate loading stationery

        * WebView/WebView.mm:
        (getMethod): Added.
        (-[WebView _cacheResourceLoadDelegateImplementations]): Use getMethod.
        (-[WebView _cacheFrameLoadDelegateImplementations]): Ditto.

2007-09-11  Darin Adler  <darin@apple.com>

        Rubber-stamped by Dave Harrison.

        * WebCoreSupport/WebSystemInterface.m: (InitWebCoreSystemInterface):
        Removed wkCreateURLPasteboardFlavorTypeName and wkCreateURLNPasteboardFlavorTypeName.

2007-09-11  Darin Adler  <darin@apple.com>

        Reviewed by Mark Rowe.

        - fix <rdar://problem/5472899> REGRESSION (TOT): Crash in FrameLoadDelegate loading stationery

        * Misc/WebNSObjectExtras.h:
        (class_getMethodImplementation): Added.
        (method_setImplementation): Added.

        * WebView/WebHTMLView.mm: (+[WebHTMLViewPrivate initialize]):
        * Carbon/HIViewAdapter.m: (+[HIViewAdapter bindHIViewToNSView:nsView:]):
        Remove old-ObjC code path, since WebNSObjectExtras.h now implements everything we need.

        * WebView/WebView.mm:
        (-[WebView _cacheResourceLoadDelegateImplementations]): Don't bother doing a separate
        respondsToSelector call, since class_getMethodImplementation will return 0 for selectors
        that we don't respond to. The bug fix is to actually set the cached pointer to 0.
        Also get rid of the unnecessary use of a macro; instead use the functions from
        WebNSObjectExtras.h on Tiger and the appropriate function directly on Leopard.
        (-[WebView _cacheFrameLoadDelegateImplementations]): Ditto.

2007-09-11  Darin Adler  <darin@apple.com>

        Reviewed by Sam, Ollie.

        * WebView/WebView.mm: (+[WebView _setCacheModel:]): A slightly cleaner 64-bit
        fix for the NSURLCache capacity code in this file.

2007-09-11  Darin Adler  <darin@apple.com>

        Rubber-stamped by Mark Rowe.

        * Misc/WebNSPasteboardExtras.mm: Fix incorrect strings in my last check-in.
        The strings I checked in were wrong and were breaking layout tests too.
        These new ones match what WebKitSystemInterface was returning.

2007-09-10  Geoffrey Garen  <ggaren@apple.com>

        Fixed 64-bit build (I think).

        * WebView/WebView.mm:
        (max): Added. In 64-bit land, -diskCapacity magically starts returning
        unsigned long instead of unsigned, so we define a custom max() that's
        willing to compare unsigned to unsigned long.

2007-09-10  Darin Adler  <darin@apple.com>

        Reviewed by Tim Hatcher.

        - <rdar://problem/5471082> Removing WebURLPboardType from headers broke SPI-using applications

        Rolled out my fix for bug 4582212 and fixed it in a much simpler way.

        * Misc/WebNSPasteboardExtras.h:
        * Misc/WebNSPasteboardExtras.mm:
        * WebCoreSupport/WebPasteboardHelper.mm:
        * WebKit.exp:
        * WebView/WebHTMLView.mm:
        * WebView/WebView.mm:
        Rolled out the new PasteboardType functions and changed the PboardType globals to be initialized
        with constant values.

2007-09-10  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Darin.

        Always animate when calling _scrollTo.

        * WebView/WebFrameView.mm:
        (-[WebFrameView _scrollVerticallyBy:]):
        (-[WebFrameView _scrollHorizontallyBy:]):

2007-09-08  Brady Eidson  <beidson@apple.com>

        Reviewed by Darin

        <rdar://problem/5434431> - Asynchronous Icon Database

        WebKit side of things
        Mainly, there are Notifications WebKit has to listen for now that tell it when to either call back into WebCore
        for some purpose or to send the webView:didReceiveIcon: delegate call

        Many smaller tweaks as well.

        * Misc/WebIconDatabase.h:
        * Misc/WebIconDatabase.mm:
        (defaultClient):
        (-[WebIconDatabase init]):
        (+[WebIconDatabase delayDatabaseCleanup]): Accessor so clients can prevent the thread from cleaning up the database
          before they've done all their necessary retaining of icons.
        (+[WebIconDatabase allowDatabaseCleanup]):
        (-[WebIconDatabase removeAllIcons]):
        (-[WebIconDatabase _isEnabled]):
        (-[WebIconDatabase _sendNotificationForURL:]):
        (-[WebIconDatabase _sendDidRemoveAllIconsNotification]):
        (-[WebIconDatabase _databaseDirectory]):

        (-[ThreadEnabler threadEnablingSelector:]): Quick and dirty class to enabled Cocoa multithreading
        (+[ThreadEnabler enableThreading]):
        (importToWebCoreFormat):
        * Misc/WebIconDatabaseInternal.h: Expose the internal methods of WebIconDatabase that are required by WebIconDatabaseClient

        * Misc/WebNSNotificationCenterExtras.h: Added. - Great utility class whose design was borrowed from Colloquy
          that allows the posting of a Cocoa notification on the main thread from *any* thread
        * Misc/WebNSNotificationCenterExtras.m: Added.
        (-[NSNotificationCenter postNotificationOnMainThreadWithName:object:]):
        (-[NSNotificationCenter postNotificationOnMainThreadWithName:object:userInfo:]):
        (-[NSNotificationCenter postNotificationOnMainThreadWithName:object:userInfo:waitUntilDone:]):
        (+[NSNotificationCenter _postNotificationName:]):

        * WebCoreSupport/WebFrameLoaderClient.h:
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::dispatchDidReceiveIcon): Send the webView:didReceiveIcon: delegate call
        (WebFrameLoaderClient::registerForIconNotification):

        * WebCoreSupport/WebIconDatabaseClient.h: Added.
        * WebCoreSupport/WebIconDatabaseClient.mm: Added.
        (WebIconDatabaseClient::performImport):  Perform the Safari 2 icon import
        (WebIconDatabaseClient::dispatchDidRemoveAllIcons): Send the NSNotification
        (WebIconDatabaseClient::dispatchDidAddIconForPageURL): Ditto

        * WebView/WebView.mm:
        (-[WebView _receivedIconChangedNotification:]): Check and see if this notification is for this WebView's current URL by
          calling back into the IconDatabase
        (-[WebView _registerForIconNotification:]): Support for WebIconDatabaseClient
        (-[WebView _dispatchDidReceiveIconFromWebFrame:]): Dispatch this delegate call as well as unregister for the notification
        * WebView/WebViewInternal.h:

        * WebKit.xcodeproj/project.pbxproj:

2007-09-07  Geoffrey Garen  <ggaren@apple.com>

        Suggested by Maciej Stachowiak.
        
        Added wKiosk Browser to the browser list. Pretty sweet app.

        * WebView/WebPreferences.m:
        (cacheModelForMainBundle):

2007-09-07  Geoffrey Garen  <ggaren@apple.com>

        Build fix.

        * WebView/WebView.mm:
        (+[WebView _setCacheModel:]):

2007-09-05  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Darin Adler, Maciej Stachowiak, Mark Rowe, Tim Hatcher.
        
        Fixed <rdar://problem/5326009> Make non-browser WebKit clients have no 
        memory cache, or a very tiny one
        
        High level explanation:
            - Added SPI for specifying a cache model on a per-WebView basis. 
            (Hopefully, this will become API soon.) We balance competing
            cache models simply by using the largest one that pertains at a
            given time.

            - Added heuristic for guessing a default cache model in WebViews
            that don't specify one:
                1) Default to DocumentViewer for apps linked on or after this
                WebKit. Default to DocumentBrowser otherwise.

                2) Assign specific defaults to well-known clients based on 
                bundle ID.

                3) Grow the default to DocumentBrowser if a navigation takes 
                place.

            - As a part of the DocumentBrowser & PrimaryWebBrowser settings:
                1) Make the Foundation disk cache much much bigger than the 
                default 20MB, if space allows. (This is a hedge against a small 
                WebCore cache in DocumentBrowser mode, but also an all-around 
                win for page load speed.)

                2) Scaled the Foundation memory cache's capacity with physical
                RAM, just like we do with other caches. This is a small win on
                low memory systems.

        * Misc/WebKitSystemBits.h:
        * Misc/WebKitSystemBits.m:
        (WebMemorySize): Renamed from "WebSystemMainMemory."
        (WebHomeDirectoryFreeSize): Added function to measure the free space
        on the user's home directory. We use this as a factor in determining 
        the disk cache's cacpacity.

        * Misc/WebKitVersionChecks.h: Support for linked on or after check.
        
        * WebCoreSupport/WebFrameLoaderClient.h:
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::didPerformFirstNavigation): Implementation of
        heuristic rule #3.

        * WebView/WebPreferenceKeysPrivate.h:
        * WebView/WebPreferences.m:
        (cacheModelForMainBundle): Implementation of heuristic rule #2.
        (-[NSMutableDictionary _web_checkLastReferenceForIdentifier:]): Added
        notification for when a WebPreferences instance becomes inert. We use
        this to shrink the cache model back down if possible. Moved this code
        into a WebPreferences method, since it's not really a feature of 
        NSDictionary.

        * WebView/WebPreferencesPrivate.h: SPI declarations.
        
        * WebView/WebView.mm: Replaced manual notification posts with calls to
        the _postPreferencesChangesNotification convenience method.

        (-[WebView _preferencesChangedNotification:]): Merged dispersed code
        for updating preferences-related settings into this one function. This
        was needed for an earlier version of the patch, even though the 
        current version could probably do without it.

        (+[WebView _preferencesChangedNotification:]): Added a class-level 
        listener for WebPreferences changes. This listener takes care of 
        modifying the class-level global cache model setting if necessary.

        (+[WebPreferences standardPreferences]): Removed call to 
        _postPreferencesChangesNotification because the notification already 
        posts when you create the WebPreferences object. (I noticed this 
        inefficiency because my new _preferencesChangedNotification: method was
        called excessively at startup.)

        Also Added explicit tracking of WebPreferences clients, so we know when
        a WebPreferences instance becomes inert:
        
        (-[WebPreferences didRemoveFromWebView]):
        (-[WebPreferences willAddToWebView]):

        (+[WebView _setCacheModel:]): Translates a cache model into actual 
        settings in various APIs. Caches that have unbounded value grow 
        linearly relative to available space. Caches that have bounded value 
        grow inverse-squaredly relative to available space.

2007-09-05  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Darin.

        <rdar://problem/5443883> Uncaught Objective-C exceptions in WebKit clients lead to hard-to-diagnose crashes

        Changed all the direct delegate calls to use helper functions that have direct access to
        WebView's delegate objects. These helper methods will catch any ObjC exceptions and call
        ReportDiscardedDelegateException to log the discarded exception. WebView's that have
        catchesDelegateExceptions set to NO will not pay the cost of a @try/@catch. The delegate
        forwarders also have the same behavior.

        * Misc/WebKitLogging.h:
        * Misc/WebKitLogging.m:
        (ReportDiscardedDelegateException):
        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView loadPluginRequest:]):
        * Plugins/WebNullPluginView.mm:
        (-[WebNullPluginView viewDidMoveToWindow]):
        * WebCoreSupport/WebChromeClient.mm:
        (WebChromeClient::createWindow):
        (WebChromeClient::createModalDialog):
        (WebChromeClient::runModal):
        (WebChromeClient::toolbarsVisible):
        (WebChromeClient::statusbarVisible):
        (WebChromeClient::addMessageToConsole):
        (WebChromeClient::canRunBeforeUnloadConfirmPanel):
        (WebChromeClient::runBeforeUnloadConfirmPanel):
        (WebChromeClient::runJavaScriptAlert):
        (WebChromeClient::runJavaScriptConfirm):
        (WebChromeClient::runJavaScriptPrompt):
        (WebChromeClient::shouldInterruptJavaScript):
        (WebChromeClient::setStatusbarText):
        (WebChromeClient::print):
        * WebCoreSupport/WebContextMenuClient.mm:
        (WebContextMenuClient::getCustomMenuFromDefaultItems):
        (WebContextMenuClient::contextMenuItemSelected):
        * WebCoreSupport/WebDragClient.mm:
        (WebDragClient::startDrag):
        * WebCoreSupport/WebEditorClient.mm:
        (WebEditorClient::textFieldDidBeginEditing):
        (WebEditorClient::textFieldDidEndEditing):
        (WebEditorClient::textDidChangeInTextField):
        (WebEditorClient::doTextFieldCommandFromEvent):
        (WebEditorClient::textWillBeDeletedInTextField):
        (WebEditorClient::textDidChangeInTextArea):
        * WebCoreSupport/WebFrameBridge.mm:
        (-[WebFrameBridge viewForPluginWithFrame:URL:attributeNames:attributeValues:MIMEType:DOMElement:loadManually:]):
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::dispatchDidLoadResourceFromMemoryCache):
        (WebFrameLoaderClient::assignIdentifierToInitialRequest):
        (WebFrameLoaderClient::dispatchWillSendRequest):
        (WebFrameLoaderClient::dispatchDidReceiveAuthenticationChallenge):
        (WebFrameLoaderClient::dispatchDidCancelAuthenticationChallenge):
        (WebFrameLoaderClient::dispatchDidReceiveResponse):
        (WebFrameLoaderClient::willCacheResponse):
        (WebFrameLoaderClient::dispatchDidReceiveContentLength):
        (WebFrameLoaderClient::dispatchDidFinishLoading):
        (WebFrameLoaderClient::dispatchDidFailLoading):
        (WebFrameLoaderClient::dispatchDidHandleOnloadEvents):
        (WebFrameLoaderClient::dispatchDidReceiveServerRedirectForProvisionalLoad):
        (WebFrameLoaderClient::dispatchDidCancelClientRedirect):
        (WebFrameLoaderClient::dispatchWillPerformClientRedirect):
        (WebFrameLoaderClient::dispatchDidChangeLocationWithinPage):
        (WebFrameLoaderClient::dispatchWillClose):
        (WebFrameLoaderClient::dispatchDidReceiveIcon):
        (WebFrameLoaderClient::dispatchDidStartProvisionalLoad):
        (WebFrameLoaderClient::dispatchDidReceiveTitle):
        (WebFrameLoaderClient::dispatchDidCommitLoad):
        (WebFrameLoaderClient::dispatchDidFailProvisionalLoad):
        (WebFrameLoaderClient::dispatchDidFailLoad):
        (WebFrameLoaderClient::dispatchDidFinishDocumentLoad):
        (WebFrameLoaderClient::dispatchDidFinishLoad):
        (WebFrameLoaderClient::dispatchDidFirstLayout):
        (WebFrameLoaderClient::dispatchCreatePage):
        (WebFrameLoaderClient::dispatchUnableToImplementPolicy):
        (WebFrameLoaderClient::dispatchWillSubmitForm):
        (WebFrameLoaderClient::dispatchDidLoadMainResource):
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView callDelegateDoCommandBySelectorIfNeeded:]):
        (-[WebHTMLView validateUserInterfaceItem:]):
        * WebView/WebPDFView.mm:
        (-[WebPDFView validateUserInterfaceItem:]):
        (-[WebPDFView PDFViewSavePDFToDownloadFolder:]):
        * WebView/WebView.mm:
        (-[WebView _openNewWindowWithRequest:]):
        (-[WebView _menuForElement:defaultItems:]):
        (-[WebView _mouseDidMoveOverElement:modifierFlags:]):
        (-[WebView _cacheResourceLoadDelegateImplementations]):
        (-[WebView _cacheFrameLoadDelegateImplementations]):
        (-[WebView _policyDelegateForwarder]):
        (-[WebView _UIDelegateForwarder]):
        (-[WebView _editingDelegateForwarder]):
        (-[WebView _scriptDebugDelegateForwarder]):
        (-[WebView _setCatchesDelegateExceptions:]):
        (-[WebView _catchesDelegateExceptions]):
        (-[_WebSafeForwarder initWithTarget:defaultTarget:]):
        (-[_WebSafeForwarder forwardInvocation:]):
        (-[_WebSafeForwarder methodSignatureForSelector:]):
        (-[WebView _commonInitializationWithFrameName:groupName:]):
        (-[WebView validateUserInterfaceItem:]):
        (-[WebView _headerHeight]):
        (-[WebView _footerHeight]):
        (-[WebView _drawHeaderInRect:]):
        (-[WebView _drawFooterInRect:]):
        (-[WebView _shouldChangeSelectedDOMRange:toDOMRange:affinity:stillSelecting:]):
        (CallDelegate):
        (CallDelegateReturningFloat):
        (CallDelegateReturningBoolean):
        (CallUIDelegate):
        (CallUIDelegateReturningFloat):
        (CallUIDelegateReturningBoolean):
        (CallFrameLoadDelegate):
        (CallResourceLoadDelegate):
        (CallFormDelegate):
        (CallFormDelegateReturningBoolean):
        * WebView/WebViewInternal.h:
        * WebView/WebViewPrivate.h:

2007-09-04  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Darin.

        <rdar://problem/5452908> NIBs saved in the Pre-10.2 format while Safari 3 installed do not work without Safari 3

        This happened because we encoded a new field that the old WebKit does not know how to read.
        And NSCoder throws an exception if initWithCoder finishes while there is still unread data in the archive.

        The WebViewVersion is now 4 to distinguish that we do not encode/decode allowsUndo.

        * WebView/WebView.mm:
        (-[WebView initWithCoder:]): Only try to read allowsUndo if the version is 3.
        (-[WebView encodeWithCoder:]): No longer encode allowsUndo.

2007-09-04  David Hyatt  <hyatt@apple.com>

        Fix for <rdar://problem/5271213>, resizing iChat window is slower than in
        Tiger.  This patch implements a fast scaling mode that can be used by
        WebViews, e.g., during window resizing.

        Reviewed by John Sullivan

        * WebView/WebView.mm:
        (-[WebView _setUseFastImageScalingMode:]):
        (-[WebView _inFastImageScalingMode]):
        * WebView/WebViewPrivate.h:

2007-09-04  Darin Adler  <darin@apple.com>

        Reviewed by Hyatt.

        * WebView/WebView.mm:
        (-[WebView _loadBackForwardListFromOtherView:]): Added missing null check.
        (-[WebView _setInitiatedDrag:]): Ditto.
        (-[WebView _clearUndoRedoOperations]): Ditto.
        (-[WebView encodeWithCoder:]): Ditto.
        (-[WebView backForwardList]): Ditto.
        (-[WebView setMaintainsBackForwardList:]): Ditto.

2007-09-04  Tristan O'Tierney  <tristan@apple.com>

        Reviewed by John Sullivan.
        
        <rdar://problem/5454935> Can't reply to this message in Mail -- -[DOMRange webArchive] is throwing an exception

        * WebView/WebArchiver.mm:
        (+[WebArchiver _archiveWithMarkupString:fromFrame:nodes:]):
        Guard the creation of WebResource by ensuring that the passed in
        responseURL is never nil.

2007-09-03  Mark Rowe  <mrowe@apple.com>

        Reviewed by Tim Hatcher.

        <rdar://problem/5452164> Production build with in symbols directory has no debug info

        Enable debug symbol generation on all build configurations.  Production builds are stripped
        of symbols by Xcode during deployment post-processing.

        * Configurations/Base.xcconfig:
        * WebKit.xcodeproj/project.pbxproj:

2007-09-02  Brady Eidson  <beidson@apple.com>

        Reviewed by John Sullivan and Mark Rowe

        Groundwork for support for monitoring IconDatabase in-memory statistics
 
        * Misc/WebCoreStatistics.h:
        * Misc/WebCoreStatistics.mm:
        (+[WebCoreStatistics iconPageURLMappingCount]):
        (+[WebCoreStatistics iconRetainedPageURLCount]):
        (+[WebCoreStatistics iconRecordCount]):
        (+[WebCoreStatistics iconsWithDataCount]):

2007-09-01  Oliver Hunt  <oliver@apple.com>

        Reviewed by Sam.

        <rdar://problem/5344848> IME is incorrectly used for key events when on non-editable regions

        EditorClient::setInputMethodState stub

        * WebCoreSupport/WebEditorClient.h:
        * WebCoreSupport/WebEditorClient.mm:
        (WebEditorClient::setInputMethodState):

2007-08-30  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Tim.
        
        <rdar://problem/5439953> REGRESSION: Cannot load feeds in widgets in Dashcode due to change in WebKit delegate methods

        * WebView/WebFrame.mm:
        (-[WebFrame _attachScriptDebugger]): Don't create the debugger object if the frame has not yet
        created its script interpreter, to avoid premature dispatch of windowScriptObjectAvailable/Cleared
        delegate methods. The script debugger will be created in any case when the window object does appear.

2007-08-29  Darin Adler  <darin@apple.com>

        Reviewed by Tim Hatcher.

        - fix <rdar://problem/4582212> WebKit inappropriately adds +initialize to
          NSPasteboard via a category, prevents AppKit initialize
          http://bugs.webkit.org/show_bug.cgi?id=9417

        * Misc/WebNSPasteboardExtras.h: Got rid of the global data objects and replaced
        them with global functions.

        * Misc/WebNSPasteboardExtras.mm:
        (initializePasteboardTypes): Changed the initialize method to be this function.
        (WebURLPasteboardType): Added, calls the initialize function and then returns
        the value of the global.
        (WebURLNamePasteboardType): Ditto.
        (+[NSPasteboard _web_writableTypesForURL]): Changed to call the new function instead
        of getting at the global directly.
        (+[NSPasteboard _web_dragTypesForURL]): Ditto.
        (-[NSPasteboard _web_writeURL:andTitle:types:]): Ditto.
        * WebCoreSupport/WebPasteboardHelper.mm:
        (WebPasteboardHelper::urlFromPasteboard): Ditto.
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _documentFragmentFromPasteboard:forType:inContext:subresources:]): Ditto.

        * WebView/WebView.mm:
        (+[WebView initialize]): Added a call to one of the functions to take advantage
        of the side effect that initializes the globals; this is to help out old versions
        of Safari.
        (+[WebView URLTitleFromPasteboard:]): Changed to call the new function instead
        of getting at the global directly.

        * WebKit.exp: Add exports of the new functions.

2007-08-29  Adele Peterson  <adele@apple.com>

        Reviewed by Darin.

        Fix for http://bugs.webkit.org/show_bug.cgi?id=15098
        <rdar://problem/5440319> REGRESSION (9A530-9A534): Double scroll bar on pdfs

        * WebCoreSupport/WebFrameLoaderClient.mm: (WebFrameLoaderClient::makeDocumentView):
         Don't suppress scrollbars before the view creation if we're making the view for a non-html view

        * WebView/WebFrameViewInternal.h: Make _scrollView return a WebDynamicScrollBarsView since so many clients were relying on it being that type anyway.
        * WebView/WebFrameView.mm:
        (-[WebFrameView _setDocumentView:]):
        (-[WebFrameView _scrollView]):
        (-[WebFrameView setAllowsScrolling:]):
        (-[WebFrameView allowsScrolling]):
        * WebView/WebView.mm:
        (-[WebView setAlwaysShowVerticalScroller:]):
        (-[WebView alwaysShowVerticalScroller]):
        (-[WebView setAlwaysShowHorizontalScroller:]):
        (-[WebView alwaysShowHorizontalScroller]):

2007-08-29  David Hyatt  <hyatt@apple.com>

        The method that was swizzled to fix 5441281 does not exist on Tiger.
        Tiger has to do a double swizzle instead (of resetCursorRects and NSCursor's
        set method) in order to roughly achieve the same effect.

        Reviewed by darin

        * WebView/WebHTMLView.mm:
        (resetCursorRects):
        (setCursor):
        (+[WebHTMLViewPrivate initialize]):

2007-08-29  Anders Carlsson  <andersca@apple.com>

        Fix 64-bit build.
        
        * WebCoreSupport/WebFrameBridge.mm:

2007-08-29  David Hyatt  <hyatt@apple.com>

        Fix for 5441281, remove our dependency on cursor rects and drag margins
        in AppKit for a large performance boost on the PLT and iBench.

        Reviewed by darin

        * Plugins/WebBaseNetscapePluginView.h:
        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView sendNullEvent]):
        (-[WebBaseNetscapePluginView mouseEntered:]):
        (-[WebBaseNetscapePluginView mouseExited:]):
        (-[WebBaseNetscapePluginView stop]):
        Clean up cursor setting from Netscape plugins.  Don't unconditionally mutate
        the cursor when a plugin stops.

        * WebView/WebFrameView.mm:
        (-[WebFrameView _setDocumentView:]):
        Suppress the resetting of drag margins while the new document view is being
        added to the view hierarchy.

        * WebView/WebHTMLView.mm:
        (-[NSWindow _web_borderView]):
        Expose the border view of the NSWindow so that it can be hit tested.

        (setCursorForMouseLocation):
        Apply a method swizzle to override the private AppKit method, _setCursorForMouseLocation.
        We have to do this to suppress the cursor rect invalidation handling from resetting
        the cursor for no reason.

        The swizzle will do a hit test and allow the cursor set to occur if the mouse ends up
        being over a plugin or over a view other than a WebHTMLView.

        (+[WebHTMLViewPrivate initialize]):
        The swizzle for setCursorForMouseLocation is set up here.

        (-[WebHTMLView _frameOrBoundsChanged]):
        Add a 100ms delay to the fake mouse moved event that fires when the view moves
        under the mouse (without the mouse moving).  This happens on iBench when the
        pages get scrolled.  By adding a delay we ensure that even with the mouse inside
        the window, we don't experience cursor thrashing when pages are updating and
        scrolling rapidly.

2007-08-28  Anders Carlsson  <andersca@apple.com>

        Reviewed by Darin.

        <rdar://problem/5424866> Bottom portion of any Web Clip widget appears transparent
        
        * WebCoreSupport/WebFrameBridge.mm:
        Use the enum from FrameLoaderTypes.h.
        
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::objectContentType):
        Return ObjectContentNetscapePlugin and ObjectContentOtherPlugin depending on the plug-in type.

2007-08-28  Mark Rowe  <mrowe@apple.com>

        Reviewed by Maciej Stachowiak.

        Fix fallout from the fix for <rdar://problem/5437983> (Loading history containing 100,000 entries adds 20s to Safari's startup)
        in r25275.  The array of entries for each day was being maintained in the reverse of the order that was expected.

        * History/WebHistory.mm:
        (-[WebHistoryPrivate insertItem:forDateKey:]): Maintain the array of entries in descending order.

2007-08-28  Mark Rowe  <mrowe@apple.com>

        Fix the buildbot build.

        * History/WebHistory.mm:
        (timeIntervalForBeginningOfDay):  Explicitly cast to silence compiler warning.

2007-08-28  Mark Rowe  <mrowe@apple.com>

        Reviewed by Darin Adler.

        <rdar://problem/5437983> Loading history containing 100,000 entries adds 20s to Safari's startup

        Move WebHistoryItemPrivate from using a sorted array of NSCalendarDate's that map to a sorted array of arrays
        of WebHistoryItem's over to using a HashMap of NSTimeIntervals and arrays of WebHistoryItems.  NSTimeInterval
        uses less memory and is substantially cheaper during comparisons than NSCalendarDate.  The use of the HashMap
        avoids the needs to repeatedly search within an array to locate the array that corresponds to the given days
        history items.

        The result of these changes is that loading 100,000 history items drops from around 25s to 1.6s.  Loading
        100 items drops from 0.003s to 0.002s.

        * History/WebHistory.mm:
        (-[WebHistoryPrivate init]):
        (-[WebHistoryPrivate dealloc]):
        (timeIntervalForBeginningOfDay): Return the NSTimeInterval representing the beginning of the specified day.
        (-[WebHistoryPrivate findKey:forDay:]):
        (-[WebHistoryPrivate insertItem:forDateKey:]): Perform a binary search within the day's history items rather than a linear search.
        (-[WebHistoryPrivate _removeItemFromDateCaches:]):
        (-[WebHistoryPrivate _addItemToDateCaches:]):
        (-[WebHistoryPrivate removeAllItems]):
        (-[WebHistoryPrivate orderedLastVisitedDays]): Generate and cache the sorted NSArray of NSCalendarDate's exposed in the API.
        This cache is invalidated by _removeItemFromDateCaches: and _addItemToDateCaches: when needed.
        (-[WebHistoryPrivate orderedItemsLastVisitedOnDay:]):
        (-[WebHistoryPrivate arrayRepresentation]):
        (-[WebHistoryPrivate _loadHistoryGutsFromURL:savedItemsCount:collectDiscardedItemsInto:error:]): Use an autorelease pool to keep the
        number of live autoreleased objects generated to a reasonable level.
        * History/WebHistoryItem.mm:
        (-[WebHistoryItem initWithURLString:title:displayTitle:lastVisitedTimeInterval:]):
        (-[WebHistoryItem initFromDictionaryRepresentation:]): Use the new HistoryItem constructor that accepts the alternate title
        rather than setting it after construction.  This prevents a modification notification from being sent for each WebHistoryItem that is loaded.
        * History/WebHistoryItemInternal.h:
        * History/WebHistoryPrivate.h:
        * Misc/WebNSCalendarDateExtras.h: Removed as _webkit_compareDay: is no longer used.
        * Misc/WebNSCalendarDateExtras.m: Removed.
        * WebKit.xcodeproj/project.pbxproj:

2007-08-28  Anders Carlsson  <andersca@apple.com>

        Reviewed by Darin.

        <rdar://problem/5298296> XMLHttpRequest readyState 3 & responseText buffer issues
        
        Expose WKSetNSURLRequestShouldContentSniff to WebCore.
        
        * WebCoreSupport/WebSystemInterface.m:
        (InitWebCoreSystemInterface):

2007-08-24  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Darin.

        <rdar://problem/5437038> 1 credential object leaked for each call to credentialWithUser:password:persistence
        - Use initWithUser instead of credentialWithUser because credentialWithUser leaks.

        * Panels/WebAuthenticationPanel.m:
        (-[WebAuthenticationPanel runAsModalDialogWithChallenge:]):
        (-[WebAuthenticationPanel sheetDidEnd:returnCode:contextInfo:]):

2007-08-24  Adele Peterson  <adele@apple.com>

        Fix by Darin, reviewed by Adele.

        Fix for <rdar://problem/5433422> Upon quitting, WebKit loads the WebPlugin shared database and immediately closes it

        * Plugins/WebPluginDatabase.h: Added closeSharedDatabase, which won't create a new database if we're just trying to close it.
        * Plugins/WebPluginDatabase.m: (+[WebPluginDatabase closeSharedDatabase]): Added.
        * WebView/WebView.mm:
        (-[WebView _close]): Call closeSharedDatabase.
        (+[WebView _applicationWillTerminate]): Call closeSharedDatabase.

2007-08-24  Timothy Hatcher  <timothy@apple.com>

        Reviewed by John Sullivan.

        <rdar://problem/5410937> HIWebView in SimpleCarbonWeb doesn't seem to be getting adequate invalidation when window is resized

        This is a more localized fix for yesterday's change. Now explicitly call _web_layoutIfNeededRecursive inside the
        HIWebView Draw() function. Adds a FIXME to explain that we need to do layout before Carbon has decided what regions to draw.
        Doing layout in Draw() will potentially cause drawing to happen in two passes, but this has always been a problem in Carbon.

        * Carbon/HIWebView.m:
        (Draw): Call _web_layoutIfNeededRecursive on the main WebHTMLView.
        (SetFocusPart): Fix to work in ObjC++ (now that HIWebView.m is treated as a ObjC++ file.)
        * WebView/WebView.mm: Removes the 4 displayIfNeeded methods from yesterday's change.
        * WebKit.xcodeproj/project.pbxproj: Force the file type of HIWebView.m to ObjC++ so WebHTMLViewInternal.h can be included.

2007-08-23  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Dave Hyatt.

        <rdar://problem/5410937> HIWebView in SimpleCarbonWeb doesn't seem to be getting adequate invalidation when window is resized

        The Carbon HIWebView was relying on layout happening when displayIfNeededInRect: was called on the WebView.
        This would happen on Tiger because _recursiveDisplayRectIfNeededIgnoringOpacity: would always do a layout if needed.
        Doing a layout in _recursiveDisplayRectIfNeededIgnoringOpacity was removed in Leopard in favor of viewWillDraw, and
        the fact that adding new dirty rects inside _recursiveDisplayRectIfNeededIgnoringOpacity on Leopard will not
        cause a drawRect in the same display loop.

        So any client on Leopard calling displayIfNeeded* on the WebView would get a layout and any new dirty rects. So
        _web_layoutIfNeededRecursive needs to be called on the main frame's WebHTMLView to make sure we layout and
        display anything that is really needed.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _layoutIfNeeded]):
        (-[WebHTMLView _web_layoutIfNeededRecursive]):
        * WebView/WebHTMLViewInternal.h:
        * WebView/WebView.mm:
        (-[WebView displayIfNeeded]): Call _web_layoutIfNeededRecursive on the main WebHTMLView.
        (-[WebView displayIfNeededIgnoringOpacity]): Ditto.
        (-[WebView displayIfNeededInRect:]): Ditto. 
        (-[WebView displayIfNeededInRectIgnoringOpacity:]): Ditto.

2007-08-22  Timothy Hatcher  <timothy@apple.com>

        Rolling out r25102 for <rdar://problem/5410937> until
        <rdar://problem/5429920> is resolved.

        * Carbon/CarbonUtils.m:
        (WebInitForCarbon):
        (PoolCleaner):
        * Carbon/CarbonWindowAdapter.h:
        * Carbon/CarbonWindowAdapter.m:
        * Carbon/CarbonWindowContentView.h:
        * Carbon/CarbonWindowContentView.m:
        * Carbon/CarbonWindowFrame.h:
        * Carbon/CarbonWindowFrame.m:
        * Carbon/HIViewAdapter.h:
        * Carbon/HIViewAdapter.m:
        * Carbon/HIWebView.h:
        * Carbon/HIWebView.m:

2007-08-20  John Sullivan  <sullivan@apple.com>

        Reviewed by Adam Roben
        
        WebKit part of fix for: 
        <rdar://problem/5417777> WebKit focus ring color no longer matches system focus rings

        * Misc/WebNSAttributedStringExtras.mm:
        now includes <WebCore/ColorMac.h> to account for moved declaration
        * WebView/WebFrame.mm:
        ditto
        
        * WebView/WebViewPrivate.h:
        * WebView/WebView.mm:
        (+[WebView _setUsesTestModeFocusRingColor:]):
        new SPI, calls through to new WebCore function. This is used by DumpRenderTree to make sure the
        focus ring color is always the same when performing layout tests, regardless of OS X version.
        (+[WebView _usesTestModeFocusRingColor]):
        new SPI, calls through to new WebCore function

2007-08-20  Antti Koivisto  <antti@apple.com>

        Reviewed by John.
        
        Fix <rdar://problem/5378390>
        Crash at Range::startContainer() when creating multiple ToDos on the same line
        
        Null check range.
        
        No layout test, this only happens with ObjC API.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _expandSelectionToGranularity:]):

2007-08-20  Maciej Stachowiak  <mjs@apple.com>

        Not reviewed, fix for crash on launch bug in last patch.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView setDataSource:]): Remove an assertion, fix code to work right in the
        face of that condition.

2007-08-18  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Darin.
        
        - fixed <rdar://problem/5198272> REGRESSION: PLT 1.5% slower due to r21367 (change to start frames with empty documents)

        There were three main cuases of extra time due to creating the initial empty document:
        
        1) Creating an extra WebHTMLView and swapping it for a new one for each frame created.
        2) Parsing the minimal markup for the initial document's contents.
        3) Clearing the Window object an extra time and dispatching the corresponding delegate method.
        
        The WebKit part of the fixes addresses 1.

        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::makeDocumentView): When switching from the initial
        empty document to the first real document, reuse the WebHTMLView.
        
        It might actually be a significant performance improvement to always
        reuse the WebHTMLView, but that is a much riskier change and not
        needed to fix the regression right now.

2007-08-17  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Darin.

        - WebKit part of fix to scrollbar suppression hack for Leopard

        * WebView/WebDynamicScrollBarsView.m:
        (-[WebDynamicScrollBarsView reflectScrolledClipView:]): Don't call the superclass method
        when scrollbars are suppressed.
        (-[WebDynamicScrollBarsView setScrollBarsSuppressed:repaintOnUnsuppress:]): Instead call it
        here, when unsuppressing.

2007-08-17  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

        - fix <rdar://problem/5414518> Use root URL as origin URL when quarantining downloads

        * WebCoreSupport/WebFrameLoaderClient.mm: (WebFrameLoaderClient::setOriginalURLForDownload):
        Extract only the scheme and host name and make the originating URL from that.

        * WebKit/StringsNotToBeLocalized.txt: Updated for recent changes.

2007-08-17  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Darin.

        <rdar://problem/5398301> Xcode threw mutation exception while enumerating subviews (GC only)

        I was never able to reproduce this exception. But there can be cases where layout will
        trigger JavaScript or plugin code that can modify the WebView view hierarchy during a
        recursive enumeration of all the subviews.

        This patch does two things:
        1) Adds a check in debug builds that will LOG when any view is added or removed during layout.
        Noting that added views will not recieve layout this round and might paint without first recieving layout.

        2) Recursivly builds up an array of descendant WebHTMLViews before calling layout on them.
        This matches the behavior of makeObjectsPerformSelector: in the non-GC case (making a copy
        before enumerating.)

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _web_setPrintingModeRecursive]): Use _web_addDescendantWebHTMLViewsToArray to build up an array
        of WebHTMLViews to enumerate.
        (-[WebHTMLView _web_clearPrintingModeRecursive]): Ditto.
        (-[WebHTMLView _web_setPrintingModeRecursiveAndAdjustViewSize]): Ditto.
        (-[WebHTMLView _web_layoutIfNeededRecursive]): Ditto.
        (-[WebHTMLView _layoutIfNeeded]): Moved to WebHTMLViewFileInternal category.
        (-[WebHTMLView didAddSubview:]): LOG in debug builds.
        (-[WebHTMLView willRemoveSubview:]): Ditto.
        (-[NSView _web_addDescendantWebHTMLViewsToArray:]): Recursivly build an array of descendant WebHTMLViews.
        * WebView/WebHTMLViewInternal.h: Added a BOOL in WebHTMLViewPrivate to track subview changes (debug only.)

2007-08-17  Anders Carlsson  <andersca@apple.com>

        Reviewed by Dave Hyatt.

        <rdar://problem/5379040> 
        REGRESSION (Tiger-Leopard): ADOBE: Safari calls NPP_SetWindow with bad values sometimes
        
        Pass the right size when creating the views.
        
        * WebCoreSupport/WebFrameBridge.mm:
        (-[WebFrameBridge viewForPluginWithFrame:URL:attributeNames:attributeValues:MIMEType:DOMElement:loadManually:]):
        * WebCoreSupport/WebFrameLoaderClient.h:
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::createPlugin):

2007-08-13  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Dave Hyatt.
        
        WebKit changes to support new cache eviction model in WebCore.

        * WebView/WebPreferences.m:
        (+[WebPreferences initialize]): Modified to reflect new API in WebCore.
        * WebView/WebView.mm:
        (+[WebView _initializeCacheSizesIfNecessary]): Slightly increased cache
        size on low memory systems to avoid affecting the PLT for now.

2007-08-15  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Darin.

        <rdar://problem/5410937> HIWebView in SimpleCarbonWeb doesn't seem to be getting adequate invalidation when window is resized

        HIWebViewCreate now just returns a HIViewRef created with HICocoaViewCreate. This eliminates lots of old code and
        makes HIWebView a better citizen starting with Leopard. The old code paths are still needed for Tiger, so now
        most of the files in the WebKit/Carbon directory are #ifdef BUILDING_ON_TIGER.

        The Tiger code is unchanged and dosen't exhibit the invalidation problem when the window resizes.

        * Carbon/CarbonUtils.m:
        (WebInitForCarbon): #ifdef BUILDING_ON_TIGER portions of this code that is not needed on Leopard.
        * Carbon/CarbonWindowAdapter.h: #ifdef BUILDING_ON_TIGER
        * Carbon/CarbonWindowAdapter.m: Ditto.
        * Carbon/CarbonWindowContentView.h: Ditto.
        * Carbon/CarbonWindowContentView.m: Ditto.
        * Carbon/CarbonWindowFrame.h: Ditto.
        * Carbon/CarbonWindowFrame.m: Ditto.
        * Carbon/HIViewAdapter.h: Ditto.
        * Carbon/HIViewAdapter.m: Ditto.
        * Carbon/HIWebView.h: Consolidate two #ifdef __OBJC__ blocks into one.
        * Carbon/HIWebView.m: Implement Leopard specific HIWebViewCreate, HIWebViewCreateWithClass and HIWebViewGetWebView.
        (HIWebViewCreate): Call HIWebViewCreateWithClass passing [WebView class].
        (HIWebViewCreateWithClass): Call HICocoaViewCreate with an instance of the class passed in.
        (HIWebViewGetWebView): Call HICocoaViewGetView.

2007-08-14  Brady Eidson  <beidson@apple.com>

        Reviewed by Darin, John, Maciej, Oliver, and Tim

        <rdar://problem/5394708> - Crash on launch with corrupt icon database

        Expose some new SPI to help recover from this case should it happen again

        * Misc/WebIconDatabase.mm:
        (-[WebIconDatabase init]): Use the new _databaseDirectory to determine where to open the database on disk
        (+[WebIconDatabase _checkIntegrityBeforeOpening]): Tell the icon database to check integrity when it opens
        (-[WebIconDatabase _databaseDirectory]): Moved the database-directory-determining logic here as it's now used in two places
        * Misc/WebIconDatabasePrivate.h: Added _checkIntegrityBeforeOpening SPI for clients to give hints about when the
          integrity check should run

2007-08-12  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin.

        http://bugs.webkit.org/show_bug.cgi?id=4648
        Shockwave unable to load GZip'd text resources when server sends Content-Length header

        * Plugins/WebBaseNetscapePluginStream.mm:
        (-[WebBaseNetscapePluginStream startStreamWithResponse:]): Don't trust 
        -[NSURLResponse expectedContentLength] if Content-Encoding is not identity.

2007-08-10  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Mark Rowe.

        <rdar://problem/5403302> HIWebView.h should be #ifdefed out for 64-bit

        * Carbon/HIWebView.h: #ifdef out the header in 64-bit. Adds a comment about 32-bit only.
        * Carbon/CarbonUtils.h: Ditto.

2007-08-10  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Adam.

        <rdar://problem/5394449> Stop using some Carbon UI APIs for 64 bit

        Disable NPObject use in 64-bit on Mac OS X. Also generate the 64-bit export file.

        * Configurations/WebKit.xcconfig: Point to the generated 64-bit export file.
        * Plugins/WebBasePluginPackage.h:
        * Plugins/npfunctions.h: #ifdef out this header in 64-bit on Mac OS X.
        * WebKit.LP64.exp: Removed.
        * WebKit.xcodeproj/project.pbxproj: Generate the the 64-bit export file.
        * WebKitPrefix.h: Define WTF_USE_NPOBJECT.

2007-08-10  Anders Carlsson  <andersca@apple.com>

        Reviewed by Geoff.

        <rdar://problem/5390568>
        REGRESSION: -[WebFrame loadHTMLString:baseURL:] leaks the data source
        
        If the identifier is not in the map, just bail out instead of asserting. This is a better fix for
        <rdar://problem/5133420> because WebCore shouldn't have to worry about the lifetime of WebKit objects.
        
        * WebView/WebDocumentLoaderMac.mm:
        (WebDocumentLoaderMac::decreaseLoadCount):

2007-08-10  Oliver Hunt  <oliver@apple.com>

        Reviewed by Darin.

        Fixed <rdar://problem/5000470> REGRESSION: ATOK IM: reconvert returns incorrect symbol due to inconsistent range domains in TSM by working around <rdar://problem/5400551> [NSAttributedString(WebKitExtras) _web_attributedStringFromRange:] adds whitespace to the requested range

        We truncate the returned string to the expected length.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView attributedSubstringFromRange:]):

2007-08-09  Mark Rowe  <mrowe@apple.com>

        Reviewed by Antti.

        <rdar://problem/5400709> Versioning in debug and release builds should include minor and tiny version before +

        * Configurations/Version.xcconfig:
        * WebKit.xcodeproj/project.pbxproj: Add a shell script phase to make to dependency between
        Version.xcconfig and Info.plist explicit to Xcode.

2007-08-08  Kevin Decker <kdecker@apple.com>

        Reviewed by Anders Carlsson.

        Fixed: <rdar://problem/5394449> Stop using some Carbon UI APIs for 64 bit
        
        #ifdef'd out Netscape style plug-ins on 64-bit because Mac OS X doesn't support 64-bit Carbon UI.
        
        * Plugins/WebBaseNetscapePluginStream.h:
        * Plugins/WebBaseNetscapePluginStream.mm:
        * Plugins/WebBaseNetscapePluginView.h:
        * Plugins/WebBaseNetscapePluginView.mm:
        (+[WebBaseNetscapePluginView getCarbonEvent:]):
        (TSMEventHandler):
        * Plugins/WebBaseNetscapePluginViewInternal.h:
        * Plugins/WebBaseNetscapePluginViewPrivate.h:
        * Plugins/WebBasePluginPackage.m:
        (+[WebBasePluginPackage pluginWithPath:]):
        * Plugins/WebNetscapePluginEmbeddedView.h:
        * Plugins/WebNetscapePluginEmbeddedView.mm:
        * Plugins/WebNetscapePluginPackage.h:
        * Plugins/WebNetscapePluginPackage.m:
        * Plugins/WebNetscapePluginStream.h:
        * Plugins/WebNetscapePluginStream.mm:
        * Plugins/WebPluginDatabase.m:
        (-[WebPluginDatabase pluginForKey:withEnumeratorSelector:]):
        * Plugins/npapi.m:
        * WebCoreSupport/WebFrameBridge.mm:
        (-[WebFrameBridge viewForPluginWithURL:attributeNames:attributeValues:MIMEType:DOMElement:loadManually:]):
        * WebView/WebFrame.mm:
        * WebView/WebFramePrivate.h:
        * WebView/WebHTMLView.mm:
        (-[NSArray _web_makePluginViewsPerformSelector:withObject:]):
        * WebView/WebHTMLViewInternal.h:

2007-08-07  David Hyatt  <hyatt@apple.com>

        Fix a botched backout of the Quicktime plugin clipping fix that broke Java.  The plugin view should not
        be set to autosize with the parent view.  Also, cleanup of script objects was removed accidentally as
        well.

        Reviewed by olliej

        * Plugins/WebPluginController.mm:
        (-[WebPluginController destroyPlugin:]):
        (-[WebPluginController destroyAllPlugins]):
        * WebCoreSupport/WebFrameBridge.mm:
        (-[WebFrameBridge pluginViewWithPackage:attributeNames:attributeValues:baseURL:DOMElement:loadManually:]):

2007-08-03  Brady Eidson  <beidson@apple.com>

        Reviewed by Oliver

        Fix for http://bugs.webkit.org/show_bug.cgi?id=14824 and <rdar://problem/5372989>

        When unregistering a MIMEType, remove it from the WebCore registry unconditionally
        When registrying a MIMEType whose view class is WebHTMLView, add it to the WebCore registry

        * WebView/WebView.mm:
        (+[WebView _unregisterViewClassAndRepresentationClassForMIMEType:]): 
        (+[WebView _registerViewClass:representationClass:forURLScheme:]):
        (+[WebView registerViewClass:representationClass:forMIMEType:]):

2007-08-03  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Mark Rowe.

        Correct the bundle version check to work in Debug and Release builds too.

        * WebKit.xcodeproj/project.pbxproj:

2007-08-02  Brady Eidson  <beidson@apple.com>

        Reviewed by Tim

        <rdar://problem/5381463> - setMIMETypesShownAsHTML mutates while enumerating

        * WebView/WebView.mm:
        (+[WebView setMIMETypesShownAsHTML:]): Copy the dictionary before we work with it.

2007-08-02  Alice Liu  <alice.liu@apple.com>

        Reviewed by Kevin McCullough.

        fixed <rdar://problem/5310312> REGRESSION: javascript is mis-escaped at http://labs.zarate.org/passwd causing bookmarklet to break

        * Misc/WebNSURLExtras.mm:
        (+[NSURL _web_URLWithUserTypedString:relativeToURL:]):
        (-[NSURL _web_userVisibleString]):
        (-[NSURL _web_URLWithLowercasedScheme]):
        (-[NSURL _web_dataForURLComponentType:]):
        These 4 changes are just casting changes.

        (-[NSString _webkit_stringByReplacingValidPercentEscapes]):
        This change replaces the call to an NSURL method with a webcore one that doesn't abort the escaping effort once an illegal character is encountered. 

2007-08-01  Anders Carlsson  <andersca@apple.com>

        Fix build.
        
        * Misc/WebNSURLExtras.mm:
        (+[NSURL _web_URLWithUserTypedString:relativeToURL:]):
        (-[NSURL _web_userVisibleString]):
        (-[NSURL _web_URLWithLowercasedScheme]):
        (-[NSURL _web_dataForURLComponentType:]):

2007-08-01  Alice Liu  <alice.liu@apple.com>

        Reviewed by .

        Making WebNSURLExtras objc++

        * Misc/WebNSURLExtras.m: Removed.
        * Misc/WebNSURLExtras.mm: Copied from WebKit/Misc/WebNSURLExtras.m.
        * WebKit.xcodeproj/project.pbxproj:

2007-08-01  Darin Adler  <darin@apple.com>

        Reviewed by Anders Carlsson and Kevin Decker.

        - fix <rdar://problem/5377432> Removal of MakeDataExecutable from 64-bit breaks WebKit build

        The trick was to ifdef out more of the code that's only needed to support CFM, which exists
        only for 32-bit PowerPC.

        * Plugins/WebNetscapePluginPackage.h: Define a SUPPORT_CFM symbol in this internal header when
        we support CFM. We support it only on 32-bit PowerPC. Only define the isBundle, isCFM, and
        connID fields when SUPPORT_CFM is on. Also use ResFileRefNum instead of SInt16.
        * Plugins/WebNetscapePluginPackage.m: Only compile the function pointer and transition vector
        functions when SUPPORT_CFM is on.
        (-[WebNetscapePluginPackage openResourceFile]): Put the non-bundle case inside a SUPPORT_CFM
        ifdef, since all non-CFM plug-ins are bundles.
        (-[WebNetscapePluginPackage closeResourceFile:]): Ditto.
        (-[WebNetscapePluginPackage _initWithPath:]): Use SUPPORT_CFM to compile out the code for
        non-bundle and bundle-based CFM plug-ins, and code that sets isBundle and isCFM.
        (-[WebNetscapePluginPackage executableType]): Put the CFM case inside SUPPORT_CFM.
        (-[WebNetscapePluginPackage load]): Put the non-bundle and CFM cases inside SUPPORT_CFM.
        There was a bit of dead code here.
        (-[WebNetscapePluginPackage _unloadWithShutdown:]): Put the non-bundle case inside
        SUPPORT_CFM.

2007-07-31  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Oliver and Beth.

        <rdar://problem/5211271> ADOBE Leopard 9A410: At the first Launching InDesign after deactivate, EULA page gets blanked.

        Check for more Adobe applications that need the frame reload quirk. Also cache the answer
        so the version check dosen't happen more than once.

        * WebView/WebView.mm:
        (-[WebView _needsAdobeFrameReloadingQuirk]):
        (-[WebView _updateWebCoreSettingsFromPreferences:]):

2007-07-30  Adele Peterson  <adele@apple.com>

        Reviewed by Oliver.

        Fix for <rdar://problem/5308020> REGRESSION: Command-N with Dvorak-Qwerty keyboard layout stopped working inside web page text fields

        * WebView/WebHTMLView.mm: (-[WebHTMLView _handleStyleKeyEquivalent:]):
        The input method may have modified the character we get, so don't use charactersIgnoringModifiers to interpret the character we get.

2007-07-30  John Sullivan  <sullivan@apple.com>

        Reviewed by Darin
        
        - fixed <rdar://problem/5216176> Need WebKit SPI to allow clients using embedded WebViews to avoid 
          clipping ends of some printed pages
          
        This provides Mail, and other clients that print views that embed WebViews, a way to ensure that
        the HTML is laid out for printing before pagination occurs.

        * WebView/WebHTMLViewPrivate.h:
        new SPI method -_layoutForPrinting
        
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _web_setPrintingModeRecursiveAndAdjustViewSize]):
        new method, just like existing _web_setPrintingModeRecursive except passes YES for adjustViewSize
        (-[WebHTMLView _layoutForPrinting]):
        new SPI method, sets printing mode temporarily to adjust the view size for printing 
        (-[NSView _web_setPrintingModeRecursiveAndAdjustViewSize]):
        new helper method to do the recursion

2007-07-30  Adele Peterson  <adele@apple.com>

        Reviewed by Darin.

        Fix for <rdar://problem/5367919> A crash occurs at WebCore::Frame::isFrameSet() when attempting to print a iframe before it loads at http://www.monster.com/

        * WebView/WebHTMLView.mm: (-[WebHTMLView knowsPageRange:]): Nil check for frame.

2007-07-30  Anders Carlsson  <andersca@apple.com>

        Reviewed by Darin.

        <rdar://problem/5370710> 
        REGRESSION: After switching from Bookmark view, the Find Banner won't appear while displaying a PDF file

        Implement hasHTMLView.
        
        * WebCoreSupport/WebFrameLoaderClient.h:
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::hasHTMLView):

2007-07-30  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by Tristan.
        
        <rdar://problem/5098931> Attachments are lost when they are moved into a ToDo after a delete
        
        Mail needs to be asked if it is OK to do the content movement that happens 
        after a deleting in a situation like this one: 
        <div contenteditable="plaintext-only">foo</div><div>^bar</div> 
        so that they can prevent the move or so that they can save content that 
        will be stripped by the move. This could have been done with shouldInsertNode 
        and a new WebViewInsertAction for "moves", but WebKit clients like Mail and 
        DashCode think that a shouldInsert* means that the user pasted something and
        perform actions only appropriate for pastes.  This change is less risky because
        it won't require those clients to change their code.

        * DefaultDelegates/WebDefaultEditingDelegate.m:
        (-[WebDefaultEditingDelegate webView:shouldMoveRangeAfterDelete:replacingRange:]):
        * WebCoreSupport/WebEditorClient.h:
        * WebCoreSupport/WebEditorClient.mm:
        (WebEditorClient::shouldMoveRangeAfterDelete):
        * WebView/WebEditingDelegatePrivate.h:

2007-07-29  Adele Peterson  <adele@apple.com>

        Reviewed by John.

        WebKit part of fix for <rdar://problem/5102522> REGRESSION: Can't tab to webview that doesn't have editable content

        * WebView/WebHTMLView.mm: (-[WebHTMLView becomeFirstResponder]): Call new setInitialFocus method instead of advanceFocus.

2007-07-27  Darin Adler  <darin@apple.com>

        - fix build

        * WebKitPrefix.h: Removed the USING_WEBCORE_XXX definitions.
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView delete:]): Fixed this to use WebCore again; I accidentally revived a dead
        code path that didn't work in the last patch!
        (-[WebHTMLView deleteToMark:]): Ditto.
        (-[WebHTMLView copy:]): Removed the unused side of the ifdef.
        (-[WebHTMLView cut:]): Ditto.
        (-[WebHTMLView paste:]): Ditto.

2007-07-27  Darin Adler  <darin@apple.com>

        Reviewed by Tim Hatcher and Oliver Hunt.

        - fix <rdar://problem/5355815> webView:doCommandBySelector: isn't getting called for copy:

        Added code so that webView:doCommandBySelector: is called for every command.

        * WebView/WebHTMLView.mm: Made 44 of the commands use the WEBCORE_COMMAND macro instead
        of being handwritten. For all the others, added invocation of COMMAND_PROLOGUE macro at
        the start of the command.
        (-[WebHTMLView callDelegateDoCommandBySelectorIfNeeded:]): Added.
        (-[WebHTMLView callWebCoreCommand:]): Added.
        (-[WebHTMLView delete:]): Removed unused code path -- easy to bring back some day, but
        we don't need it compiled in.
        (-[WebHTMLView deleteBackwardByDecomposingPreviousCharacter:]): Changed so this doesn't
        call deleteBackward: any more so we don't call the delegate two times.
        (-[WebHTMLView deleteToMark:]): Changed so this doesn't call delete: any more so we don't
        call the delegate two times.
        (-[WebHTMLView selectToMark:]): Changed so this doesn't call setMark: any more so we don't
        call the delegate two times.
        (-[WebHTMLView doCommandBySelector:]): Added code to set the private variable
        selectorForDoCommandBySelector. This allows callDelegateDoCommandBySelectorIfNeeded to
        detect that we've already called the delegate and avoids calling it twice.

        * WebView/WebHTMLViewInternal.h: Added the selectorForDoCommandBySelector field.

2007-07-26  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Oliver.

        http://bugs.webkit.org/show_bug.cgi?id=14733
        Add a logging channel for text input
        <rdar://problem/5364667>

        * Misc/WebKitLogging.h:
        * Misc/WebKitLogging.m:
        (WebKitInitializeLoggingChannelsIfNecessary):
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView validAttributesForMarkedText]):
        (-[WebHTMLView textStorage]):
        (-[WebHTMLView characterIndexForPoint:]):
        (-[WebHTMLView firstRectForCharacterRange:]):
        (-[WebHTMLView selectedRange]):
        (-[WebHTMLView markedRange]):
        (-[WebHTMLView attributedSubstringFromRange:]):
        (-[WebHTMLView hasMarkedText]):
        (-[WebHTMLView unmarkText]):
        (-[WebHTMLView setMarkedText:selectedRange:]):
        (-[WebHTMLView doCommandBySelector:]):
        (-[WebHTMLView insertText:]):

2007-07-26  Darin Adler  <darin@apple.com>

        - fix Tiger build

        * Misc/WebTypesInternal.h: For use inside the library, use NSInteger and
        NSUInteger, just like on Leopard. WebNSInteger and WebNSUInteger are still
        present, but they are used in public and private headers only.

        * Carbon/CarbonWindowAdapter.m:
        * Carbon/CarbonWindowFrame.m:
        * DefaultDelegates/WebScriptDebugServer.m:
        * History/WebBackForwardList.mm:
        * Misc/WebDownload.m:
        * Misc/WebSearchableTextView.m:
        * Plugins/WebBaseNetscapePluginView.mm:
        * WebCoreSupport/WebFrameLoaderClient.mm:
        * WebView/WebHTMLView.mm:
        * WebView/WebPDFView.mm:
        * WebView/WebView.mm:
        * WebView/WebViewInternal.h:
        Update all implementation files and internal headers to use NSInteger and
        NSUInteger rather than WebNSInteger and WebNSUInteger.

2007-07-26  John Sullivan  <sullivan@apple.com>

        Reviewed by Kevin Decker
        
        - fixed <rdar://problem/5362989> Searching a pdf in some modes shows hilights for all instances 
          of the word, even those not on the current page
          
        It turns out that there were three different issues here, all contributing to incorrect display
        of multiple matches for PDF pages in certain display modes. (1) in non-continuous display modes,
        we weren't updating the match rects when the displayed page is changed with page up/down (e.g.);
        (2) the mechanism to update the match rects on scrolling was busted except for the first scroll
        away from 0,0; (3) the PDFKit API returns selection bounds for non-displayed pages in non-continuous
        modes just as if they were the displayed pages. This patch fixes all three issues.

        * WebView/WebPDFView.h:
        made ivar name even longer
        
        * WebView/WebPDFView.mm:
        (-[WebPDFView setPDFDocument:]):
        updated for ivar name change
        (-[WebPDFView viewDidMoveToWindow]):
        observe page-change notifications as well as the others; this is necessary because in the
        non-continuous modes the view can be completely updated without any scrolling involved (problem 1)
        (-[WebPDFView viewWillMoveToWindow:]):
        stop observing page-change notifications
        (-[WebPDFView rectsForTextMatches]):
        skip any pages that aren't visible; this avoids treating matches on non-displayed non-continous
        modes as if they were on the displayed page (problem 3)
        (-[WebPDFView _PDFDocumentViewMightHaveScrolled:]):
        after checking whether scroll position has changed since we last checked it, remember the new
        one (d'oh!) (problem 2)

        (-[WebPDFView _scaleOrDisplayModeOrPageChanged:]):
        renamed to include page changes
        
        (-[WebPDFView _visiblePDFPages]):
        new method, returns the set of pages that are at least partly visible

2007-07-24  Oliver Hunt  <oliver@apple.com>

        Reviewed by Adam and Justin.

        <rdar://problem/5141779> WebView editableDOMRangeForPoint: & moveDragCaretToPoint: returns last position in DOMText range

        editableDOMRangeForPoint:, moveDragCaretToPoint:, and removeDragCaret now call directly into
        WebCore without relying on bridge look up through the now removed _bridgeAtPoint:.

        * WebKit.xcodeproj/project.pbxproj:
        * WebView/WebView.mm:
        (-[WebView moveDragCaretToPoint:]):
        (-[WebView removeDragCaret]):
        (-[WebView editableDOMRangeForPoint:]):

2007-07-24  Kevin Decker  <kdecker@apple.com>

        Reviewed by Anders.

        <rdar://problem/4699455> REGRESSION (Safari 2->Safari 3): Adobe Reader 7.0.8 plug-in doesn't work
        
        * Plugins/WebNetscapePluginEmbeddedView.h: Added a #define that renames this class to "WebNetscapePluginDocumentView"
        This is necessary because the Adobe 7.x Acrobat plug-in has a hard coded check for a view named "WebNetscapePluginDocumentView"
        and will not function correctly if it doesn't find a view in the hierarchy without the old class name.

2007-07-24  Mark Rowe  <mrowe@apple.com>

        Reviewed by Antti.

        <rdar://problem/5356666> NSMenuItem's seen leaking on buildbot

        * WebCoreSupport/WebContextMenuClient.mm:
        (WebContextMenuClient::contextMenuItemSelected): Release platformItem as we were transferred its ownership by releasePlatformDescription.

2007-07-23  Oliver Hunt  <oliver@apple.com>

        Reviewed by Darin.

        We have to be able to support insertText: followed by doCommandBySelector: in 
        order to support the 2- and 3-Set Korean and RuSwitcher IMs at least.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView insertText:]):

2007-07-23  Alice Liu  <alice.liu@apple.com>

        Reverting change 24535 now that a solution has been found that doesn't 
        involve exposing an interface unnecessarily.

        * WebView/WebHTMLView.mm:
        * WebView/WebHTMLViewPrivate.h:

2007-07-23  Alice Liu  <alice.liu@apple.com>

        Reviewed by Oliver Hunt.

        Expose [WebHTMLView hasMarkedText] to 
        fix <rdar://problem/4830074> autocomplete breaks Japanese typing

        * WebView/WebHTMLView.mm:
        * WebView/WebHTMLViewPrivate.h:

2007-07-22  Darin Adler  <darin@apple.com>

        * StringsNotToBeLocalized.txt: Updated for recent changes.

2007-07-21  Adam Roben  <aroben@apple.com>

        Fix REGRESSION: Right-click/control-click broken

        http://bugs.webkit.org/show_bug.cgi?id=14658
        <rdar://problem/5346830>

        Reviewed by Mitz.

        * WebCoreSupport/WebContextMenuClient.mm:
        (fixMenusToSendToOldClients): Update defaultItemsCount after removing
        items from the defaultItems array.

2007-07-20  Oliver Hunt  <oliver@apple.com>

        Reviewed by Adele.

        <rdar://problem/5319438> REGRESSION: Cannot paste into an active inline input area (14522)
        http://bugs.webkit.org/show_bug.cgi?id=14522

        AppKit sends noop: to -[WebHTMLView doCommandBySelector:] when an IM does not handle event,
        we now check this as it is necessary to work around some IMs that do send messages 
        (such as insertText: rather than unmarkText: to confirm a composition)

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _interceptEditingKeyEvent:shouldSaveCommand:]):
        (-[WebHTMLView doCommandBySelector:]):
        * WebView/WebHTMLViewInternal.h:

2007-07-20  Brady Eidson  <beidson@apple.com>

        Reviewed by Adele and Andersca

        <rdar://problem/5336105> - WebBackForwardList created from scratch is unusable (always leads to crash)

        * History/WebBackForwardList.mm:
        (-[WebBackForwardList init]): Have a default initializer that uses an empty BackFowardList not associated with a page.

        * WebView/WebFrame.mm:
        (kit): For clarity's sake, this should return nil, not 0

2007-07-20  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by Darin.
        
        <rdar://problem/5109817> Ctrl-click on word in non-editable text doesn't select it

        * WebCoreSupport/WebEditorClient.h:
        * WebCoreSupport/WebEditorClient.mm: Removed the method
        for enabling/disabling word selection on right click.
        * WebView/WebView.mm: Ditto.
        * WebView/WebViewPrivate.h: Removed the getter/setter entirely, 
        it was in a private Category for Mail, but wasn't used by Mail
        on Tiger or Leopard, they apparently implement word selection on 
        their own.

2007-07-20  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Darin.

        <rdar://problem/5199812> WebView needs to adopt viewWillDraw (moving off of _propagateDirtyRectsToOpaqueAncestors)
        <rdar://problem/5017301> REGRESSION: Scroller in Widget Manager splits down the middle while scrolling

        On Leopard _propagateDirtyRectsToOpaqueAncestors is no longer called by AppKit. Also marking new dirty rects
        underneath _recursiveDisplayRectIfNeededIgnoringOpacity will wait until the next runloop to draw them,
        causing rendering to happen in two steps instead of one as WebCore expected.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _topHTMLView]): Move to the file internal category so we can use it in viewWillDraw.
        (-[WebHTMLView _isTopHTMLView]): Ditto.
        (-[WebHTMLView _propagateDirtyRectsToOpaqueAncestors]): #ifdef for Tiger only.
        (-[WebHTMLView viewWillDraw]): Do a recursive layout if this is the top WebHTMLView.
        (-[WebHTMLView _recursiveDisplayRectIfNeededIgnoringOpacity:isVisibleRect:rectIsVisibleRectForView:topView:]):
          Don't do layout here on Leopard since viewWillDraw handled it.
        (-[WebHTMLView _recursiveDisplayAllDirtyWithLockFocus:visRect:]): Ditto.

2007-07-20  Beth Dakin  <bdakin@apple.com>

        Reviewed by Tim and Geoff.

        Fix for <rdar://problem/5346855> Mail crashes at 
        WebCore::RenderTableSection:paint + 846 when attempting to display 
        a HTML based message

        After reapplying styles, the RenderView needs layout. However, 
        layoutToMinimumPageWidth:maximumPageWidth:adjustingViewSize used to 
        return early if the WebHTMLView itself does not need layout. 
        Because the WebHTMLView is not necessarily in synch with the 
        RenderTree, returning early here can get us into a bad situation 
        where we paint before laying out the Render Tree. This patch checks 
        both the WebHTMLView and the bridge (which checks the RenderView, 
        etc), so that we do not return early without laying out the Render 
        Tree. 

        Some day, we should phase out WebHTMLView keeping track of 
        needsLayout at all. But that is a bit beyond the scope of this fix.  

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView layoutToMinimumPageWidth:maximumPageWidth:adjustingViewSize:]):

2007-07-20  John Sullivan  <sullivan@apple.com>

        Reviewed by Darin Adler and David Harrison
        
        - fixed <rdar://problem/5307075> REGRESSION: Bottom of some printed pages are truncated
        
        The "avoid orphan" code I added a year ago was causing the page to be imaged to a larger 
        height (good), but not shrinking everything to compensate (bad). Bad one-year-ago me!

        * WebView/WebHTMLViewInternal.h:
        added avoidingPrintOrphan boolean

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _setPrinting:minimumPageWidth:maximumPageWidth:adjustViewSize:]):
        clear _private->avoidingPrintOrphan when clearing _private->printing
        (-[WebHTMLView _scaleFactorForPrintOperation:]):
        take _private->avoidingPrintOrphan into account when computing the scale factor
        (-[WebHTMLView knowsPageRange:]):
        set _private->avoidingPrintOrphan when we're shrinking to avoid an orphan

2007-07-19  Adam Roben  <aroben@apple.com>

        Fix <rdar://problem/5344972> REGRESSION: A error dialog occurs when
        attempting to ctrl-click in a iChat message window (webview)

        Reviewed by Oliver.

        * WebCoreSupport/WebContextMenuClient.mm:
        (fixMenusToSendToOldClients): Don't check for the Inspect Element item
        if we have fewer than 2 items.

2007-07-18  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Dave Hyatt.
        
        <rdar://problem/5345099>
        
        Reduced default WebCore cache size from 32 MB to 23 MB on systems below 
        512 MB RAM. This improves RPRVT usage in the Safari pageout test by 
        ~10% on a system with 384 MB RAM.
        
        At 23 MB, no extra resources are evicted from the cache during a PLT 
        run, so this is a safe change PLT-wise. 23 MB is also seems to be a
        generous number in real world usage.

        * WebView/WebPreferences.m:
        (+[WebPreferences initialize]):

2007-07-18  Anders Carlsson  <andersca@apple.com>

        Reviewed by Geoff.

        <rdar://problem/5341133> REGRESSION (Safari 2->Safari 3): DjVu plug-in doesn't load in Safari 3
        
        The DjVu plug-in uses the size of the passed in NPNetscapeFuncs struct to copy it over to a NPNetscapeFuncs struct
        whose size was determined when DjVu was compiled. This means that when we add extra functions to the vtable, 
        DjVu will segfault copying it into the (too small) destination struct.
        
        Fix this by special-casing the DjVu plug-in and setting the NPNetscapeFuncs size to be the same size as what DjVu expects.
        
        * Plugins/WebNetscapePluginPackage.m:
        (-[WebNetscapePluginPackage _applyDjVuWorkaround]):
        (-[WebNetscapePluginPackage load]):

2007-07-18  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Adam.

        <rdar://problem/5343767> Should have a way to disable the Web Inspector

        Adds a new DisableWebKitDeveloperExtras default that will force the Web Inspector to be disabled.
        This overrides the WebKitDeveloperExtras and IncludeDebugMenu default. It also disables
        the Web Inspector in Debug builds.

        * WebView/WebView.mm:
        (+[WebView _developerExtrasEnabled]): Check for the DisableWebKitDeveloperExtras default.
        (-[WebView _commonInitializationWithFrameName:groupName:]): Make a new WebInspectorClient when making the Page.

2007-07-18  Anders Carlsson  <andersca@apple.com>

        Build fix.
        
        * Misc/WebNSAttributedStringExtras.mm:

2007-07-18  Sam Weinig  <sam@webkit.org>

        Rubber-stamped by Adam Roben.

        Update after renaming MimeTypeRegistry to MIMETypeRegistry.

        * Misc/WebNSPasteboardExtras.mm:
        (-[NSPasteboard _web_writePromisedRTFDFromArchive:containsImage:]):
        * WebCoreSupport/WebFrameBridge.mm:
        (-[WebFrameBridge determineObjectFromMIMEType:URL:]):
        * WebView/WebDataSource.mm:
        (-[WebDataSource _documentFragmentWithArchive:]):
        * WebView/WebHTMLRepresentation.mm:
        (+[WebHTMLRepresentation supportedNonImageMIMETypes]):
        (+[WebHTMLRepresentation supportedImageMIMETypes]):
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _imageExistsAtPaths:]):

2007-07-18  Tristan O'Tierney  <tristan@apple.com>

        Reviewed by Maciej Stachowiak.
        
        <rdar://problem/5341334> Alt-clicking a link in Safari does not register original URL info with gatekeeper
        <rdar://problem/5342570> REGRESSION: A hang occurs when attempting to open a attached file from a .Mac web mail message

        * WebCoreSupport/WebFrameLoaderClient.h:
        Added a new method, setOriginalURLForDownload, for both download() 
        and startDownload() to share.
        
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::download):
        Moved all the gatekeeper code into setOriginalURLForDownload.
        
        (WebFrameLoaderClient::setOriginalURLForDownload):
        Same code that was in download() but moved into a single place for both
        startDownload and download to use.  Also returned the boolean logic
        for detecting _wasUserGesture back to it's previous state, since my prior change
        was incorrect.  Additionally I found a loop index bug with backListCount and fixed it.
        
        (WebFrameLoaderClient::startDownload):
        Calls out to setOriginalURLForDownload after a download is created.
        
        * WebView/WebView.mm:
        (-[WebView _downloadURL:]):
        Changed to return the WebDownload object created inside _downloadURL
        
        * WebView/WebViewInternal.h:
        Changed _downloadURL to return the WebDownload it creates.

2007-07-17  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Geoff.

        <rdar://problem/5336267> loadData:MIMEType:textEncodingName:baseURL: doesn't like relative URLs

        Get the absoluteURL from any user supplied NSURL before we pass it down to WebCore.

        * WebView/WebFrame.mm:
        (-[WebFrame _loadURL:referrer:intoChild:]):
        (-[WebFrame _loadData:MIMEType:textEncodingName:baseURL:unreachableURL:]):
        * WebView/WebView.mm:
        (-[WebView userAgentForURL:]):

2007-07-17  Adam Roben  <aroben@apple.com>

        Fix Bug 14324: Cannot remove/customize the "Inspect Element" contextual menu item
        http://bugs.webkit.org/show_bug.cgi?id=14324

        Only clients linking against new versions of WebKit will see the item.
        I've maintained our behavior for old clients of not including the
        Inspect Element item in the menu items passed to the UI delegate.

        Reviewed by Tim.

        * Misc/WebKitVersionChecks.h: Added a new constant.
        * WebCoreSupport/WebContextMenuClient.mm:
        (isPreInspectElementTagClient): Added.
        (fixMenusToSendToOldClients): Return an array of items that should be
        appended to the menu received from the delegate.
        (fixMenusReceivedFromOldClients): Append the saved items to the array.
        (WebContextMenuClient::getCustomMenuFromDefaultItems): Retain/release
        the saved items.

2007-07-17  Adam Roben  <aroben@apple.com>

        Remove WebContextMenuClient::shouldIncludeInspectElementItem

        Reviewed by Tim.

        * WebCoreSupport/WebContextMenuClient.h:
        * WebCoreSupport/WebContextMenuClient.mm:

2007-07-17  Adam Roben  <aroben@apple.com>

        Initialize Settings::developerExtrasEnabled

        Reviewed by Tim.

        * WebView/WebView.mm:
        (-[WebView _updateWebCoreSettingsFromPreferences:]):

2007-07-17  Geoffrey Garen  <ggaren@apple.com>

        Build fix.

        * WebView/WebFrame.mm:
        (-[WebFrame _loadURL:referrer:intoChild:]):
        * WebView/WebFramePrivate.h:

2007-07-17  Tristan O'Tierney  <tristan@apple.com>

        Reviewed by Maciej Stachowiak.

        <rdar://problem/5294691> Source of file is misrepresented if downloaded by typing in URL in Safari address bar

        * WebCoreSupport/WebFrameLoaderClient.h:
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::download):
        Revised code to check the initial request's referrer before assuming it has a history to check.

2007-07-16  Brady Eidson  <beidson@apple.com>

        Reviewed by Adam

        Begin the arduous task of localizing FTP directory listings while removing a global initializer!

        * English.lproj/Localizable.strings:
        * WebCoreSupport/WebViewFactory.mm:
        (-[WebViewFactory unknownFileSizeText]):

2007-07-16  Adam Roben  <aroben@apple.com>

        Move printing from WebFrameBridge to WebChromeClient

        Reviewed by Darin.

        * WebCoreSupport/WebChromeClient.h: Updated for ChromeClient changes.
        * WebCoreSupport/WebChromeClient.mm:
        (WebChromeClient::print): Moved code from WebFrameBridge.
        * WebCoreSupport/WebFrameBridge.mm: Removed -print.

2007-07-16  Darin Adler  <darin@apple.com>

        * StringsNotToBeLocalized.txt: Update for recent changes.

2007-07-16  John Sullivan  <sullivan@apple.com>

        Reviewed by Kevin Decker and Darin Adler
        
        - fixed <rdar://problem/5337529> Holes in Find banner overlay on PDF pages are left in wrong place after changing scale

        * WebView/WebPDFView.mm:
        (-[WebPDFView _scaleOrDisplayModeChanged:]):
        tell UI delegate that the entire PDF view has been redrawn

2007-07-14  Brady Eidson  <beidson@apple.com>

        Reviewed by Sam Weinig

        Initial check-in for <rdar://problem/3154486> - Supporting FTP directory listings in the browser

        * WebView/WebPreferenceKeysPrivate.h: Added preference keys for the FTP template location, as well as to force 
          FTP directory listings, bypassing the policy delegate.  This is necessary to test the new feature until browser
          policy delegate support is added.

        * WebView/WebPreferences.m:
        (-[WebPreferences _setFTPDirectoryTemplatePath:]):
        (-[WebPreferences _ftpDirectoryTemplatePath]):
        (-[WebPreferences _setForceFTPDirectoryListings:]):
        (-[WebPreferences _forceFTPDirectoryListings]):
        * WebView/WebPreferencesPrivate.h:
        * WebView/WebView.mm:
        (-[WebView _updateWebCoreSettingsFromPreferences:]):

2007-07-13  Anders Carlsson  <andersca@apple.com>

        Reviewed by Maciej.

        <rdar://problem/5290103> Assert failure when loading page with multipart resource
        
        Don't try to call the delegate method if the resource object doesn't exist in the 
        identifier map. When a multipart resource has finished loading one part, it is removed from the
        web view identifier map. 
        
        This is not an ideal fix, a better fix would be to special-case multipart resources and not remove
        them when the first part has finished loading. I've filed <rdar://problem/5335034> to track doing that.
        
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::dispatchDidReceiveAuthenticationChallenge):
        (WebFrameLoaderClient::dispatchDidCancelAuthenticationChallenge):
        (WebFrameLoaderClient::dispatchDidReceiveResponse):
        (WebFrameLoaderClient::willCacheResponse):
        (WebFrameLoaderClient::dispatchDidReceiveContentLength):
        (WebFrameLoaderClient::dispatchDidFinishLoading):
        (WebFrameLoaderClient::dispatchDidFailLoading):

2007-07-13  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Oliver Hunt.

        <rdar://problem/5333766> Can't include WebEditingDelegatePrivate.h

        * WebView/WebEditingDelegatePrivate.h: Changed the include to be a framework include,
        so other projects can use this header.

2007-07-12  Anders Carlsson  <andersca@apple.com>

        Reviewed by Darin and Maciej.

        <rdar://problem/5271096> panic after Safari stress test, caused by port leak

        Replace uses of -[NSObject performSelector:withObject:afterDelay:] with CFRunLoopTimer. performSelector
        causes the target (the WebHTMLView in this case) to be retained until the timer fires. Furthermore, when
        running the PLT or iBench, the timers will not fire until the main loop is entered (usually after running all tests).
        
        This means that the timers and ports will not be released until after the test has finished running.
        
        * WebView/WebHTMLView.mm:
        (-[WebHTMLViewPrivate dealloc]):
        (-[WebHTMLView _cancelUpdateMouseoverTimer]):
        (-[WebHTMLView _updateMouseoverWithFakeEvent]):
        (-[WebHTMLView _updateMouseoverTimerCallback:]):
        (-[WebHTMLView _frameOrBoundsChanged]):
        (-[WebHTMLView _updateActiveState]):
        (-[WebHTMLView _updateActiveStateTimerCallback:]):
        (-[WebHTMLView viewWillMoveToWindow:]):
        (-[WebHTMLView viewDidMoveToWindow]):
        (-[WebHTMLView mouseDown:]):
        (-[WebTextCompleteController dealloc]):
        * WebView/WebHTMLViewInternal.h:

2007-07-13  Mark Rowe  <mrowe@apple.com>

        Reviewed by Mitz.

        Build fix.  Stub out WebChromeClient::print.

        * WebCoreSupport/WebChromeClient.h:
        * WebCoreSupport/WebChromeClient.mm:
        (WebChromeClient::print):

2007-07-11  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Oliver.

        <rdar://problem/5108789> WEBVIEW: Drawing artifacts when dragging in IB

        Interface Builder 3 is relying on KVO notifications for frameOrigin and frameSize,
        among other standard NSView keys. Change automaticallyNotifiesObserversForKey to 
        return NO only for keys WebView manually fires notifications for.

        * WebView/WebView.mm:
        (+[WebView automaticallyNotifiesObserversForKey:]): Selectivly return NO for keys we manually fire.
        (-[WebView _declaredKeys]): Code clean up.

2007-07-10  Antti Koivisto  <antti@apple.com>

        Reviewed by John.
        
        Fix <rdar://problem/4570550>
        Hang in layout/layoutBlock/layoutBlockChildren preparing to print certain Mail messages
        
        When printing from Mail, WebHTMLView is a subview of the view that is actually printed and does not 
        receive calls that would set it to printing mode. Method adjustPageHeightNew is called repeatedly (for each page) during
        printing and it enables printing mode temporarily for each call. This triggers two full style recalcs and layouts
        each time making printing at least O(n^2). 

        Instead of enabling printing mode and resetting it back immediatly do the resetting asynchronously, after
        all adjustPageHeightNew calls are done. Normal Safari printing is not affected as adjustPageHeightNew is only
        called in case WebHTMLView is embedded in the view that is being printed.
        
        No automatic test possible, requires printing and non-Safari client.
        
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView adjustPageHeightNew:top:bottom:limit:]):

2007-07-10  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Maciej Stachowiak.

        - Fixed <rdar://problem/5049509> REGRESSION(10.4.9-9A377a): REAP Suite 
        installer shows empty modal alert window (hangs) if user cancels during
        "installing shared components" phase
        
        Added Adobe installers to the family of apps that need a data load
        loading quirk.
        
        Added a linked-on-or-after check because this code is no longer 
        Tiger-only.
        
        I tested this code on Tiger and Leopard.

        * Misc/WebKitVersionChecks.h:
        * WebKit.xcodeproj/project.pbxproj:
        * WebView/WebDocumentLoaderMac.mm:
        (needsDataLoadWorkaround):
        (WebDocumentLoaderMac::setDataSource):

2007-07-10  Darin Adler  <darin@apple.com>

        - fix build

        * WebView/WebHTMLView.mm: Add include of ContextMenu.h.

2007-07-10  Darin Adler  <darin@apple.com>

        Reviewed by John Sullivan.

        - <rdar://problem/5321953> remove workaround for fixed AppKit mouse moved bug

        * WebView/WebHTMLView.mm: Put the workaround for bug 3429631 inside an
        ifdef BUILDING_ON_TIGER.

2007-07-09  Anders Carlsson  <andersca@apple.com>

        Reviewed by Oliver.

        <rdar://problem/4954319> 
        Acrobat 7 / Safari crash: CrashTracer: 99 crashes in Safari at 
        com.apple.WebCore: WebCore::NetscapePlugInStreamLoader::isDone const + 0

        Add a new initWithFrameLoader: method to WebNetscapePluginStream which is to be used when
        the stream is a "fake" stream for full frame plug-ins.
        
        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView pluginView:receivedResponse:]):
        * Plugins/WebNetscapePluginStream.h:
        * Plugins/WebNetscapePluginStream.mm:
        (-[WebNetscapePluginStream initWithFrameLoader:]):
        (-[WebNetscapePluginStream initWithRequest:plugin:notifyData:sendNotification:]):
        (-[WebNetscapePluginStream start]):
        (-[WebNetscapePluginStream cancelLoadWithError:]):
        (-[WebNetscapePluginStream stop]):
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::createFrame):

2007-07-09  John Sullivan  <sullivan@apple.com>

        Reviewed by Darin
        
        - fixed <rdar://problem/5320208> WebKit should prevent Time Machine from backing up WebKit clients' icon databases

        * Misc/WebIconDatabase.mm:
        (-[WebIconDatabase init]):
        Re-added the code to exclude the icon database from backups. We now do this at the same time we (try to) import
        the old icon database format, which happens only once per icon database's lifetime.
        (-[WebIconDatabase _importToWebCoreFormat]):
        Assert that we haven't imported yet rather than bailing out. It's now the caller's responsibility to check
        whether we've imported yet.

2007-07-08  John Sullivan  <sullivan@apple.com>

        * Misc/WebIconDatabase.mm:
        (-[WebIconDatabase init]):
        Removed the code to exclude the icon database from backups. We still want to do this, but in a way
        that only runs once ever, instead of once per launch, due to performance concerns.

2007-07-07  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

        - fix <rdar://problem/5124665> WebCore secondary-thread assertion should use linked-on-or-after check instead of building on Tiger check

        * Misc/WebKitVersionChecks.h: Added WEBKIT_FIRST_VERSION_WITH_MAIN_THREAD_EXCEPTIONS.

        * WebView/WebFrameView.mm: (-[WebFrameView initWithFrame:]): In first-time initialization block,
        check for binaries linked against older versions of WebKit, and set the default thread violation
        behavior to LogOnFirstThreadViolation.

        * WebView/WebView.mm: (+[WebView initialize]): Improved comments.

2007-07-06  Oliver Hunt  <oliver@apple.com>

        Reviewed by Maciej.

        <rdar://problem/5318756> Need to refactor IM/Marked text code to share logic with windows.

        Moved a number of methods from WebHTMLView into WebCore.
        Replaced bridge methods with calls directly into WebCore objects.

        * WebKit.xcodeproj/project.pbxproj:
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView setMarkedText:selectedRange:]):
          Now calls WebCore object methods directly, rather than calling 
          via the bridge.

2007-07-06  John Sullivan  <sullivan@apple.com>

        Reviewed by Brady

        - WebKit part of fix for: 
          <rdar://problem/5310739> Time Machine shouldn't back up WebKit's icon database files

        * Misc/WebIconDatabase.mm:
        (-[WebIconDatabase init]):
        Use CSBackupSetItemExcluded to tell Time Machine not to back up the icon database file

2007-07-07  Mark Rowe  <mrowe@apple.com>

        Build fix.  Update WebDynamicScrollBarsView.h to include methods added and used in r24060.

        * WebView/WebDynamicScrollBarsView.h:

2007-07-05  Timothy Hatcher  <timothy@apple.com>

        Reviewed by John.

        <rdar://problem/5236277> REGRESSION-9A458: SPI for setting scroll bar behavior doesn't work

        Calling setHorizontalScrollingMode: calls updateScrollers before returning, this will cause
        WebCore to reset the scrolling mode based on the CSS overflow rules. So the setAlwaysShowHorizontalScroller:
        and setAlwaysShowVerticalScroller: methods needed a way to lock the scrolling mode before
        calling updateScrollers.

        * WebView/WebDynamicScrollBarsView.m:
        (-[WebDynamicScrollBarsView updateScrollers]):
        (-[WebDynamicScrollBarsView setHorizontalScrollingMode:]):
        (-[WebDynamicScrollBarsView setHorizontalScrollingMode:andLock:]):
        (-[WebDynamicScrollBarsView setVerticalScrollingMode:]):
        (-[WebDynamicScrollBarsView setVerticalScrollingMode:andLock:]):
        (-[WebDynamicScrollBarsView setScrollingMode:]):
        (-[WebDynamicScrollBarsView setScrollingMode:andLock:]):
        * WebView/WebView.mm:
        (-[WebView setAlwaysShowVerticalScroller:]):
        (-[WebView setAlwaysShowHorizontalScroller:]):

2007-07-06  Mitz Pettel  <mitz@webkit.org>

        Reviewed by Maciej.

        - fix http://bugs.webkit.org/show_bug.cgi?id=10267
          Can't scroll page downwards with scroll wheel, when pointer is on top of non-scrolling iframe

        * WebView/WebDynamicScrollBarsView.m:
        (-[WebDynamicScrollBarsView scrollWheel:]): Override the superclass
        implementation to forward the wheel event to the next responder if this view
        does not allow scrolling in the event's direction.

2007-07-05  John Sullivan  <sullivan@apple.com>

        Reviewed by Adam
        
        - WebKit part of fix for <rdar://problem/5315033>

        * WebView/WebDocumentPrivate.h:
        new selectionImageForcingBlackText: method. selectionImageForcingWhiteText: is no longer used and was never
        in an official release of WebKit, so it could be removed, except that doing so would cause trouble for people
        using nightly WebKit with Safari 3.0 beta. So I left it in, but made it just force black text instead of
        white text, which will look different for those nightly WebKit/Safari 3.0 beta people but not break anything.
        
        * Misc/WebSearchableTextView.m:
        (-[WebSearchableTextView selectionImageForcingBlackText:]):
        new unimplemented protocol method for this obsolete class
        
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView selectionImageForcingBlackText:]):
        calls through to WebCore the way selectionImageForcingWhiteText: used to
        (-[WebHTMLView selectionImageForcingWhiteText:]):
        now just calls selectionImageForcingBlackText:, thus not working as you would expect from the name
        
        * WebView/WebPDFView.mm:
        (-[WebPDFView selectionImageForcingBlackText:]):
        guts of old selectionImageForcingWhiteText:, but with black substituted for white
        (-[WebPDFView selectionImageForcingWhiteText:]):
        now just calls selectionImageForcingBlackText:, thus not working as you would expect from the name

2007-07-05  Timothy Hatcher  <timothy@apple.com>

        Reviewed by John.

        <rdar://problem/5314993> Shiira 2.1 throws an exception open a new window: -[WebInspector window]: unrecognized selector

        Add an empty implementation of this method to prevent Shiira from throwing an exception.
        Also log that this method is obsolete and the class will be removed.

        * WebInspector/WebInspector.mm:
        (-[WebInspector window]):

2007-07-04  Adam Roben  <aroben@apple.com>

        Move tooltip logic down into WebCore so that it can be shared cross-platform

        Reviewed by Sam.

        * WebCoreSupport/WebChromeClient.h:
        * WebCoreSupport/WebChromeClient.mm:
        (WebChromeClient::setToolTip): Added.
        * WebView/WebHTMLView.mm: Removed _resetCachedWebPreferences.
        (-[WebHTMLView _updateMouseoverWithEvent:]): Removed tooltip code.
        (-[WebHTMLView initWithFrame:]): Removed call to
        _resetCachedWebPreferences.
        (-[WebHTMLView setDataSource:]): Ditto.
        * WebView/WebHTMLViewInternal.h: Removed showsURLsInToolTips ivar.
        * WebView/WebHTMLViewPrivate.h: Added declaration for _setTooltip so
        that WebChromeClient can call it.

2007-07-04  Adam Roben  <aroben@apple.com>

        Initialize Settings::showsURLsInToolTips

        Reviewed by Sam.

        * WebView/WebView.mm:
        (-[WebView _updateWebCoreSettingsFromPreferences:]):

2007-07-04  Adam Roben  <aroben@apple.com>

        Removed call to mouseDidMoveOverElement now that WebCore handles it

        Reviewed by Sam.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _updateMouseoverWithEvent:]):

2007-07-04  Adam Roben  <aroben@apple.com>

        Add WebChromeClient::mouseDidMoveOverElement

        This is not called yet.

        Reviewed by Sam.

        * WebCoreSupport/WebChromeClient.h:
        * WebCoreSupport/WebChromeClient.mm:

2007-07-03  Darin Adler  <darin@apple.com>

        * StringsNotToBeLocalized.txt: Updated for recent changes.

2007-07-03  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Darin.

        Remove HIWebView in 64-bit.

        Also disable a few calls that are now gone in 64-bit and filed these bugs:

        <rdar://problem/5311653> WebKit needs to adopt HIGetMousePosition where we used GetGlobalMouse before
        <rdar://problem/5311648> WebKit needs to move off of CopyEvent in WebBaseNetscapePluginView
        <rdar://problem/5311640> WebKit needs a new solution for HISearchWindowShow on 64-bit

        * Carbon/CarbonUtils.m:
        * Carbon/CarbonWindowAdapter.m:
        * Carbon/CarbonWindowContentView.m:
        * Carbon/CarbonWindowFrame.m:
        * Carbon/HIViewAdapter.m:
        (SetViewNeedsDisplay):
        * Carbon/HIWebView.m:
        (Draw):
        (SyncFrame):
        * Configurations/WebKit.xcconfig:
        * Plugins/WebBaseNetscapePluginView.mm:
        (+[WebBaseNetscapePluginView getCarbonEvent:]):
        (TSMEventHandler):
        * WebKit.LP64.exp: Added.
        * WebView/WebView.mm:
        (-[WebView _searchWithSpotlightFromMenu:]):

2007-07-03  Adam Roben  <aroben@apple.com>

        Merge the Windows and Mac localized strings and exceptions files

        Reviewed by Darin and Anders.

        * English.lproj/Localizable.strings: Added Windows strings.
        * StringsNotToBeLocalized.txt: Renamed from WebKit/English.lproj/StringsNotToBeLocalized.txt.

2007-07-03  Adele Peterson  <adele@apple.com>

        Removed printf I accidently left in.

        * Misc/WebNSURLExtras.m: (mapHostNames):

2007-07-03  Adele Peterson  <adele@apple.com>

        Reviewed by Darin.

        Fix for: <rdar://problem/5292988> domain names shouldn't contain ignorable characters

        * Misc/WebNSURLExtras.m:
        (isLookalikeCharacter): Renamed.  Also excludes any non-printable character, 
         any character considered as whitespace that isn't already converted to a space by ICU, any ignorable character,
         and any character excluded in Mozilla's blacklist: http://kb.mozillazine.org/Network.IDN.blacklist_chars
        (allCharactersInIDNScriptWhiteList):

2007-07-03  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

        - fix <rdar://problem/5310848> WebDataSource lifetime problem -- may be cause of the leaks seen on the buildbot

        * WebView/WebDataSource.mm:
        (-[WebDataSourcePrivate dealloc]): Added a call to the new detachDataSource function.
        (-[WebDataSourcePrivate finalize]): Ditto.

        * WebView/WebDocumentLoaderMac.h: Added detachDataSource function to be used when the
        WebDataSource is deallocated. Added retain/releaseDataSource helper functions to be
        used to retain and release the data source object. Replaced the m_hasEverBeenDetached
        boolean with a more primitive and hence easier to understand m_isDataSourceRetained boolean.

        * WebView/WebDocumentLoaderMac.mm:
        (WebDocumentLoaderMac::WebDocumentLoaderMac): Initialize m_isDataSourceRetained to false.
        (WebDocumentLoaderMac::setDataSource): Call retainDataSource instead of calling HardRetain
        on the dataSource parameter. Also updated a comment.
        (WebDocumentLoaderMac::attachToFrame): Call retainDataSource unconditionally rather than
        trying to use m_hasEverBeenDetached to decide if a retain is needed. Also got rid of an
        assertion that m_loadingResources is empty -- not important any more.
        (WebDocumentLoaderMac::detachFromFrame): Call releaseDataSource instead of using
        HardRelease, but only if m_loadingResources is empty. If it's non-empty, then we'll
        do the releaseDataSource later in decreaseLoadCount.
        (WebDocumentLoaderMac::increaseLoadCount): Call retainDataSource unconditionally
        rather than calling HardRetain only if the old set of resources was empty.
        (WebDocumentLoaderMac::decreaseLoadCount): Call releaseDataSource if m_loadingResources
        is empty and we're not attached to a frame. If we are attached to a frame, then
        we'll do the releaseDataSource later in detachFromFrame.
        (WebDocumentLoaderMac::retainDataSource): Added. Calls CFRetain, but only if the data
        source is not already retained (according to the boolean).
        (WebDocumentLoaderMac::releaseDataSource): Added. Calls CFRelease, but only if the data
        source is currently retained (according to the boolean).
        (WebDocumentLoaderMac::detachDataSource): Added. Sets m_dataSource to nil. Since this
        is only called from WebDataSource's dealloc and finalize methods, it won't ever be called
        when the m_isDataSourceRetained boolean is true.

2007-07-03  Darin Adler  <darin@apple.com>

        - forgot to check in one file in the fix for <rdar://problem/5307880>
          some classes need finalize methods because of non-trivial work done in dealloc methods

        * WebView/WebView.mm: (-[WebViewPrivate finalize]): Delete identifierMap so it doesn't leak.

2007-07-03  Anders Carlsson  <andersca@apple.com>

        Reviewed by Darin.

        * WebView/WebView.mm:
        (-[WebView stringByEvaluatingJavaScriptFromString:]):
        ASSERT that the value returned isn't nil. It can't be nil when invoked on the main frame.

2007-07-04  Mark Rowe  <mrowe@apple.com>

        Unreviewed 64-bit build fixes.

        * WebCoreSupport/WebInspectorClient.mm: Let the compiler know that WebFrameView is a subclass of NSView.
        * WebView/WebDocumentInternal.h: Remove our preprocessor macro once we're done with it.
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView markAllMatchesForText:caseSensitive:limit:]): Fix argument types.

2007-07-02  Darin Adler  <darin@apple.com>

        Reviewed by Kevin Decker and Tim Hatcher.

        - fix <rdar://problem/5307880> some classes need finalize methods
          because of non-trivial work done in dealloc methods

        * DefaultDelegates/WebScriptDebugServer.m:
        (-[WebScriptDebugServer dealloc]): Added a comment about how this probably won't
        work under GC.
        * WebInspector/WebNodeHighlight.m:
        (-[WebNodeHighlight dealloc]): Ditto.

        * WebView/WebDataSource.mm:
        (+[WebDataSourcePrivate initialize]): Added. Makes finalize run on main thread.
        (-[WebDataSourcePrivate finalize]): Added. Calls deref on the document loader.
        * WebView/WebHTMLView.mm:
        (+[WebHTMLViewPrivate initialize]): Added. Makes finalize run on main thread.
        (-[WebHTMLViewPrivate finalize]): Added. Calls deref on promisedDragTIFFDataSource.

        * WebKit.xcodeproj/project.pbxproj: Let Xcode be Xcode.

2007-07-02  Oliver Hunt  <oliver@apple.com>

        Reviewed by Justin.

        Fix for 
          <rdar://problem/5290113> WebKit does not correctly handle replacement ranges from the IM in -[WebHTMLView insertText:]
          http://bugs.webkit.org/show_bug.cgi?id=13664

        We replicate the logic of -[WebHTMLView setMarkedText:selectedRange:] to handle the Input Method 
        feeding us a replacement string through insertText: so we can handle IMs that use insertText to
        replace text.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView insertText:]):

2007-07-01  Oliver Hunt  <oliver@apple.com>

        Reviewed by Alexey.

        Fix for <rdar://problem/5306210> Some events are still passed to WebCore despite being handled by the IM
        http://bugs.webkit.org/show_bug.cgi?id=14457

        We have to assume that the IM will consume all events, so we remove the dependency
        on -[WebHTMLView hasMarkedText].

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _interceptEditingKeyEvent:shouldSaveCommand:]):

2007-06-29  John Sullivan  <sullivan@apple.com>

        Reviewed by Oliver Hunt.

        - WebKit support for accessing the set of rectangles that encompass the selected text

        * WebView/WebDocumentPrivate.h:
        added -selectionTextRects to WebDocumentSelection protocol; tweaked comments

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _selectionDraggingRect]):
        use selectionRect instead of selectionImageRect since they're the same and maybe we can get
        rid of selectionImageRect someday
        (-[WebHTMLView selectionTextRects]):
        added implementation of new protocol method, which calls through to WebCore
        
        * WebView/WebPDFView.mm:
        (-[WebPDFView selectionTextRects]):
        added simple implementation of new protocol method, which just returns the single selection rect.
        PDFKit doesn't support obtaining multiple rects to describe a multi-line selection.
        (-[WebPDFView selectionImageForcingWhiteText:]):
        use selectionRect instead of selectionImageRect since they're the same and maybe we can get
        rid of selectionImageRect someday
        
        * Misc/WebSearchableTextView.m:
        (-[WebSearchableTextView selectionTextRects]):
        added no-op implementation of new protocol method to this obsolete class

2007-06-28  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Darin.

        <rdar://problem/5287569> WEBVIEW: Creating a webview in IB 3.0 (v2.0) NIB later crashes Interface Builder 2.5.4 on Tiger

        Prevent encoding any of the WebView subviews. The subviews are ignored by -[WebView initWithCoder:] and will be recreated.
        The Tiger 2.0 code crashed when the WebView released the subviews in initWithCoder:, so now there are no subviews to release.
        This never happened before because the Tiger 2.0 code and IB wouldn't encode a WebView that has a WebHTMLView.

        * WebView/WebView.mm:
        (-[WebView encodeWithCoder:]):

2007-06-26  John Sullivan  <sullivan@apple.com>

        Reviewed by Darin
        
        - WebKit support for displaying multiple text matches in PDF views (<rdar://problem/4601967>)

        * WebView/WebPDFView.h:
        new ivars textMatches and lastScrollPosition; now conforms to WebMultipleTextMatches protocol
        
        * WebView/WebPDFView.mm:
        (-[WebPDFView dealloc]):
        release textMatches
        (-[WebPDFView viewDidMoveToWindow]):
        start observing bounds changes in the PDF document's enclosing clip view, so we can notice when
        scrolling takes place
        (-[WebPDFView viewWillMoveToWindow:]):
        stop observing bounds changes in the PDF document's enclosing clip view
        (-[WebPDFView searchFor:direction:caseSensitive:wrap:startInSelection:]):
        most of the code here has been moved into the new method _nextMatchFor::::, which this now calls
        (-[WebPDFView setMarkedTextMatchesAreHighlighted:]):
        implementation of WebMultipleTextMatches protocol method, does nothing useful here because we don't
        support inline highlighting of matches in PDF documents
        (-[WebPDFView markedTextMatchesAreHighlighted]):
        implementation of WebMultipleTextMatches protocol method
        (-[WebPDFView markAllMatchesForText:caseSensitive:limit:]):
        implementation of WebMultipleTextMatches protocol method; calls _nextMatchFor:::: in a loop until
        entire document is searched or limit is hit; records results by saving PDFSelections in textMatches ivar
        (-[WebPDFView unmarkAllTextMatches]):
        implementation of WebMultipleTextMatches protocol method; clears saved textMatches
        (-[WebPDFView rectsForTextMatches]):
        implementation of WebMultipleTextMatches protocol method; converts saved PDFSelections into NSValue 
        objects that represent NSRects
        (-[WebPDFView _clipViewForPDFDocumentView]):
        new helper method to find the clip view whose bounds determine the current scroll position
        (-[WebPDFView _nextMatchFor:direction:caseSensitive:wrap:fromSelection:startInSelection:]):
        new helper method, extracted from searchFor:::::
        (-[WebPDFView _PDFDocumentViewMightHaveScrolled:]):
        new notification callback; tells webView's delegate when document has scrolled
        (-[WebPDFView _setTextMatches:]):
        new helper method, stores value in ivar

2007-06-26  Oliver Hunt  <oliver@apple.com>

        Reviewed by Maciej.

        Hopefully fix remainder of the IME issues on Mac.  
        We now assume that the IME silently consumes any event given
        to it during text composition, and only override this assumption
        if the NSTextInput or NSResponder callbacks are made.

        This prevents us from treating those events that the IME has 
        consumed internally (eg. candidate window navigation) as unhandled
        events that should be bubbled.

        This fixes:
          <rdar://problem/5107538> Major problems handling key press event with non-english Input Methods
          <rdar://problem/4196249> REGRESSION: Mail: Inputting space (U+0020) with IM deletes subsequent line breaks on Mail.app
          <rdar://problem/5015544> REGRESSION: Reverse conversion keyboard command does not work in Safari.
          <rdar://problem/5045121> REGRESSION: Inline is confirmed after press left/right arrow keys, happens in Mail but not in TextEdit.
          <rdar://problem/5076807> REGRESSION: Can't undo conversion of inline text (by hitting ESC)
          <rdar://problem/5085781> REGRESSION: Active input area lost "selected" highlight
          <rdar://problem/5094200> space key pressed to close the associated words candidate window gets inserted as text
          <rdar://problem/5228294> Candidate item for character matrix is sometimes skipped

        * WebKit.xcodeproj/project.pbxproj:
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView launchKeyEvent:]):
        (-[WebHTMLView keyDown:]):
        (-[WebHTMLView keyUp:]):
        (-[WebHTMLView _interceptEditingKeyEvent:shouldSaveCommand:]):
        (-[WebHTMLView unmarkText]):
        (-[WebHTMLView setMarkedText:selectedRange:]):
        (-[WebHTMLView doCommandBySelector:]):
        (-[WebHTMLView insertText:]):

2007-06-26  Jim Correia  <jim.correia@pobox.com>

        Reviewed by Darin.

        Fix http://bugs.webkit.org/show_bug.cgi?id=14411
        Bug 14411: WebNetscapePluginPackage overagressively sets CurApRefNum, which affects shipping versions of BBEdit.
        <rdar://problem/5297268>

        * Plugins/WebNetscapePluginPackage.m:
        (+[WebNetscapePluginPackage initialize]): Force the Resource Manager to
        lazy initialize, and only set CurApRefNum to the system file if
        CurApRefNum is still -1 after that forced lazy initialization.

2007-06-25  Kevin Decker  <kdecker@apple.com>

        Reviewed by Darin.

        <rdar://problem/5294036> -[WebView customTextEncodingName] API may return empty string instead of nil

        * WebView/WebView.mm:
        (-[WebView _mainFrameOverrideEncoding]): Addded the nsStringNilIfEmpty() inline to the data being returned because 
        our API says "The custom text encoding name or nil if no custom text encoding name has been set." I also verified
        the standing Tiger WebKit behavior for this method and it does indeed return nil if a custom encoding wasn't set.

2007-06-25  John Sullivan  <sullivan@apple.com>

        Reviewed by Darin
        
        - WebKit part of <rdar://problem/5293820>, needed to support multiple matches in PDFs

        * WebView/WebDocumentInternal.h:
        Added WebMultipleTextMatches protocol, containing five methods that were formerly implemented in WebHTMLView
        * WebView/WebHTMLViewPrivate.h:
        Removed declarations for the methods that are now in WebMultipleTextMatches protocol
        
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView markAllMatchesForText:caseSensitive:limit:]):
        moved this method into the WebDocumentInternalProtocols portion of the file
        (-[WebHTMLView setMarkedTextMatchesAreHighlighted:]):
        ditto
        (-[WebHTMLView markedTextMatchesAreHighlighted]):
        ditto
        (-[WebHTMLView unmarkAllTextMatches]):
        ditto
        (-[WebHTMLView rectsForTextMatches]):
        ditto

        * WebView/WebView.mm:
        (-[WebView canMarkAllTextMatches]):
        new method, returns YES only if the documentView of every frame implements WebMultipleTextMatches
        (-[WebView markAllMatchesForText:caseSensitive:highlight:limit:]):
        check for WebMultipleTextMatches protocol instead of checking for WebHTMLView class
        (-[WebView unmarkAllTextMatches]):
        ditto
        (-[WebView rectsForTextMatches]):
        ditto

        * WebView/WebViewPrivate.h:
        declared new method canMarkAllTextMatches

2007-06-25  John Sullivan  <sullivan@apple.com>

        Reviewed by Darin
        
        Fixed <rdar://problem/5292259> Find on Page doesn't work (throws exception) on page that includes PDF in a subframe

        * WebView/WebView.mm:
        (-[WebView markAllMatchesForText:caseSensitive:highlight:limit:]):
        We were testing whether the view was an HTMLView, but then running code that assumed it was an HTMLView outside of
        that test. That's a bad idea.

2007-06-22  Adele Peterson  <adele@apple.com>

        Reviewed by Geoff and Darin.

        Fix for: <rdar://problem/5239236> Other slash characters should not be permitted as part of a domain name

        * Misc/WebNSURLExtras.m:
        (isSlashOrPeriodLookalike):
        (allCharactersInIDNScriptWhiteList):

2007-06-21  Sam Weinig  <sam@webkit.org>

        Reviewed by Antti.

        Remove empty directories

        * WebInspector/webInspector: directory removed.
        * WebInspector/webInspector/Images: directory removed

2007-06-21  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by Tim.
        
        <rdar://problem/5237524> 
        REGRESSION: Keyboard commands don't work in a message window until you click inside the message
        
        When you open a message in its own window, Mail creates an empty 
        WebView, makes that WebView firstResponder and then sets off a 
        load inside that WebView.
        
        When we're asked to create the empty WebView, we put an empty 
        WebHTMLView inside it (in r21367 we began creating a document 
        for empty frames).  When Mail makes the WebView first responder 
        we make that empty WebHTMLView firstResponder.  Then when the 
        load finishes we create a new WebHTMLView and set it as the 
        document view.  
        
        Inside _setDocumentView, if the old document view or one of its
        descendants was the first responder, we'd makeFirstResponder:nil 
        so that the window wouldn't be left with a firstResponder that 
        was no longer inside of it.  This change fixes the bug by instead 
        transferring firstResponder status to the new document view.
        
        We could also fix this by not allowing the WebHTMLView to become
        firstResponder when it's in the provisional state mentioned above.

        * WebView/WebFrameView.mm:
        (-[WebFrameView _setDocumentView:]):

2007-06-21  John Sullivan  <sullivan@apple.com>

        Reviewed by Adele
        
        - fixed <rdar://problem/5268673> REGRESSION: Context menu missing for PDF in frame when there's no selection
        
        This was surprisingly interesting. It turns out that at least for Safari, the method [WebDefaultUIDelegate
        webView:contextMenuItemsForElement:defaultMenuItems:] is only exercised from WebPDFView these days. It mimics
        some of the code that was moved to WebCore as part of the Great Context Menu Refactoring of 2006, but is
        independent of that code. And it was partly broken/incomplete, probably as a result of said refactoring.

        * DefaultDelegates/WebDefaultContextMenuDelegate.mm:
        (localizedMenuTitleFromAppKit()):
        deleted this function since I removed all callers
        (-[WebDefaultUIDelegate menuItemWithTag:target:representedObject:]):
        Handle WebMenuItemTagOpenFrameInNewWindow tag, since code later in this file was relying on it. Added
        ASSERT_NOT_REACHED to the default case, since returning nil from this method is bad.
        Also, use WebKit versions of menu title strings rather than AppKit versions. We added these strings to WebKit 
        a while back so we don't need to sneakily find them in AppKit anymore.
        (-[WebDefaultUIDelegate webView:contextMenuItemsForElement:defaultMenuItems:]):
        make the WebView be the target of the Open Frame in New Window item; previously it was self, but that was
        just silly (probably a leftover from some code shuffling when context menus were reimplemented)

        * WebView/WebView.mm:
        (-[WebView _openFrameInNewWindowFromMenu:]):
        new method, used by Open Frame in New Window menu item.

        * WebView/WebViewInternal.h:
        Declare new method used by menu item. This isn't necessary for compilation, but could prevent the accidental
        deletion of the method implementation.

2007-06-20  Mark Rowe  <mrowe@apple.com>

        Reviewed by Adam.

        Fix http://bugs.webkit.org/show_bug.cgi?id=14255.
        Bug 14255: Reproducible crash opening web inspector from debug menu

        Reinstate the WebInspector class so WebKit clients that currently depend on it
        will build and run correctly.

        * WebInspector/WebInspector.h: Added.
        * WebInspector/WebInspector.mm: Added.
        (+[WebInspector webInspector]):
        (-[WebInspector dealloc]):
        (-[WebInspector setWebFrame:]):
        (-[WebInspector showWindow:]):
        * WebKit.exp:
        * WebKit.xcodeproj/project.pbxproj:

2007-06-20  Adam Roben  <aroben@apple.com>

        Land the new Inspector.

        Co-written with Tim Hatcher.

        Reviewed by Anders, Adele, Hyatt, and Sam.

        Implement the InspectorClient interface.

        * WebCoreSupport/WebInspectorClient.h: Added.
        * WebCoreSupport/WebInspectorClient.mm: Added.
        (WebInspectorClient::WebInspectorClient):
        (WebInspectorClient::inspectorDestroyed):
        (WebInspectorClient::createPage):
        (WebInspectorClient::showWindow):
        (WebInspectorClient::closeWindow):
        (WebInspectorClient::attachWindow):
        (WebInspectorClient::detachWindow):
        (WebInspectorClient::highlight):
        (WebInspectorClient::hideHighlight):
        (WebInspectorClient::inspectedURLChanged):
        (WebInspectorClient::updateWindowTitle):
        (-[WebInspectorWindowController init]):
        (-[WebInspectorWindowController initWithInspectedWebView:]):
        (-[WebInspectorWindowController dealloc]):
        (-[WebInspectorWindowController inspectorVisible]):
        (-[WebInspectorWindowController webView]):
        (-[WebInspectorWindowController window]):
        (-[WebInspectorWindowController windowShouldClose:]):
        (-[WebInspectorWindowController close]):
        (-[WebInspectorWindowController showWindow:]):
        (-[WebInspectorWindowController attach]):
        (-[WebInspectorWindowController detach]):
        (-[WebInspectorWindowController highlightAndScrollToNode:]):
        (-[WebInspectorWindowController highlightNode:]):
        (-[WebInspectorWindowController hideHighlight]):
        (-[WebInspectorWindowController animationDidEnd:]):

        Add an easier-to-see highlight.

        * Misc/WebNSViewExtras.h:
        * Misc/WebNSViewExtras.m:
        (-[NSView _web_convertRect:toView:]):
        * WebInspector/WebNodeHighlight.h:
        * WebInspector/WebNodeHighlight.m:
        (-[WebNodeHighlightFadeInAnimation setCurrentProgress:]):
        (-[WebNodeHighlight initWithTargetView:]):
        (-[WebNodeHighlight setHighlightedNode:]):
        (-[WebNodeHighlight highlightedNode]):
        (-[WebNodeHighlight dealloc]):
        (-[WebNodeHighlight attachHighlight]):
        (-[WebNodeHighlight delegate]):
        (-[WebNodeHighlight detachHighlight]):
        (-[WebNodeHighlight show]):
        (-[WebNodeHighlight hide]):
        (-[WebNodeHighlight animationDidEnd:]):
        (-[WebNodeHighlight ignoresMouseEvents]):
        (-[WebNodeHighlight highlightView]):
        (-[WebNodeHighlight setDelegate:]):
        (-[WebNodeHighlight setHolesNeedUpdateInTargetViewRect:]):
        (-[WebNodeHighlight setIgnoresMouseEvents:]):
        (-[WebNodeHighlight targetView]):
        (-[WebNodeHighlight _computeHighlightWindowFrame]):
        (-[WebNodeHighlight _repositionHighlightWindow]):
        * WebInspector/WebNodeHighlightView.h:
        * WebInspector/WebNodeHighlightView.m:
        (-[WebNodeHighlightView initWithWebNodeHighlight:]):
        (-[WebNodeHighlightView dealloc]):
        (-[WebNodeHighlightView detachFromWebNodeHighlight]):
        (-[WebNodeHighlightView drawRect:]):
        (-[WebNodeHighlightView webNodeHighlight]):
        (-[WebNodeHighlightView fractionFadedIn]):
        (-[WebNodeHighlightView setFractionFadedIn:]):
        (-[WebNodeHighlightView setHolesNeedUpdateInRect:]):
        (-[WebNodeHighlightView _holes]):

        WebView changes needed for the new Inspector.

        * WebView/WebView.mm: Remove the old _inspectElement method now that
        this is handled by WebCore.
        (-[WebView _isClosed]): Added.
        (-[WebView initWithFrame]): Give each Page an InspectorClient to
        enable the Inspector.
        * WebView/WebViewPrivate.h:

        Updates needed for WebCore changes.

        * WebCoreSupport/WebContextMenuClient.h:
        * WebCoreSupport/WebContextMenuClient.mm:
        * WebCoreSupport/WebViewFactory.mm:
        (-[WebViewFactory contextMenuItemTagInspectElement]):
        * WebView/WebUIDelegatePrivate.h:

        Remove old Inspector code.

        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::dispatchDidLoadResourceFromMemoryCache):
        (WebFrameLoaderClient::assignIdentifierToInitialRequest):
        (WebFrameLoaderClient::dispatchDidFinishLoading):
        * WebInspector/WebInspector.m: Removed.
        * WebInspector/WebInspectorPanel.h: Removed.
        * WebInspector/WebInspectorPanel.m: Removed.
        * WebInspector/webInspector/Images/button.png: Removed.
        * WebInspector/webInspector/Images/buttonDivider.png: Removed.
        * WebInspector/webInspector/Images/buttonPressed.png: Removed.
        * WebInspector/webInspector/Images/close.png: Removed.
        * WebInspector/webInspector/Images/closePressed.png: Removed.
        * WebInspector/webInspector/Images/downTriangle.png: Removed.
        * WebInspector/webInspector/Images/menu.png: Removed.
        * WebInspector/webInspector/Images/menuPressed.png: Removed.
        * WebInspector/webInspector/Images/popup.png: Removed.
        * WebInspector/webInspector/Images/popupPressed.png: Removed.
        * WebInspector/webInspector/Images/resize.png: Removed.
        * WebInspector/webInspector/Images/rightTriangle.png: Removed.
        * WebInspector/webInspector/Images/scrollThumbBottom.png: Removed.
        * WebInspector/webInspector/Images/scrollThumbMiddle.png: Removed.
        * WebInspector/webInspector/Images/scrollTrackBottom.png: Removed.
        * WebInspector/webInspector/Images/upTriangle.png: Removed.
        * WebInspector/webInspector/inspector.css: Removed.
        * WebInspector/webInspector/inspector.html: Removed.
        * WebInspector/webInspector/inspector.js: Removed.
        * WebInspector/webInspector/scrollarea.js: Removed.
        * WebInspector/webInspector/scrollbar.js: Removed.
        * WebInspector/webInspector/utilities.js: Removed.
        * WebView/WebFrame.mm:
        (-[WebFramePrivate dealloc]):
        * WebView/WebFrameInternal.h:
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView menuForEvent:]):

        Build-fu:

        * WebKit.exp:
        * WebKit.xcodeproj/project.pbxproj:

2007-06-20  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by Darin.
        
        <rdar://problem/5263541> REGRESSION (Safari 3 Beta 1): Pressing Delete doesn't delete an HTML message in Mail
        
        Mail wasn't receiving the keyDown event because WebFrameView was blocking it.
        It blocks the event and moves back/forward on Delete/Shift+Delete if the
        back/forward list is enabled.

        * WebView/WebFrameView.mm:
        (-[WebFrameView keyDown:]): Check to see if the BackForwardList is
        enabled.  It always exists.

2007-06-19  Anders Carlsson  <andersca@apple.com>

        Reviewed by Kevin Decker.

        <rdar://problem/5266289> REGRESSION (Safari 3 Beta 1): Incoming iChat messages are delayed

        * WebView/WebDocumentLoaderMac.mm:
        (needsAppKitWorkaround):
        New function which checks if the frame load delegate belongs to AppKit.
        
        (WebDocumentLoaderMac::setDataSource):
        If the frame load delegate belongs to AppKit, set m_deferMainResourceDataLoad to false.

2007-06-19  John Sullivan  <sullivan@apple.com>

        Reviewed by Tim Hatcher

        - fixed <rdar://problem/5272011> Hole for find-on-page match in subframe isn't clipped by frame bounds

        * WebView/WebView.mm:
        (-[WebView rectsForTextMatches]):
        intersect the HTMLView's computed rect with the visible rect for that view

2007-06-19  Jim Correia  <jim.correia@pobox.com>

        Reviewed by Kevin Decker
        
        * Carbon/HIWebView.m:
        (WindowHandler): HIObjectIsOfClass requires non-NULL input on Tiger. Reworked Kevin Decker's patch to remove the conditional compilation for Tiger, yet still avoid crashing BBEdit.

2007-06-18  Sam Weinig  <sam@webkit.org>

        Reviewed by Beth.

        Build fix.

        * WebCoreSupport/WebChromeClient.mm:

2007-06-18  Kevin Decker <kdecker@apple.com>

        * Carbon/HIWebView.m:
        (WindowHandler): Fixed the Tiger build; ControlKind wasn't defined.

2007-06-18  Kevin Decker  <kdecker@apple.com>

        Reviewed by Tim Hatcher.

        Fixed: <rdar://problem/5276135> With Safari 3 Tiger Beta installed, a crash occurs in BBEdit while mousing down and dragging outside of HTML preview window

        * Carbon/HIWebView.m:
        (WindowHandler): Because the fix for 5051616 causes Tiger to crash in HIToolbox (but not on Leopard), I reverted back to using GetControlKind
        on Tiger only, instead of HIObjectIsOfClass.

2007-06-16  David Hyatt  <hyatt@apple.com>

        Back out fix for 13972.  Quicktime will no longer clip correctly. :(
        Too many regressions in Mail caused by inserting an extra view into the
        hierarchy.  Can revisit later.

        Reviewed by olliej

        * Plugins/WebPluginController.mm:
        (-[WebPluginController destroyPlugin:]):
        (-[WebPluginController destroyAllPlugins]):
        * WebCoreSupport/WebFrameBridge.mm:
        (-[WebFrameBridge pluginViewWithPackage:attributeNames:attributeValues:baseURL:DOMElement:loadManually:]):
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView addSubview:]):
        (-[WebHTMLView willRemoveSubview:]):

2007-06-15  Sam Weinig  <sam@webkit.org>

        Reviewed by Darin.

        Patch for http://bugs.webkit.org/show_bug.cgi?id=14053
        Autogenerate JS binding for Rect

        - Fix conflicts by using ::Rect instead of Rect.

        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView saveAndSetNewPortStateForUpdate:]):
        (-[WebBaseNetscapePluginView sendEvent:]):
        (-[WebBaseNetscapePluginView tellQuickTimeToChill]):
        (-[WebBaseNetscapePluginView invalidateRegion:]):
        (-[WebBaseNetscapePluginView _printedPluginBitmap]):

2007-06-15  Anders Carlsson  <andersca@apple.com>

        Reviewed by Kevin.

        A better fix for <rdar://problem/5271774>. Only try to access the element if the
        view has an associated window. This also works with GC. (Fix suggested by Kevin.)

        * Plugins/WebKitPluginContainerView.mm:
        (-[WebKitPluginContainerView dealloc]):
        (-[WebKitPluginContainerView visibleRect]):

2007-06-15  Anders Carlsson  <andersca@apple.com>

        Reviewed by Kevin.

        <rdar://problem/5271774> REGRESSION: A crash occurs when closing a window that contains a QT movie
        
        In some cases, calling [super dealloc] might end up calling visibleRect, so make sure to
        set _element to 0 so we won't send a message to a freed object and crash.
        
        * Plugins/WebKitPluginContainerView.mm:
        (-[WebKitPluginContainerView dealloc]):
        (-[WebKitPluginContainerView visibleRect]):

2007-06-14  Anders Carlsson  <andersca@apple.com>

        Reviewed by Geoff.

        Call cleanupScriptObjectsForPlugin on the frame after destroying the plug-in.
        
        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView _destroyPlugin]):
        * Plugins/WebPluginController.mm:
        (-[WebPluginController destroyPlugin:]):
        (-[WebPluginController destroyAllPlugins]):

2007-06-13  John Sullivan  <sullivan@apple.com>

        Reviewed by Adele Peterson
        
        - fixed <rdar://problem/5267607> Clicking the "Save to Downloads" button in 
          PDF overlay too soon results in corrupt file

        * WebView/WebPDFView.mm:
        (-[WebPDFView PDFViewSavePDFToDownloadFolder:]):
        Just beep if the document isn't available yet, since trying to save it as a file
        really isn't a good idea.

2007-06-12  Oliver Hunt  <oliver@apple.com>

        Reviewed by Darin.

        Use correct size for BITMAPINFOHEADER -- whoops.

        * win/WebIconDatabase.cpp:
        (createDIB):
        (WebIconDatabase::getOrCreateDefaultIconBitmap):

2007-06-10  David Hyatt  <hyatt@apple.com>

        Fix for bug 14037, make sure respondsToSelector does the write thing
        when invoked on a WebKit plugin's container view.

        Reviewed by Mark Rowe

        * Plugins/WebKitPluginContainerView.mm:
        (-[WebKitPluginContainerView respondsToSelector:]):

2007-06-08  John Sullivan  <sullivan@apple.com>

        * WebView/WebViewPrivate.h:
        Added a FIXME

2007-06-07  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by Tristan.
        
        <rdar://problem/5250997> A crash occurs when selecting Undo Typing for a page that has been closed in tab

        * WebView/WebView.mm:
        (-[WebView _clearUndoRedoOperations]): Added.
        * WebView/WebViewPrivate.h:

2007-06-07  Oliver Hunt  <oliver@apple.com>

        Reviewed by Sam "The Intern" Weinig.
        
        Don't be overzealous with the input checks, firstRectForCharacterRange
        can be determined even when there is not an active editable region.
        
        This unbreaks editing/input/range-for-empty-document which was broken
        by aforementioned overzealousness. 

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView firstRectForCharacterRange:]):

2007-06-07  Oliver Hunt  <oliver@apple.com>

        Reviewed by Justin.
        
        Add checks to make sure we don't try to create, use
        or return invalid ranges to TSM when it calls us despite
        not currently being in an editable region.

        * WebView/WebHTMLView.mm:
        (isTextInput):
        (-[WebHTMLView textStorage]):
        (-[WebHTMLView firstRectForCharacterRange:]):
        (-[WebHTMLView selectedRange]):
        (-[WebHTMLView attributedSubstringFromRange:]):

2007-06-06  David Hyatt  <hyatt@apple.com>

        Make sure to hand back a script object for webkit plugins (the container
        view forwards to its plugin child).

        Reviewed by sullivan

        * Plugins/WebKitPluginContainerView.h:
        * Plugins/WebKitPluginContainerView.mm:
        (-[WebKitPluginContainerView objectForWebScript]):

2007-06-06  David Hyatt  <hyatt@apple.com>

        Fix for bug 13972, quicktime doesn't respect CSS clip and overflow properties.
        Make sure that calls to [NSView visibleRect] will do the right thing for both
        Netscape plugins and WebKit plugins.

        Reviewed by olliej

        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView visibleRect]):
        (-[WebBaseNetscapePluginView saveAndSetNewPortStateForUpdate:]):
        (-[WebBaseNetscapePluginView isOpaque]):
        * Plugins/WebKitPluginContainerView.h: Added.
        * Plugins/WebKitPluginContainerView.mm: Added.
        (-[WebKitPluginContainerView initWithFrame:DOMElement:]):
        (-[WebKitPluginContainerView dealloc]):
        (-[WebKitPluginContainerView visibleRect]):
        * Plugins/WebPluginController.mm:
        (-[WebPluginController destroyAllPlugins]):
        * WebCoreSupport/WebFrameBridge.mm:
        (-[WebFrameBridge pluginViewWithPackage:attributeNames:attributeValues:baseURL:DOMElement:loadManually:]):
        * WebKit.xcodeproj/project.pbxproj:
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView addSubview:]):
        (-[WebHTMLView willRemoveSubview:]):

2007-06-04  Oliver Hunt  <oliver@apple.com>

        Reviewed by Geoff and Justin.

        Fix for <rdar://problem/5246941> Clicking URL field on 
        Safari causes halt for a minute when using input methods.
        and <rdar://problem/5245964> Safari hangs for several 
        seconds when trying to select text using mouse
        
        This is a by product of the textStorage hack used to fix 
        rdar://problem/5000470 -- TSM calls textStorage repeatedly
        when changing focus, on certain mouse events, etc.  If there
        is no selection/editable region we repeatedly create an     
        NSAttributedString from the full document.  If the document is
        sufficiently long this starts consuming an inordinate amount of 
        time.
        
        This check should really have been present in the original 
        patch.

        * WebKit.xcodeproj/project.pbxproj:
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView textStorage]):

2007-05-31  David Hyatt  <hyatt@apple.com>

        Fix for 11768, Flash plugin does not respect clips set by CSS.

        Reviewed by olliej

        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView saveAndSetNewPortStateForUpdate:]):

2007-05-30  Mark Rowe  <mrowe@apple.com>

        Build fixes after r21889.

        * ForwardingHeaders/kjs/function.h: Added.

2007-05-29  Mark Rowe  <mrowe@apple.com>

        Reviewed by Geoff.

        64-bit build fix.  Ensure that use of WebNSUInteger in headers is matched by WebNSUInteger in implementations.

        * DefaultDelegates/WebScriptDebugServer.h:
        * DefaultDelegates/WebScriptDebugServer.m:
        (-[WebScriptDebugServer webView:didParseSource:baseLineNumber:fromURL:sourceId:forWebFrame:]):
        (-[WebScriptDebugServer webView:failedToParseSource:baseLineNumber:fromURL:withError:forWebFrame:]):
        * DefaultDelegates/WebScriptDebugServerPrivate.h:
        * History/WebBackForwardList.mm:
        (-[WebBackForwardList setPageCacheSize:]):
        (-[WebBackForwardList pageCacheSize]):
        * WebView/WebView.mm:
        (-[WebView markAllMatchesForText:caseSensitive:highlight:limit:]):

2007-05-26  Darin Adler  <darin@apple.com>

        Reviewed by Tim Hatcher.

        * MigrateHeaders.make: Added dependency on this makefile itself, which is
        useful when you change the sed command or other aspect of this file. My build
        failed until I made this fix.

2007-05-25  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Darin Adler.

        Fixed <rdar://problem/5055182> The page cache has no global cap.
        
        The main WebKit changes are:
            1. Changed -[WebBackForwardList setPageCacheSize] and -[WebBackForwardList 
            pageCacheSize] to accomodate the new global page cache model, updating
            their documentation. 
            
            2. Added -[WebPreferences setShouldUsePageCache] and -[WebPreferences 
            shouldUsePageCache] as pending public API.
            
            3. Centralized calculation of object cache and page cache sizes inside
            WebPreferences. 
            
            Cchanged our old behavior of reading a preference and applying a fudge 
            factor with a new behavior of just using the preference directly. The 
            old behavior was confusing and often inappropriate. (For example, if 
            you set a page cache size of 100, a 256MB machine would somewhat 
            arbitrarily reduce that number to 98. ???)

        * WebView/WebView.mm: Added support for two flags to determine whether
        to use the page cache. If either -[WebBackForwardList setPageCacheSize:0]
        or -[WebPreferences setShouldUsePageCache:NO] is called, we don't use
        the page cache.

2007-05-25  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Kevin Decker.

        <rdar://problem/5219089> Changes for migration of DictionaryServices

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _lookUpInDictionaryFromMenu:]): look for the HIDictionaryWindowShow symbol in HIToolbox

2007-05-25  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Oliver Hunt.
        
        Fixed global initializer (like you fix a dog).
        
        I'm not sure how our script missed this. I tested, and it generally doesn't 
        seem to work very well.

        * WebView/WebHTMLView.mm: Allocate lazily to avoid the performance hit of
        a global initializer.
        (promisedDataClient):
        (-[WebHTMLViewPrivate dealloc]):
        (-[WebHTMLViewPrivate clear]):
        (-[WebHTMLView setPromisedDragTIFFDataSource:WebCore::]):

2007-05-25  Brady Eidson  <beidson@apple.com>

        Reviewed by Darin

        <rdar://problem/5228371> - REGRESSION - Certain mail message bodies display as empty

        This is due to http://trac.webkit.org/projects/webkit/changeset/21480 which unintentionally
        made applewebdata urls result in check.call(false) instead of check.call(true)

        Best place for a fix is to have the FrameLoaderClient::canHandleRequest() call return true, which
        really is rooted in WebView

        <rdar://problem/5229587> tracks adding a layout test

        * WebView/WebView.mm:
        (+[WebView _canHandleRequest:]): Return true for applewebdata URLs

2007-05-25  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Darin Adler, Tim Hatcher.
        
        "unsigned" => "WebNSUInteger" in public API.

        * History/WebBackForwardList.h:
        * WebView/WebScriptDebugDelegate.h:
        * WebView/WebUIDelegate.h:
        * WebView/WebViewPrivate.h:

2007-05-25  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Darin Adler.
        
        Moved JavaScriptCore-related pending public API to public API.

        * MigrateHeaders.make: Hack to prevent <JavaScriptCore/JSBase.h> from 
        automatically converting to <WebKit/JSBase.h>
        
        Moved -windowObject and -globalContext

        * WebView/WebFramePrivate.h: from here
        * WebView/WebFrame.h: to here
        * WebView/WebFrame.mm: and out of its temporary category

        Moved -didClearWindowObject:forFrame:

        * WebView/WebViewPrivate.h: from here
        * WebView/WebFrameLoadDelegate.h: to here

2007-05-25  John Sullivan  <sullivan@apple.com>

        Reviewed by Anders and Tim
        
        - fixed <rdar://problem/5226000> REGRESSION: In Gmail and Mail, a hang occurs when attempting 
          to grammar/spellcheck a word in a reply

        * WebCoreSupport/WebEditorClient.mm:
        (WebEditorClient::checkGrammarOfString):
        Fixed recently-introduced false assumption that NSNotFound == -1

2007-05-24  dethbakin  <bdakin@apple.com>

        Reviewed by Geoff.

        Fix for <rdar://problem/5023545> QuickBooks Pro 2007:hang/crash 
        after closing QuickBooks Tutorial Center with Leopard9A377

        We can hit a race condition where drawRect will be called after the 
        WebView has closed. Quickbooks does not properly close the WebView 
        and set the UIDelegate to nil, so the UIDelegate is stale and we 
        crash. This is a regression because the code that uses the 
        UIDelegate in the drawRect code path was only added recently. The 
        method that the UIDelegate calls into is new -- it does not exist 
        on Tiger -- so there is no harm in not running this code for 
        applications linked against older WebKits. Other applications may 
        run into this same bug so I am not doing a bundle 
        check...particularly because, as I mentioned, the new UIDelegate 
        call would not be implemented by older clients anyway.  

        * Misc/WebKitVersionChecks.h:
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView drawSingleRect:]):

2007-05-24  Darin Adler  <darin@apple.com>

        * English.lproj/StringsNotToBeLocalized.txt: Update for recent changes.

2007-05-24  Oliver Hunt  <oliver@apple.com>

        Reviewed by Adam, Darin, and Geoff.

        Fix for <rdar://problem/5000470> REGRESSION: The IM reconvert
        function returns incorrect symbol due to inconsistent range
        domains in TSM

        Text Services Management uses ranges provided by the
        NSTextInput API to index into the string return by
        -[WebHTMLView string]. As a result some input methods
        incorrectly get their candidate text from the beginning
        of the document instead of from the input element.

        TSM prefers to query -textStorage over -string so as a
        workaround we provide an implementation of -textStorage that
        returns the content of the current text input.  TSM only ever
        queries the result of textStorage as an NSAttributedString so
        we do not need to implement a fake NSTextStorage class

        This should not cause harm to anything else as textStorage is
        actually a method on NSTextView, which we clearly are not. TSM
        only queries the method because it uses respondsToSelector to
        control behaviour.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView textStorage]):


2007-05-24  David Harrison  <harrison@apple.com>

        Reviewed by Tim Hatcher.

        <rdar://problem/5225343> REGRESSION: With View Source window opened, navigating to a different URL in the browser window results in a crash at WebCore::FrameLoader::frameHasLoaded()
        
        _private->loader->frameLoader() was not being nil checked.
        * WebView/WebDataSource.mm:
        (-[WebDataSource request]):
        Add nil check for _private->loader->frameLoader() 

2007-05-23  Anders Carlsson  <andersca@apple.com>

        Reviewed by Geoff.

        <rdar://problem/3663808> Resize large images to fit in the browser window
        
        Add new WebPreferences SPI.
        
        * WebView/WebPreferenceKeysPrivate.h:
        * WebView/WebPreferences.m:
        (+[WebPreferences initialize]):
        (-[WebPreferences enableAutomaticImageResizing]):
        (-[WebPreferences setEnableAutomaticImageResizing:]):
        * WebView/WebPreferencesPrivate.h:
        * WebView/WebView.mm:
        (-[WebView _updateWebCoreSettingsFromPreferences:]):

2007-05-23  Sam Weinig  <sam@webkit.org>

        Reviewed by Darin.

        Patch for http://bugs.webkit.org/show_bug.cgi?id=13830
        Auto-generate JS DOM bindings for HTMLDocument and most of the rest
        of HTMLElement

        * MigrateHeaders.make: add DOMHTMLDocumentPrivate.h
        * WebKit.xcodeproj/project.pbxproj:

2007-05-23  Oliver Hunt  <oliver@apple.com>

        Reviewed by Geoff.

        Fix for <rdar://problem/5223782> REGRESSION: Can't drag and drop a standalone image

        The main resource for a standalone image webarchive has the same mimetype as the
        underlying image.

        * Misc/WebNSPasteboardExtras.mm:
        (-[NSPasteboard _web_writePromisedRTFDFromArchive:containsImage:]):

2007-05-22  Sam Weinig  <sam@webkit.org>

        Reviewed by Adam.

        Patch for http://bugs.webkit.org/show_bug.cgi?id=13833
        Add ObjC DOM binding for HTMLMarqeeElement

        - Also adds missing DOMHTMLFramePrivate.

        * MigrateHeaders.make:

2007-05-22  Darin Adler  <darin@apple.com>

        Reviewed by Geoff.

        * WebInspector/webInspector/treeoutline.js: Use ownerDocument instead of non-standard
        document property.

2007-05-22  Adele Peterson  <adele@apple.com>

        Reviewed by Darin.

        Adding some asserts to help detect other cases of <rdar://problem/5171145>

        * WebCoreSupport/WebFrameBridge.mm: (-[WebFrameBridge makeFirstResponder:]):

2007-05-22  Brady Eidson  <beidson@apple.com>

        Reviewed by Kevin (Sarge)

        <rdar://problem/5219885> - Crash after closing a inline popup ad at http://news.yahoo.com/

        This regressed in http://trac.webkit.org/projects/webkit/changeset/21618

        * WebView/WebFrame.mm:
        (-[WebFrame dataSource]): Null check the frameloader

2007-05-21  Adele Peterson  <adele@apple.com>

        Fix by Darin, reviewed by me.

        Fix for <rdar://problem/5171145> Safari crashed closing tab in NSInputContext updateInputContexts

        * WebView/WebFrameView.mm: (-[WebFrameView _setDocumentView:]): If the old view is the first responder,
        then set the window's first responder to nil so we don't leave the window pointing to a view that's no longer in it.

2007-05-21  Brady Eidson  <beidson@apple.com>

        Making the importance of my last change more clear

        * WebView/WebViewPrivate.h: "Leave for Dashboard, people!"

2007-05-21  Brady Eidson  <beidson@apple.com>

        Reviewed by Kevin (Sarge)

        <rdar://problem/5217124> - Re-add mistakenly removed SPI

        * WebView/WebView.mm:
        (-[WebView handleAuthenticationForResource:challenge:fromDataSource:]):
        * WebView/WebViewPrivate.h:

2007-05-21  Anders Carlsson  <andersca@apple.com>

        Reviewed by Ada.

        <rdar://problem/5200816> REGRESSION: With Shiira 1.2.2 , I can't open embedded link in flash object by clicking (http:/www.adobe.com )
        
        Null check the request.
        
        * WebView/WebView.mm:
        (+[WebView _canHandleRequest:]):

2007-05-19  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Geoff.
        
        <rdar://problem/5205358> REGRESSION (r21367): All messages appear entirely blank when running Mail off of tip of tree WebKit
        
        The fix is to return nil from [WebFrame dataSource] when it has not loaded anything but the fake
        empty initial document. However, WebKit still needs the real data source internally, so I also
        added a [WebFrame _dataSource] method that skips this check, and made WebKit use it throughout.

        * Misc/WebNSAttributedStringExtras.mm:
        (fileWrapperForElement):
        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView dataSource]):
        * Plugins/WebNullPluginView.mm:
        (-[WebNullPluginView viewDidMoveToWindow]):
        * Plugins/WebPluginController.mm:
        (-[WebPluginController URLPolicyCheckReferrer]):
        * WebCoreSupport/WebFrameBridge.mm:
        (-[WebFrameBridge dataSource]):
        (-[WebFrameBridge redirectDataToPlugin:]):
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::makeDocumentView):
        (WebFrameLoaderClient::forceLayoutForNonHTML):
        (WebFrameLoaderClient::prepareForDataSourceReplacement):
        (WebFrameLoaderClient::canCachePage):
        * WebCoreSupport/WebViewFactory.mm:
        (-[WebViewFactory bridgeForView:]):
        * WebKit.xcodeproj/project.pbxproj:
        * WebView/WebArchiver.mm:
        (+[WebArchiver archiveFrame:]):
        (+[WebArchiver archiveMainResourceForFrame:]):
        (+[WebArchiver _archiveWithMarkupString:fromFrame:nodes:]):
        (+[WebArchiver archiveSelectionInFrame:]):
        * WebView/WebFrame.mm:
        (-[WebFrame _loadURL:referrer:intoChild:]):
        (-[WebFrame _addChild:]):
        (-[WebFrame _dataSource]):
        (-[WebFrame DOMDocument]):
        (-[WebFrame dataSource]):
        * WebView/WebFrameInternal.h:
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _setPrinting:minimumPageWidth:maximumPageWidth:adjustViewSize:]):
        * WebView/WebRenderNode.mm:
        (-[WebRenderNode initWithWebFrameView:]):
        * WebView/WebView.mm:
        (-[WebView _mainFrameOverrideEncoding]):
        (-[WebView mainFrameURL]):
        (-[WebView mainFrameTitle]):
        (-[WebView mainFrameIcon]):
        (-[WebView validateUserInterfaceItemWithoutDelegate:]):
        (-[WebView replaceSelectionWithArchive:]):
        (-[WebView _isLoading]):
        (-[WebView _performTextSizingSelector:withObject:onTrackingDocs:selForNonTrackingDocs:newScaleFactor:]):
        (-[WebView _notifyTextSizeMultiplierChanged]):

2007-05-18  Oliver Hunt  <oliver@apple.com>

        Reviewed by Sam.

        Fix for http://bugs.webkit.org/show_bug.cgi?id=13782 
        REGRESSION (r21528-r21533): Failing editing/selection/drag-in-iframe in pixel mode
        
        r21533 made used a DOMElement as the source for promise data, this meant it had to 
        clear the dragging pasteboard following the drag.  In DRT a drag is non-blocking
        so this resulted in us prematurely clearing the pasteboard.  
        
        This patch avoids this problem by referencing the source CachedImage rather than the
        DOMElement, so we don't need to worry about retaining an entire document forever, so
        we don't need to clear the dragging pasteboard following the drag.
        
        * Misc/WebNSPasteboardExtras.mm:
        (imageFromElement):
          Extract the underlying CachedImage from a DOMElement
        (-[NSPasteboard _web_writeImage:element:URL:title:archive:types:source:]):
          Use a CachedImage instead of a DOMElement
          
        * WebCoreSupport/WebDragClient.mm:
        (WebDragClient::startDrag):
        
        * WebKit.xcodeproj/project.pbxproj:
        
        * WebView/WebHTMLView.mm:
        (-[WebHTMLViewPrivate dealloc]):
        (-[WebHTMLViewPrivate clear]):
        (-[WebHTMLView pasteboardChangedOwner:]):
        (-[WebHTMLView pasteboard:provideDataForType:]):
        (-[WebHTMLView namesOfPromisedFilesDroppedAtDestination:]):
        (-[WebHTMLView WebCore::]):
        (-[WebHTMLView setPromisedDragTIFFDataSource:WebCore::]):
          Use CachedImage rather than DOMElement as promised data source
          
        * WebView/WebHTMLViewInternal.h:
        * WebView/WebHTMLViewPrivate.h:

2007-05-18  Tristan O'Tierney  <tristan@apple.com>

        Reviewed by Brady E.

        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::download):
        asked the webframeloaderclient for its webview's history and 
        injected the originated url into the created WebDownload

2007-05-18  John Sullivan  <sullivan@apple.com>

        Reviewed by Kevin Decker
        
        Improvement to WebKit part of fix for 5201499 based on more modern understanding. (That is,
        a couple of hours more modern.)

        * WebView/WebUIDelegatePrivate.h:
        add showPanel: parameter to just-introduced delegate method webView:saveFrameView:

        * WebView/WebPDFView.mm:
        (-[WebPDFView PDFViewSavePDFToDownloadFolder:]):
        pass NO for new showPanel: parameter, and update comment

2007-05-18  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by John.
        
        <rdar://problem/5204792> REGRESSION (r21367): System widgets are drawn with vertical/horizontal scroll bars
        
        No test because the bug requires calling setAllowsScrolling: to reproduce.

        * WebView/WebFrameView.mm:
        (-[WebFrameView setAllowsScrolling:]): Update the FrameView's scroll state as well as the one
        on WebDynamicScrollBarsView, otherwise this setting won't stick if the frame has already loaded
        a document.

2007-05-18  Geoffrey Garen  <ggaren@apple.com>

        Fixed spelling error.
        
        * WebView/WebViewPrivate.h:

2007-05-18  John Sullivan  <sullivan@apple.com>

        Reviewed by Kevin Decker
        
        WebKit part of fix for 5201499 (support for PDFKit UI for saving PDFs to disk)
        
        Also, the PDFKit mechanism for notifying clients about "Open File Externally" was
        changed from a notification to a delegate method. The notification was new to 
        Leopard, so removing it doesn't affect clients in the field.

        * WebView/WebUIDelegatePrivate.h:
        Declared new UI delegate method webView:saveFrameView:, analogous to the existing
        webView:printFrameView:

        * WebView/WebPDFView.mm:
        removed declaration of _webkit_PDFKitLaunchNotification
        (-[WebPDFView viewDidMoveToWindow]):
        don't observe _webkit_PDFKitLaunchNotification
        (-[WebPDFView viewWillMoveToWindow:]):
        ditto
        (-[WebPDFView PDFViewOpenPDFInNativeApplication:]):
        new PDFKit delegate method, replaces our use of _webkit_PDFKitLaunchNotification
        (-[WebPDFView PDFViewSavePDFToDownloadFolder:]):
        new PDFKit delegate method, calls through to new WebKit UI delegate method
        
2007-05-17  Oliver Hunt  <oliver@apple.com>

        Reviewed by Justin.

        Fix for <rdar://problem/4244861> Safari fails to create image file
        after releasing dragged image that has changed on source page

        This patch fixes this bug by manually creating an NSFileWrapper from
        the TIFF promise data for a drag if it is available.  This bypasses
        the problem of the required resource no longer being held due to page
        loads or other constraints.
        
        We need to leave the old path in place to allow for the case where
        the promised data is not available.

        * WebCoreSupport/WebDragClient.mm:
        (WebDragClient::declareAndWriteDragImage):
          Always use the top WebHTMLView as the pasteboard owner, this is
          safe as we only use the owner for resolving promised types.
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _writeSelectionToPasteboard:]):
        (-[WebHTMLView writeSelectionToPasteboard:types:]):
          Always use the top WebHTMLView as the pasteboard owner.
        (-[WebHTMLView namesOfPromisedFilesDroppedAtDestination:]):
          Add path to create NSFileWrapper from promise data.

2007-05-17  Oliver Hunt  <oliver@apple.com>

        Reviewed by Adam.
        
        Fix for <rdar://problem/4343832> Trying to drag a large 6.2MB jpeg image
         out of Safari is unexpectedly slow (4 copies of image plus RTF document on pasteboard)
         
        This patch causes the construction of the RTF and TIFF data to be delayed until requested.
        
        We delay TIFF construction from a DOMElement as this may require generating TIFF data
        from the CachedImage, which is slow.  To allow the TIFF data to be created later the 
        it's necessary to add a reference to the source DOMElement to the view.

        * Misc/WebNSPasteboardExtras.h:
        * Misc/WebNSPasteboardExtras.mm:
        (-[NSPasteboard _web_writePromisedRTFDFromArchive:containsImage:]):
          Implements the delayed write of RTF data
        (-[NSPasteboard _web_writeImage:element:URL:title:archive:types:source:]):
          Set up the pasteboard to allow the data writing to be delayed
        (-[NSPasteboard _web_declareAndWriteDragImageForElement:URL:title:archive:source:]):
          Now we need to pass the WebHTMLView on to _web_writeImage:element:URL:title:archive:types:source:
        * WebCoreSupport/WebDragClient.mm:
        (WebDragClient::startDrag):
          Clear the dragging pasteboard once the drag has ended to ensure we don't hold references
          to anything longer than we need to.
        (WebDragClient::declareAndWriteDragImage):
          
        * WebView/WebHTMLView.mm:
        (-[WebHTMLViewPrivate dealloc]):
        (-[WebHTMLViewPrivate clear]):
        (-[WebHTMLView pasteboardChangedOwner:]):
          Make sure we clear out the DOMElement reference once it is no longer needed
        (-[WebHTMLView pasteboard:provideDataForType:]):
          Provide delayed data
        (-[WebHTMLView _writeSelectionToPasteboard:]):
          Make sure we set pasteboard ownership correctly
        (-[WebHTMLView promisedDragTIFFDataSource]):
        (-[WebHTMLView setPromisedDragTIFFDataSource:]):
        (-[WebHTMLView writeSelectionToPasteboard:types:]):
        * WebView/WebHTMLViewInternal.h:
        * WebView/WebHTMLViewPrivate.h:
        
        * WebView/WebView.mm:
        (-[WebView _writeImageForElement:withPasteboardTypes:toPasteboard:]):

2007-05-16  Anders Carlsson  <andersca@apple.com>

        Reviewed by Darin.

        <rdar://problem/5207156> Hamachi test tool causes assertion in FormCompletionController in Safari

        Update for WebCore changes.
        
        * WebView/WebFrame.mm:
        (-[WebFrame _loadURL:referrer:intoChild:]):

2007-05-15  Oliver Hunt  <oliver@apple.com>

        Reviewed by Sam and Geoff.
        
        Removing dead code left behind from drag and drop refactoring.

        * WebCoreSupport/WebFrameBridge.mm:
        * WebView/WebHTMLView.mm:
        * WebView/WebHTMLViewPrivate.h:

2007-05-15  Bruce Q Hammond  <bruceq@apple.com>

        Reviewed by Darin.

        Correction of previous patch for http://bugs.webkit.org/show_bug.cgi?id=13578
        This corrects the sign of the Y-Axis origin adjustment.

        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView saveAndSetNewPortStateForUpdate:]):

2007-05-15  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Maciej Stachowiak.
        
        Patch: fixed <rdar://problem/5198890> .5% performance regression caused 
        by r21307
        
        The only code r21307 added that runs during the PLT is a frame load delegate
        -respondsToSelector: call inside windowObjectCleared(), so it seems like 
        our message dispatch overhead for the frame load delegate is significant.
        
        This patch is a straight port of Maciej's fix for the same problem in the
        resource load delegate. The solution is simple enough: don't use Objective-C. 
        Instead, use a special structure that caches which methods the delegate 
        implements, along with pointers to those methods.
        
        I verified each frame load delegate callback in the debugger, except for
        -webView:didFailLoadWithError:forFrame:, which is not implemented by Safari
        or DumpRenderTree.

        * WebKit/DefaultDelegates/WebDefaultFrameLoadDelegate.h: Removed.
        * WebKit/DefaultDelegates/WebDefaultFrameLoadDelegate.m: Removed.

        * WebCoreSupport/WebFrameBridge.mm:
        (-[WebFrameBridge windowObjectCleared]): I also removed a misleading 
        comment here. The JS debugger caches the windowScriptObject, so you do
        need to re-create the debugger every time you invalidate the old 
        WebScriptObject wrapper for the window object and create a new one, or
        the debugger will stop working. We could fix this in a number of ways, 
        but <rdar://problem/4608404> is not the key issue.

2007-05-15  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Hyatt and Lars.
        
        - fixed <rdar://problem/5201758> REGRESSION: Stop button enabled and other problems caused by [WebView currentURL] returning non-nil for empty window
        
        * WebView/WebDataSource.mm:
        (-[WebDataSource request]): Return nil when we are still showing the initial empty doc

2007-05-14  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Darin Adler.
        
        Updated for WebCore move to PageCache singleton. Also removed some WebCore::
        prefixes and replaced them with 'using namespace WebCore'.

        * History/WebHistoryItem.mm:
        (+[WebHistoryItem _releaseAllPendingPageCaches]):
        (-[WebWindowWatcher windowWillClose:]):

2007-05-13  Darin Adler  <darin@apple.com>

        - one more retain/release for a tiny bit more robustness

        * WebView/WebPDFView.mm:
        (-[WebPDFView _updatePreferences:]): [prefs release]
        (-[WebPDFView _updatePreferencesSoon]): [prefs retain]

2007-05-13  Darin Adler  <darin@apple.com>

        Reviewed by Geoff.

        - fix <rdar://problem/5188400> Webkit crashes going back from PDF at perl.org site

        * WebView/WebPDFView.h: Replace _updatePreferencesTimer with _willUpdatePreferencesSoon BOOL.
        Also remove unneeded @public that gives other classes access to our dataSource member.

        * WebView/WebPDFView.mm: Rearrange top of file a bit, remove forward declaration of the
        _cancelUpdatePreferencesTimer method.
        (-[WebPDFView dealloc]): Removed call to _cancelUpdatePreferencesTimer.
        (-[WebPDFView _updatePreferencesNow:]): Added WebPreferences parameter. This sidesteps problems
        where the dataSource is no longer present by not looking at the dataSource field at all.
        Also removed the call to _cancelUpdatePreferencesTimer, added code to set _willUpdatePreferencesSoon
        to NO and added a release to balance a retain I did in _updatePreferencesSoon.
        (-[WebPDFView _updatePreferencesSoon]): Changed to use performSelectorAfterDelay instead of
        an NSTimer. Pass in the preferences object as a parameter, since we might not be able to get to
        the dataSource when the timer fires.

2007-05-10  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Darin Adler.
        
        "IconDatabase::sharedIconDatabase()" => "iconDatabase()" for terseness.

2007-05-10  Adele Peterson  <adele@apple.com>

        Reviewed by Hyatt.

        WebKit part of fix for <rdar://problem/4100616> Doing a "find" in RSS doesn't scroll to result

        Updated to use selectionRect instead of visibleSelectionRect.  selectionRect() now returns the visible rect by default.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _lookUpInDictionaryFromMenu:]):
        (-[WebHTMLView selectionImageRect]):

2007-05-10  dethbakin  <bdakin@apple.com>

        Reviewed by Darin.

        Fix for <rdar://problem/5191941> Leopard: Adobe Acrobat 8: 
        Distiller 8 needs same check fix as 4992521

        * WebView/WebView.mm:
        (-[WebView _updateWebCoreSettingsFromPreferences:]): Adobe 
        Distiller needs the same quirk.

2007-05-10  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Oliver.

        - WebKit part of fix for:
        <rdar://problem/5063277> blank screen after login to Citibank Online (accessing document before frame starts loading cancels load)
        <rdar://problem/5159541> REGRESSION (r20972): Wall Street Journal pages replaced by advertisements (13465)

        The basic approach is to have Frames start out containing an empty document instead of absolutely nothing,
        so there is no need to initialize them on demand. Various side effects of that cause both of these bugs.
        
        However, this caused many regressions so I had to fix the fallout.

        * WebCoreSupport/WebChromeClient.mm:
        (WebChromeClient::takeFocus): Avoid focus cycle problems (can happen in DumpRenderTree
        with initial empty document now).
        * WebCoreSupport/WebFrameBridge.mm:
        (-[WebFrameBridge finishInitializingWithPage:frameName:frameView:ownerElement:]): init the frame.
        (-[WebFrameBridge determineObjectFromMIMEType:URL:]): return image type when appropriate
        * WebView/WebFrame.mm:
        (-[WebFrame stopLoading]): use stopForUserCancel().
        * WebView/WebFrameView.mm:
        (-[WebFrameView _makeDocumentViewForDataSource:]): assume html when no mime type available.
        * WebView/WebView.mm:
        (-[WebView becomeFirstResponder]): Track whether we are becoming first responder from
        outside the view.
        (-[WebView _becomingFirstResponderFromOutside]): Return this value.
        * WebView/WebViewInternal.h:

2007-05-09  Oliver Hunt  <oliver@apple.com>

        rs=Adele.

        The previous patch (r21346) broke editing, rolling out

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _interceptEditingKeyEvent:shouldSaveCommand:]):
        (-[WebHTMLView doCommandBySelector:]):

2007-05-09  Adele Peterson  <adele@apple.com>

        Reviewed by Oliver.
        
        Re-applying fix for <rdar://problem/5107538> REGRESSION: Page scroll when selecting characters from inline input candidate window by arrow buttons
        http://bugs.webkit.org/show_bug.cgi?id=13263
        
        We don't need to call interpretKeyEvents for cmd-key events as
        they events will be interpreted by performKeyEquivalent.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _interceptEditingKeyEvent:shouldSaveCommand:]):
        (-[WebHTMLView doCommandBySelector:]):

2007-05-09  Mark Rowe  <mrowe@apple.com>

        Build fix to keep the buildbot happy.

        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView saveAndSetNewPortStateForUpdate:]):

2007-05-08  Bruce Q Hammond  <bruceq@apple.com>

        Reviewed by Darin.

        http://bugs.webkit.org/show_bug.cgi?id=13578
        Bug 13578: When QD plugins draw to an offscreen bitmap the origin is not correct

        Now we have correct handling of the origin when QD plugins draw to
        offscreen bitmaps.
        Also the clipping code for this path was doing unnecessary work which
        caused incorrect results; it has been removed.
        
        This change should not affect Safari and in general will only affect
        plugins (e.g. Flash) drawing to a CGBitmapContext.

        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView saveAndSetNewPortStateForUpdate:]):

2007-05-08  Steve Falkenburg  <sfalken@apple.com>

        Reviewed by Darin.

        Implemented spelling/grammar related WebEditorClient methods.

        * WebCoreSupport/WebEditorClient.h:
        * WebCoreSupport/WebEditorClient.mm:
        (WebEditorClient::ignoreWordInSpellDocument): Added. Call through to NSSpellChecker.
        (WebEditorClient::learnWord): Added. Call through to NSSpellChecker.
        (WebEditorClient::checkSpellingOfString): Added. Call through to NSSpellChecker.
        (WebEditorClient::checkGrammarOfString): Added. Call through to NSSpellChecker.
        (WebEditorClient::updateSpellingUIWithGrammarString): Added. Call through to NSSpellChecker.
        (WebEditorClient::updateSpellingUIWithMisspelledWord): Added. Call through to NSSpellChecker.
        (WebEditorClient::showSpellingUI): Added. Call through to NSSpellChecker.
        (WebEditorClient::spellingUIIsShowing): Added. Call through to NSSpellChecker.
        (WebEditorClient::getGuessesForWord): Added. Call through to NSSpellChecker.

2007-05-08  Steve Falkenburg  <sfalken@apple.com>

        Reviewed by Ada.

        Slight modification to last editor method fix.

        * WebCoreSupport/WebEditorClient.h:
        (WebEditorClient::updateSpellingUIWithGrammarString):

2007-05-07  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Maciej Stachowiak.
        
        Fixed <rdar://problem/5140447> API for fetching JSGlobalContextRef from 
        WebView or WebFrame
        
        Added -[WebFrame windowObject] and -[WebFrame globalContext], along with
        a new frame load delegate method, - (void)webView:(WebView *)webView 
        didClearWindowObject:(WebScriptObject *)windowObject forFrame:(WebFrame *)frame.
        This is all to support briding between the WebScriptObject and JavaScriptCore
        APIs.

        Also fixed more of <rdar://problem/4395622> API: WebScriptObject.h incorrectly 
        reports that -isSelectorExcludedFromWebScript returns NO by default, and
        generally cleaned up the WebScriptObject headerdoc.

        * WebCoreSupport/WebFrameBridge.mm:
        (-[WebFrameBridge windowObjectCleared]):
        * WebView/WebFrame.mm:
        (-[WebFrame windowObject]):
        (-[WebFrame globalContext]):
        * WebView/WebFramePrivate.h:
        * WebView/WebViewPrivate.h:

2007-05-07  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Darin.

        <rdar://problem/5180384> webView:validateUserInterfaceItem:defaultValidation: does not get called on WebUIDelegates

        Call the delegate when the one of our views gets a validateUserInterfaceItem: call.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView validateUserInterfaceItemWithoutDelegate:]): Validate without the delegate.
        (-[WebHTMLView validateUserInterfaceItem:]): Call the delegate with the result of validateUserInterfaceItemWithoutDelegate:.
        * WebView/WebPDFView.mm:
        (-[WebPDFView validateUserInterfaceItemWithoutDelegate:]): Validate without the delegate.
        (-[WebPDFView validateUserInterfaceItem:]): Call the delegate with the result of validateUserInterfaceItemWithoutDelegate:.
        * WebView/WebView.mm:
        (-[WebView _responderValidateUserInterfaceItem:]): Call validateUserInterfaceItemWithoutDelegate: to prevent asking the delegate twice.
        (-[WebView validateUserInterfaceItemWithoutDelegate:]): Validate without the delegate.
        (-[WebView validateUserInterfaceItem:]): Call the delegate with the result of validateUserInterfaceItemWithoutDelegate:.

2007-05-07  Brady Eidson  <beidson@apple.com>

        Actually finish the code move from my last checkin

        * History/WebHistoryItem.mm:
        (-[WebHistoryItem _transientPropertyForKey:]):
        (-[WebHistoryItem _setTransientProperty:forKey:]):

2007-05-07  Brady Eidson  <beidson@apple.com>

        Rubberstamped by Kevin (Sarge)

        Make _transientPropertyForKey: and _setTransientProperty:forKey: SPI

        * History/WebHistoryItemInternal.h:
        * History/WebHistoryItemPrivate.h:

2007-05-04  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Tim Hatcher.

        First step in fixing <rdar://problem/5055182> The back cache has no global cap

        Stop giving SnapBack infinite cache-ability. Instead, make SnapBack rely
        on the underlying back cache.
        
        I left -setAlwaysAttemptToUsePageCache: as an empty stub because we don't 
        want to break Safari 2.0, but I removed its header declaration so nobody 
        else starts using it.

        * History/WebHistoryItem.mm:
        (-[WebHistoryItem setAlwaysAttemptToUsePageCache:]):
        * History/WebHistoryItemPrivate.h:

2007-05-04  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Brady Eidson.
        
        Some cleanup in preparation for fixing <rdar://problem/5055182> The 
        back/forward cache has no global cap
        
        Unified naming of WebKit/WebCore b/f lists -- instead of the potpourri 
        of webBackForwardList, backForwardList, list, kitList, coreList, listWrapper, 
        and webCoreBackForwardList, we use webBackForwardList for WebKit and 
        backForwardList for WebCore, matching their respective class names.
        
        Removed "private" versions of kit() and core() -- kit() and core() are
        canonically used for converting between WebKit API objects and WebCore
        API objects. I think it's clearer to have only one way to do this.

        Removed COMPUTE_DEFAULT_PAGE_CACHE_SIZE, since it was unused.
        
        Removed _clearPageCache, since it was unused and it duplicated -setPageCacheSize:0.

        Removed _usesPageCache, since it was unused and it duplicated -pageCacheSize.

2007-05-04  Brady Eidson  <beidson@apple.com>

        Reviewed by Mark Rowe

        Added main thread assertion to WebHTMLView to help make sure 3rd party clients aren't trying
        to draw on secondary threads

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView drawRect:]): Added ASSERT_MAIN_THREAD()

2007-05-04  Anders Carlsson  <andersca@apple.com>

        Reviewed by Antti.

        <rdar://problem/5179977> Use the correct URLs when dispatching delegate methods for data loads.

        * WebView/WebFrame.mm:
        (-[WebFrame _loadData:MIMEType:textEncodingName:baseURL:unreachableURL:]):
        If the base URL is nil, set it to "about:blank", and set the response URL to a generated applewebdata URL.
        
        * WebView/WebView.mm:
        (+[WebView _canHandleRequest:]):
        No need to special-case applewebdata URLs here anymore, they're only used in responses.

2007-05-03  Steve Falkenburg  <sfalken@apple.com>

        Reviewed by Oliver.

        Add missing user description parameter to spelling-related editor client method.

        * WebCoreSupport/WebEditorClient.h:
        (WebEditorClient::updateSpellingUIWithGrammarString):

2007-05-03  TImothy Hatcher  <timothy@apple.com>

        Reviewed by Kevin.

        <rdar://problem/4975212> REGRESSION: With NetNewsWire 2.1.1, the contextual menu shows extra menu items when focus
        is placed in input or textarea field

        The NetNewsWire UI delegate isn't expecting calls for form controls, so we need to do a linked-on-or-after check.
        If the application was linked against Tiger or earlier and the element is a text form control, just return the
        default menu items and bypass the delegate call completely.

        * WebCoreSupport/WebContextMenuClient.mm:
        (isPreVersion3Client): Cache the result of the WebKitLinkedOnOrAfter call
        (fixMenusToSendToOldClients): Call the new isPreVersion3Client()
        (fixMenusReceivedFromOldClients): Ditto.
        (WebContextMenuClient::getCustomMenuFromDefaultItems): Return the default menu items if the element is a text form control.

2007-05-03  Mark Rowe  <mrowe@apple.com>

        Reviewed by Geoff and Kevin.

        <rdar://problem/5141290> WebAssertions.h is still needed by some internal clients

        Second shot at fixing this error.  Stub out the macros rather than forwarding to JavaScriptCore, which would
        leave clients using this header trying to resolve JavaScriptCore symbols against WebKit when linking.  This
        should only happen in production builds when assertions should be disabled anyway as anyone building a
        development configuration should be in a position to move away from using this header.

        * Misc/WebAssertions.h: 

2007-05-03  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Kevin.

        <rdar://problem/5067707> REGRESSION: "Open Link" contextual menu item appears twice in Mail

        Remove the check for Mail in fixMenusToSendToOldClients and fixMenusReceivedFromOldClients
        when linked on or after Leopard. The isAppleMail() function is still used for Tiger Mail fixups.

        * WebCoreSupport/WebContextMenuClient.mm:
        (fixMenusToSendToOldClients):
        (fixMenusReceivedFromOldClients):

2007-05-02  Anders Carlsson  <andersca@apple.com>

        Reviewed by Brady.

        <rdar://problem/5151113> Assertion firing in [FrameProgressEntry addChild:forDataSource:] when navigating cnn.com
        
        The assertion fired because a plug-in was trying to load a subresource when a new load had started but not yet
        committed. The check that would have prevented this was removed in order to fix <rdar://problem/5085897>.
        
        This puts back the check but changes it to allow loads where the target is the same frame as the plugin's parent frame.
        
        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView loadRequest:inTarget:withNotifyData:sendNotification:]):

2007-04-27  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Darin.

        There were only a couple calls to ResourceLoadDelegate forwarder left,
        this removes the calls and adds a new cached method for didFailLoad.

        * WebKit/DefaultDelegates/WebDefaultResourceLoadDelegate.h: Removed.
        * WebKit/DefaultDelegates/WebDefaultResourceLoadDelegate.m: Removed.
        * WebKit/Plugins/WebNullPluginView.mm: Call the resource load delegate directly.
        * WebKit/WebCoreSupport/WebFrameLoaderClient.mm: Call the cached didFailLoad delegate function.
        * WebKit/WebKit.xcodeproj/project.pbxproj: Remove WebDefaultResourceLoadDelegate.
        * WebKit/WebView/WebDataSource.mm: Remove the #import for WebDefaultResourceLoadDelegate.h
        * WebKit/WebView/WebView.mm: Remove the ResourceLoadDelegate forwarder, and remove a method that isn't used.
        * WebKit/WebView/WebViewInternal.h: Ditto.
        * WebKit/WebView/WebViewPrivate.h: Remove a method that is no longer used.

2007-04-27  David Harrison  <harrison@apple.com>

        Reviewed by Darin.

        <rdar://problem/5160627> Export JS list creation support as ObjC SPI for Mail

        * WebKit.xcodeproj/project.pbxproj:
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _selectedRange]):
        (-[WebHTMLView _shouldDeleteRange:]):
        (-[WebHTMLView _canEdit]):
        (-[WebHTMLView _canEditRichly]):
        (-[WebHTMLView _hasSelection]):
        (-[WebHTMLView _hasSelectionOrInsertionPoint]):
        (-[WebHTMLView _hasInsertionPoint]):
        (-[WebHTMLView _isEditable]):
        Condense the check for nil [self frame].
        Remove canEditRichly checks and rely on the editor to do the check instead.
        
        (-[WebHTMLView _insertOrderedList]):
        (-[WebHTMLView _insertUnorderedList]):
        New.
        
        (-[WebHTMLView _canIncreaseSelectionListLevel]):
        (-[WebHTMLView _canDecreaseSelectionListLevel]):
        (-[WebHTMLView _increaseSelectionListLevel]):
        (-[WebHTMLView _increaseSelectionListLevelOrdered]):
        (-[WebHTMLView _increaseSelectionListLevelUnordered]):
        (-[WebHTMLView _decreaseSelectionListLevel]):
        Moved from bridge to frame editor.

        * WebView/WebHTMLViewPrivate.h:
        Add _insertOrderedList and _insertUnorderedList to WebHTMLView(WebPrivate)

2007-04-27  Brady Eidson  <beidson@apple.com>

        Rubberstamped by Mark

        Remove default implementation of UIDelegate method that was removed

        I have also been instructed to give Tim a hard time about this one - apparently
        it was his job to clean it out and he failed...  failed miserably.

        :)

        * DefaultDelegates/WebDefaultUIDelegate.m: Removed webViewPrint:

2007-04-27  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Mark.
        
        <rdar://problem/5154113> Repro ASSERT (would be crash) in KJS::GCLock::GCLock (13462)
        http://bugs.webkit.org/show_bug.cgi?id=13462

        * WebInspector/WebInspector.m:
        (-[WebInspectorPrivate dealloc]): Delay release of WebView to avoid GC re-entrancy.

2007-04-27  Anders Carlsson  <andersca@apple.com>

        Reviewed by Mitz.

        <rdar://problem/5165755>
        View Source is broken; empty window is shown
        
        Return YES for applewebdata URLs.
        
        * WebView/WebView.mm:
        (+[WebView _canHandleRequest:]):

2007-04-26  Oliver Hunt  <oliver@apple.com>

        Reviewed by Adam.

        Fix <rdar://problem/5061252> REGRESSION: In Gmail, image fails 
        to be inserted into message field after dragging

        Don't try to create <img> tags for local image files as it results
        in the potential to submit forms that look like they have an image,
        when in reality they don't.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _documentFragmentWithPaths:]):

2007-04-26  Anders Carlsson  <andersca@apple.com>

        Reviewed by Maciej.

        <rdar://problem/5049099> documents no longer have a default base URL
        
        If the base URL is nil, then create a unique applewebdata URL to match what Tiger WebKit does.
        
        * WebView/WebFrame.mm:
        (createUniqueWebDataURL):
        (-[WebFrame _loadData:MIMEType:textEncodingName:baseURL:unreachableURL:]):

2007-04-25  Oliver Hunt  <oliver@apple.com>

        Rubber stamped by Adele.

        Roll out WebKit changes from from r21052 to fix regression noted in
        <rdar://problem/5159556> REGRESSION: In Mail, pressing option-command- ' doesn't decrease block quote in selection

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _interceptEditingKeyEvent:shouldSaveCommand:]):
        (-[WebHTMLView doCommandBySelector:]):

2007-04-25  Steve Falkenburg  <sfalken@apple.com>

        Reviewed by Adam.

        Mac callbacks for new spelling methods in WebEditorClient.
        Not used yet.

        * WebCoreSupport/WebEditorClient.h:
        (WebEditorClient::ignoreWordInSpellDocument):
        (WebEditorClient::learnWord):
        (WebEditorClient::checkSpellingOfString):
        (WebEditorClient::checkGrammarOfString):
        (WebEditorClient::updateSpellingUIWithGrammarString):
        (WebEditorClient::updateSpellingUIWithMisspelledWord):
        (WebEditorClient::showSpellingUI):
        (WebEditorClient::spellingUIIsShowing):
        (WebEditorClient::getGuessesForWord):

2007-04-24  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Darin Adler, Tim Hatcher.

        Fixed a few NSAutoreleasePool issues I noticed while reviewing Brady's patch.

        * Carbon/CarbonUtils.m:
        (PoolCleaner): Call -drain instead of -release, since -release is a 
        no-op in a GC world.

        * Misc/WebKitErrors.m:
        (registerErrors): Condensed onto one line.

        * Plugins/WebPluginDatabase.m:
        (-[WebPluginDatabase refresh]): Call -drain instead of -release, since
        -release is a no-op in a GC world.

        * WebCoreSupport/WebChromeClient.mm:
        (WebChromeClient::setStatusbarText):

        * WebInspector/WebNodeHighlightView.m:
        (-[WebNodeHighlightView initWithHighlight:andRects:forView:]): Don't drain
        and then release because drain deallocates the receiver, so the release
        is an over-release.

        * WebView/WebView.mm:
        (-[WebView rectsForTextMatches]): Re-allocate the pool after draining it,
        because drain deallocates the receiver, so the drain would leave you without
        any autorelease pool, causing a leak and then an over-release at the bottom
        of the loop.

2007-04-24  Brady Eidson  <beidson@apple.com>

        Reviewed by Beth, Hyatt, Ada, and Darin

        <rdar://problem/5011477> and <rdar://problem/5011514>
        Provide support for the icon.db to be moved to a different directory from the old WebKit-style
        icons, and remove the old directory if that is the case

        * Misc/WebIconDatabase.mm:
        (-[WebIconDatabase init]):
        (-[WebIconDatabase _importToWebCoreFormat]): Check "imported()" to determine if a conversion is needed
          - Look for WebIconDatabaseImportDirectoryDefaultsKey for the source location for the conversion
          - Set "imported" to true in the Icons.db
          - If the new Icons.db isn't in the same patch as the old icons, delete the entire directory when finished
          - Move old icon.db to Icons.db to reflect rename
        * Misc/WebIconDatabasePrivate.h: Add WebIconDatabaseImportDirectoryDefaultsKey so a WebKit client can tell WebKit
          where to look for the old icons if their location is different from the icon.db
        * WebKit.exp:

2007-04-24  Mitz Pettel  <mitz@webkit.org>

        Reviewed by Oliver Hunt.

        Changed an apostrophe (') into a right single quotation mark (U+2019).

        * WebInspector/webInspector/inspector.js:

2007-04-24  Mitz Pettel  <mitz@webkit.org>

        Reviewed by Timothy Hatcher.

        - fix http://bugs.webkit.org/show_bug.cgi?id=13459
          The "mapped style" link next to an attribute doesn't work

        * WebInspector/webInspector/inspector.js: Added a check that the rule is
        mapped from an attribute.

2007-04-23  Adele Peterson  <adele@apple.com>

        Fixed and reviewed by Darin, Adele, and Oliver.

        WebKit part of fix for <rdar://problem/5107538> REGRESSION: Page scroll when selecting characters from inline input candidate window by arrow buttons
        http://bugs.webkit.org/show_bug.cgi?id=13263

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _interceptEditingKeyEvent:shouldSaveCommand:]):  If we have no command after calling interpretKeyEvents, we assume the input method handled the key.
        (-[WebHTMLView doCommandBySelector:]): Add noop: to the command vector, but then when actually performing actions, ignore it.

2007-04-23  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Darin.

        <rdar://problem/5124364> IB3 crashes when loading a nib containing a WebView that has a WebHTMLView encoded inside

        Since WebView's initWithCoder throws away all the decoded subviews, the WebHTMLView gets dealoced while it has a nil _private pointer.
        Checking for a nil _private in WehHTMLView's close fixes this crash. No need to implement a full initWithCoder for WebHTMLView since
        it will be thrown away by the WebView anyway.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView close]): Return earily if _priviate is nil.
        (-[WebHTMLView initWithFrame:]): Unrelated change that removes an AppKit version check that predates Tiger.

2007-04-23  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Mark Rowe.

        Remove the "No Selection" message after leaving search mode.
        This was a regression caused by the inspector refresh.

        * WebInspector/webInspector/inspector.js:

2007-04-23  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Darin.

        Bug 6658: World leak when closing inspected window
        http://bugs.webkit.org/show_bug.cgi?id=6658 and <rdar://problem/4411863>

        Removes over-retains of the inspector WebView, WebInspector and WebInspectorPanel.

        * WebInspector/WebInspector.m:
        (+[WebInspector sharedWebInspector]): Return the global sharedWebInspector variable.
        (-[WebInspector window]): Release the window after calling setWindow:.
        (-[WebInspector windowWillClose:]): Set the JavaScript Inspector variable to null and expire the current highlight.
          Also clear the global sharedWebInspector variable and release it if self equals sharedWebInspector.
        (-[WebInspector showWindow:]): Set the JavaScript Inspector variable back to self.
        * WebInspector/WebInspectorInternal.h: Remove the isSharedInspector member variable.
        * WebView/WebView.mm:
        (-[WebView windowScriptObject]): Return nil if core([self mainFrame]) is NULL.

2007-04-23  Darin Adler  <darin@apple.com>

        Reviewed by Hyatt.

        - rename box-sizing to -webkit-box-sizing

        * WebInspector/webInspector/inspector.css: Here.
        * WebInspector/webInspector/inspector.js: And here, in the expected default CSS values list.

2007-04-22  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Darin.

        The fix for <rdar://problem/4976681> ASSERTION failure on quit @ talkcrunch.com in _NPN_ReleaseObject
        was #ifdefed out in Production builds.

        * WebView/WebView.mm:
        (+[WebView initialize]): Move the #ifdef REMOVE_SAFARI_DOM_TREE_DEBUG_ITEM inside initialize around the specific code
        (+[WebView _applicationWillTerminate]): Moved outside the #ifdef REMOVE_SAFARI_DOM_TREE_DEBUG_ITEM block

2007-04-22  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Mitz.

        Bug 13436: Make Option-clicking a disclosure triangle expand the entire subtree
        http://bugs.webkit.org/show_bug.cgi?id=13436

        Makes option-click recursively expand and collapse the sub-tree. Pressing option-left
        and -right also recursively expands and collapses the sub-tree.

        * WebInspector/webInspector/treeoutline.js:

2007-04-22  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Mitz.

        Bug 13437: Inspector does not update when navigating to a different page
        http://bugs.webkit.org/show_bug.cgi?id=13437

        * WebInspector/webInspector/inspector.js: Correctly update to a new root node
          if the new focus node and the old focus node don't have a common ancestor.

2007-04-22  Darin Adler  <darin@apple.com>

        Reviewed by Adele.

        - fix for <rdar://problem/5100240> REGRESSION: Control-O broken

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _interceptEditingKeyEvent:shouldSaveCommand:]): Update to handle a vector of
        command names instead of a single command.
        (-[WebHTMLView doCommandBySelector:]): Change logic so that we add the command to a vector
        and also so that the interpretKeyEvents parameters are still intact for a second call to
        doCommandBySelector:, since the key bindings mechanism can do more than one.
        (-[WebHTMLView insertText:]): Added comment.

2007-04-21  Darin Adler  <darin@apple.com>

        Reviewed by Oliver.

        - fix some problems I ran into using the inspector

        * WebInspector/webInspector/inspector.js: Add some null checks.

2007-04-20  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Darin.

        Merge over the WebInspectorRefresh branch. This change removes the NSOutlineView and
        is replaced with a HTML/JavaScript tree. Most of the inspector logic is now in the JavaScript.

        A few bugs are fixed by these changes:

        Bug 6615: Parent node drop-down list is upside-down
        http://bugs.webkit.org/show_bug.cgi?id=6615

        Bug 6643: REGRESSION: Tree view repaints lines without erasing them first
        http://bugs.webkit.org/show_bug.cgi?id=6643

        Bug 6650: Web Inspector HTML Hierarchy can't be scrolled with scrollwheel
        http://bugs.webkit.org/show_bug.cgi?id=6650

        Bug 6677: Can't drag inspector when tree view has focus
        http://bugs.webkit.org/show_bug.cgi?id=6677

        Bug 7326: Web Inspector tree scrollbar always shows up when resizing the top pane down
        http://bugs.webkit.org/show_bug.cgi?id=7326

        * WebInspector/WebInspector.h: Removed the searchQuery methods.
        * WebInspector/WebInspector.m: Removed the DOMNode category and code for the old outline view.
        * WebInspector/WebInspectorOutlineView.h: Removed.
        * WebInspector/WebInspectorOutlineView.m: Removed.
        * WebInspector/WebInspectorInternal.h: Remove some methods and instance variables.
        * WebInspector/webInspector/Images/resize.png: Added.
        * WebInspector/webInspector/inspector.css: 
        * WebInspector/webInspector/inspector.html: Include the new classes and remove the plugin.
        * WebInspector/webInspector/inspector.js: Changes to use the new tree outline and other fixes.
        * WebInspector/webInspector/scrollarea.js: Copied from the Dashboard widget resources.
        * WebInspector/webInspector/scrollbar.js: Ditto.
        * WebInspector/webInspector/treeoutline.js: New tree outline class.
        * WebInspector/webInspector/utilities.js: DOM and String prototype additions.
        * WebKit.xcodeproj/project.pbxproj: Remove WebInspectorOutlineView.

2007-04-20  Brady Eidson  <beidson@apple.com>

        Reviewed by Oliver (Black Sheep)

        <rdar://problem/3559794>
        [WebView setMaintainsBackForwardList:] doesn't actually flush out the current page caches

        * WebView/WebView.mm: Remove _private->useBackForwardList
        (-[WebView _setInitiatedDrag:]): Use _private->page instead of [self page]
        (-[WebView initWithCoder:]): Manipulate the flag that is now in WebCore::BackForwardList
        (-[WebView encodeWithCoder:]): Ditto
        (-[WebView backForwardList]): Use _private->page instead of [self page]
        (-[WebView setMaintainsBackForwardList:]): Manipulate the flag that is now in WebCore::BackForwardList

2007-04-20  Anders Carlsson  <andersca@apple.com>

        Reviewed by Maciej.

        <rdar://problem/5085897> REGRESSION: Some Flash links at www.jumpskyhigh.com just reload the page
        
        Get rid of the check that would prevent plugin requests from being loaded if a new page load was underway.
        www.jumpskyhigh.com had a flash movie that was embedded inside an <a> tag and clicking on the plug-in would cause the
        URL pointed to by the <a> tag to start loading and thus preventing the plug-in from loading the real URL.
        
        This check was added by Maciej and we should be able to remove it with the loader changes that have happened now,
        (mainly the fact that resource loaders are handled by the document loader instead of the frame loader).
        
        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView loadRequest:inTarget:withNotifyData:sendNotification:]):

2007-04-19  Oliver Hunt  <oliver@apple.com>

        Reviewed by Adam.

        Fix for <rdar://problem/4960912> -- REGRESSION: Content-Disposition:
        filename is ignored for drag-and-drop.

        * WebView/WebResource.mm:
        (-[WebResource _fileWrapperRepresentation]):
          When creating the NSFileWrapper check the response for a preferred 
          filename, rather than just blindly hoping for the best.

2007-04-19  Anders Carlsson  <andersca@apple.com>

        Reviewed by John.

        <rdar://problem/5137002>
        REGRESSION (r20812): [WebFrame DOMDocument] is returning non-nil value in bookmarks view, causing trouble in Safari

        Put back the MIME type check as a workaround.
        * WebView/WebFrame.mm:
        (-[WebFrame DOMDocument]):

2007-04-19  Mark Rowe  <mrowe@apple.com>

        Reviewed by Oliver and Adam.

        <rdar://problem/5141290> WebAssertions.h is still needed by some internal clients.

        * Misc/WebAssertions.h: Added.
        * WebKit.xcodeproj/project.pbxproj:

2007-04-17  Brady Eidson  <beidson@apple.com>

        Reviewed by Tim

        <rdar://problem/5008925>
        Expose the NSURLConnection delegate willCacheResponse API to WebResourceLoadDelegate

        * WebCoreSupport/WebFrameLoaderClient.h:
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::willCacheResponse): Call 
          [WebResourceLoadDelegate webView:resource:willCacheResponse:fromDataSource:];

        * WebView/WebView.mm:
        (-[WebView _cacheResourceLoadDelegateImplementations]): Pull out the willCacheResponse impl

        * WebView/WebViewPrivate.h: Add WebResourceLoadDelegatePrivate category for this new SPI

2007-04-18  John Sullivan  <sullivan@apple.com>

        Reviewed by Adam

        - fixed <rdar://problem/5103009> REGRESSION: Activity window shows blank name for untitled pages

        * WebView/WebHTMLRepresentation.mm:
        (-[WebHTMLRepresentation title]):
        return nil for empty string, to match old behavior

2007-04-17  John Sullivan  <sullivan@apple.com>

        Reviewed by Tim Hatcher

        - fixed <rdar://problem/5138492> Safari doesn't remember some changes to the PDF scale and display mode 

        Some of the user interactions that could change the PDF scale and display mode were not going through
        the proxy mechanism in WebPDFView that updates preferences. Now we also listen to PDFKit notifications
        in order to catch the other cases.

        * WebView/WebPDFView.h:
        new _ignoreScaleAndDisplayModeNotifications and _updatePreferencesTimer ivars

        * WebView/WebPDFView.mm:
        (-[WebPDFView setPDFDocument:]):
        ignore scale and display mode notifications while we're setting up a fresh document
        (-[WebPDFView dealloc]):
        cancel the new timer (which releases it)
        (-[WebPDFView viewDidMoveToWindow]):
        listen for two PDFKit notifications
        (-[WebPDFView viewWillMoveToWindow:]):
        stop listening to the two PDFKit notifications
        (-[WebPDFView _applyPDFDefaults]):
        white space change
        (-[WebPDFView _cancelUpdatePreferencesTimer]):
        invalidate, release, and nil out the timer
        (-[WebPDFView _scaleOrDisplayModeChanged:]):
        update preferences soon, unless deliberately ignoring these notifications
        (-[WebPDFView _updatePreferencesNow]):
        cancel timer, then save data to preferences (code for saving the data was extracted from
        -[PDFPrefUpdatingProxy forwardInvocation:])
        (-[WebPDFView _updatePreferencesSoon]):
        use timer to consolidate multiple calls into one action; formerly we were setting preferences
        multiple times for some atomic user actions
        (-[PDFPrefUpdatingProxy forwardInvocation:]):
        call _updatePreferencesSoon where we used to immediately set preferences

2007-04-17  John Sullivan  <sullivan@apple.com>

        Reviewed by Kevin Decker

        - fixed <rdar://problem/4184640> "Look Up in Dictionary" item is always disabled for PDF pages

        * WebView/WebPDFView.mm:
        (-[WebPDFView validateUserInterfaceItem:]):
        enable "Look Up in Dictionary" only if we're using a version of PDFKit that knows how to do so
        (-[WebPDFView _canLookUpInDictionary]):
        use respondsToSelector to test whether the current version of PDFKit supports this non-API feature
        (-[WebPDFView _lookUpInDictionaryFromMenu:]):
        implement this method, which WebKit includes in the context menu when there's selected text
        (-[WebPDFView _menuItemsFromPDFKitForEvent:]):
        updated comment for this change

2007-04-16  Darin Adler  <darin@apple.com>

        Rubber stamped by Tim Hatcher.

        * WebKit.xcodeproj/project.pbxproj: Added Radar bug number to the error message
        for the "version number ending in 4" check so folks from Apple can find the
        original bug that motivated for this. To summarize what's in that bug, it says that
        <http://my.fedex.com> was failing, that it was because of the OpenCube DHTML Menu,
        and that some other affected sites were not using OpenCube (so the error is presumably
        more widespread).

2007-04-16  Darin Adler  <darin@apple.com>

        Reviewed by John Sullivan.

        - fix http://bugs.webkit.org/show_bug.cgi?id=13303
          <rdar://problem/5126341> REGRESSION: controls in a background Safari window
          maintain active appearance if the address bar has focus (13303)

        * WebView/WebHTMLView.mm: (-[WebHTMLView _windowChangedKeyState]):
        Added. Calls FrameView::updateControlTints.

2007-04-13  Oliver Hunt  <oliver@apple.com>

        Reviewed by Adam.

        Due to rdar://problem/5133910 -- WebArchives should not be constructed 
        using resource from the cache -- We may try to create a potentially 
        incorrect WebArchive when dragging an image multiple times.

        This patch retains the assertion for invalid behaviour, but adds a
        branch to make sure we don't try to do anything with the WebArchive
        in release builds.

        * Misc/WebNSPasteboardExtras.mm:
        (-[NSPasteboard _web_writeImage:element:URL:title:archive:types:]):

2007-04-13  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Dave Harrison.

        <rdar://problem/5132727> Soho Mail build fails because of renamed SPI

        * WebView/WebUIDelegatePrivate.h: define WebMenuItemTagSearchInGoogle as OldWebMenuItemTagSearchWeb

2007-04-13  Mark Rowe  <mrowe@apple.com>

        Reviewed by Oliver.

        <rdar://problem/5130686> Using WebPreferencesPrivate.h requires modifying framework search path

        * WebView/WebPreferencesPrivate.h: Remove unneeded #ifdef.

2007-04-12  Deneb Meketa  <dmeketa@adobe.com>

        Reviewed by Darin Adler.

        http://bugs.webkit.org/show_bug.cgi?id=13029
        rdar://problem/4994849
        Bug 13029: Permit NPAPI plug-ins to see HTTP response headers.

        * Plugins/WebBaseNetscapePluginStream.h: declarations.
        * Plugins/WebBaseNetscapePluginStream.mm: main implementation.
        (-[WebBaseNetscapePluginStream dealloc]): cleanup.
        (-[WebBaseNetscapePluginStream finalize]): cleanup.
        (-[WebBaseNetscapePluginStream startStreamResponseURL:expectedContentLength:lastModifiedDate:MIMEType:headers:]):
        Pass headers along.
        (-[WebBaseNetscapePluginStream startStreamWithResponse:]):
        Main work is here.  Extract headers from NSHTTPURLResponse object into a byte sequence.
        See comments here about how it would be nice to have low-level access to the HTTP response.
        (-[WebBaseNetscapePluginStream _destroyStream]): cleanup.
        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView evaluateJavaScriptPluginRequest:]):
        Conform to new startStream params.  Not applicable here, pass nil.

2007-04-12  Brady Eidson  <beidson@apple.com>

        Build fix for case sensitive file systems

        * Misc/WebNSPasteboardExtras.mm:
        * WebCoreSupport/WebPasteboardHelper.mm:

2007-04-11  John Sullivan  <sullivan@apple.com>

        Reviewed by Anders

        - WebKit part of fix for:
        <rdar://problem/5128697> REGRESSION: At least one PDF context menu item isn't appearing on Leopard

        * Misc/WebNSArrayExtras.h: Added.
        * Misc/WebNSArrayExtras.m: Added.
        (-[NSMutableArray _webkit_removeUselessMenuItemSeparators]):
        New file, includes this method to strip leading, trailing, and duplicate separators from arrays
        of NSMenuItems (copied from Safari)

        * WebView/WebUIDelegatePrivate.h:
        new MenuItemTag enum values for new PDFKit context menu items

        * WebKit.xcodeproj/project.pbxproj:
        updated for new files

        * WebView/WebPDFView.mm:
        (-[WebPDFView _anyPDFTagsFoundInMenu:]):
        check for new PDFKit context menu items
        (-[WebPDFView _menuItemsFromPDFKitForEvent:]):
        associate new PDFKit context menu item selectors with the new tags; skip certain selectors that
        correspond to menu items that WebKit already includes; remove useless menu item separators when
        we're done, since we might have removed arbitrarily-placed menu items

2007-04-11  Oliver Hunt  <oliver@apple.com>

        Reviewed by Maciej.

        Adding RetainPtr to the many global obj-c pointers we use in
        C/C++ methods.  This is necessary to prevent GC from collecting
        globals we want to keep around.

        We use RetainPtr in obj-c++ and c++ files, and CFRetain/Release in pure
        obj-c.

        This fixes <rdar://problem/5058731> -- Crash in 
        WebCore::DragData::containsCompatibleContent due to early release 
        of types array

        * Misc/WebLocalizableStrings.m:
        (WebLocalizedString):
        * Misc/WebNSPasteboardExtras.mm:
        (+[NSPasteboard _web_writableTypesForURL]):
        (_writableTypesForImageWithoutArchive):
        (_writableTypesForImageWithArchive):
        * Misc/WebNSURLExtras.m:
        (applyHostNameFunctionToMailToURLString):
        (applyHostNameFunctionToURLString):
        * Misc/WebStringTruncator.m:
        (defaultMenuFont):
        (fontFromNSFont):
        * WebCoreSupport/WebPasteboardHelper.mm:
        (WebPasteboardHelper::insertablePasteboardTypes):

2007-04-11  MorganL  <morganl.webkit@yahoo.com>

        Reviewed by Maciej.

        Add a Frame pointer to ChromeClient methods:
        http://bugs.webkit.org/show_bug.cgi?id=13127

        * COM/ChromeClientWin.cpp:
        (ChromeClientWin::createWindow):
        (ChromeClientWin::createModalDialog):
        * COM/ChromeClientWin.h:
        * WebCoreSupport/WebChromeClient.h:
        * WebCoreSupport/WebChromeClient.mm:
        (WebChromeClient::createWindow):
        (WebChromeClient::createModalDialog):

2007-04-10  Brady Eidson  <beidson@apple.com>

        Reviewed by Darin

        <rdar://problem/4887095> - PageCache and PageState should be combined

        WebKit side of the change to reflect the new object name of CachedPage and new Client method names

        * History/WebHistoryItem.mm:
        (-[WebHistoryItem setAlwaysAttemptToUsePageCache:]):
        (+[WebHistoryItem _releaseAllPendingPageCaches]):
        (-[WebWindowWatcher windowWillClose:]):

        * WebCoreSupport/WebFrameLoaderClient.h:
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::setDocumentViewFromCachedPage):
        (WebFrameLoaderClient::loadedFromCachedPage):
        (WebFrameLoaderClient::saveDocumentViewToCachedPage):

2007-04-09  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Maciej Stachowiak.
        
        Support for fixing fast/forms/textarea-paste-newline.html.
        
        Added SPI for specifying whether a WebView should allow pasting through the 
        DOM API.

        * ChangeLog:
        * WebKit.xcodeproj/project.pbxproj:
        * WebView/WebPreferenceKeysPrivate.h:
        * WebView/WebPreferences.m:
        (+[WebPreferences standardPreferences]):
        (-[WebPreferences isDOMPasteAllowed]):
        (-[WebPreferences setDOMPasteAllowed:]):
        * WebView/WebPreferencesPrivate.h:
        * WebView/WebView.mm:
        (-[WebView _updateWebCoreSettingsFromPreferences:]):

2007-04-09  Anders Carlsson  <andersca@apple.com>

        Reviewed by John.

        <rdar://problem/5081860>
        REGRESSION: Select All for standalone image has no visible effect but does change state
        
        <rdar://problem/5081840>
        REGRESSION: context menu in white space beyond standalone image is different after Select All
        
        Have validateUserInterface emulate the old behavior for full-frame images and plugins, which is:
        
        - For full-frame plugins, always return false.
        - For images, only return true if the selector is copy: and the image has finished loading.
        
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView validateUserInterfaceItem:]):

2007-04-09  Anders Carlsson  <andersca@apple.com>

        Reviewed by Darin.

        <rdar://problem/5026893>
        REGRESSION: "Mail Contents of this Page" for standalone image in Safari results in a broken image in Mail
        
        * WebView/WebFrame.mm:
        (-[WebFrame DOMDocument]):
        We can't check for _isHTMLDocument here since image and plugin documents inherit from HTMLDocument. Instead,
        check for those two document types explicitly.
        
2007-04-09  Anders Carlsson  <andersca@apple.com>

        Reviewed by Geoff, Ada and John.

        <rdar://problem/4600978> Would like a way to test whether a WebView is displaying a standalone image

        * WebView/WebFrame.mm:
        (-[WebFrame _isDisplayingStandaloneImage]):
        * WebView/WebFramePrivate.h:
        Add _isDisplayingStandaloneImage SPI.

2007-04-06  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Mark Rowe.

        Adds a build phase script that ensures WebKit's version dosen't end in a 4.
        If our version ends in 4, some sites might think we are Netscape 4 in their
        user agent checks.

        * Configurations/Version.xcconfig:
        * WebKit.xcodeproj/project.pbxproj:

2007-04-05  Anders Carlsson  <andersca@apple.com>

        Reviewed by Adam.

        <rdar://problem/5083023>
        REGRESSION: In Real Player (10.1.0), video continues to play after closing window
        
        This broke in revision 18422 because now the plugin isn't stopped when the window is closed. Since the window is retained
        by the plugin view for as long as it is running (so that removeTrackingRect works even though the window has been closed),
        we would end up with a reference cycle (NSWindow -> WebView -> PluginView -> NSWindow) and stopping the plug-in when the window
        was closed would break that cycle.
        
        Applications that call -[WebView close] when closing aren't affected, but RealPlayer doesn't do this.
        
        The bug that 18422 was supposed to fix was fixed by 19275, which is why it's safe to add back the check.
        
        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView addWindowObservers]):
        (-[WebBaseNetscapePluginView removeWindowObservers]):
        (-[WebBaseNetscapePluginView windowWillClose:]):

2007-04-05  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Darin.

        - Moved registerURLSchemeAsLocal to the public API.

        * WebView/WebView.h:
        * WebView/WebView.mm:
        (+[WebView registerURLSchemeAsLocal:]):
        * WebView/WebViewPrivate.h:

=== Safari-5522.6 ===

2007-04-04  Anders Carlsson  <andersca@apple.com>

        Reviewed by John.

        <rdar://problem/5107536> 
        http://bugs.webkit.org/show_bug.cgi?id=13264
        REGRESSION: Crash when canceling about:blank in Activity viewer
        
        * WebView/WebFrame.mm:
        (-[WebFrame stopLoading]):
        Add a null check for the frame loader - it can be null when the frame has been disconnected
        from the web page.

2007-04-03  Anders Carlsson  <andersca@apple.com>

        Reviewed by Darin.

        <rdar://problem/5028178>
        Crash occurs at WebCore::FrameLoader::activeDocumentLoader() after loading Froggster widget
        
        * Plugins/WebNetscapePluginStream.mm:
        (-[WebNetscapePluginStream start]):
        If load returns no the plugin loader has already been removed by the didFail callback.

2007-04-02  Anders Carlsson  <andersca@apple.com>

        Reviewed by Geoff.

        Fix crash when running plugins/destroy-stream-twice.html under GuardMalloc

        * Plugins/WebBaseNetscapePluginStream.h:
        * Plugins/WebBaseNetscapePluginStream.mm:
        (+[WebBaseNetscapePluginStream ownerForStream:]):
        (-[WebBaseNetscapePluginStream initWithRequestURL:plugin:notifyData:sendNotification:]):
        (-[WebBaseNetscapePluginStream dealloc]):
        (-[WebBaseNetscapePluginStream finalize]):
        Change the streams hash map to contain an NPStream*, and change ownerForStream to take an NPStream*.
        
        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView destroyStream:reason:]):
        Check that the NPStream pointer is valid before accessing stream->ndata.

2007-04-02  Darin Adler  <darin@apple.com>

        Reviewed by Geoff.

        - fix http://bugs.webkit.org/show_bug.cgi?id=13026
          <rdar://problem/5061026> incomplete render of menu
          (assertion failing in -[WebBaseNetscapePluginView saveAndSetNewPortStateForUpdate:])

        - fix http://bugs.webkit.org/show_bug.cgi?id=13120
          <rdar://problem/5080339> Plug-ins that draw through the QuickDraw interface may crash
          by hanging onto old GWorlds.

        - set clip path for CoreGraphics plug-ins in the same way we do for QuickDraw plug-ins
          this is a better fix for <rdar://problem/4939511> WebKit should set the the CG clip
          path for plug-ins that draw using Core Graphics

        Incorporates changes from a patch by Mark Ambachtsheer.

        Here are the changes:

            1) Don't try to use the offscreen code path if GGBitmapContextGetData returns 0.
            2) Handle kCGBitmapByteOrderDefault when computing the QD pixel format, even though
               we don't have any evidence that this happens in practice.
            3) Keep the GWorld around until we create a new one or the plug-in is destroyed.
            4) Use the GWorld pointer itself as a flag to indicate whether we are using an
               offscreen GWorld.
            5) Set up clipping for CoreGraphics in the same way we do for QuickDraw; remove an
               earlier attempt that handled CoreGraphics differently.

        * Plugins/WebBaseNetscapePluginView.h: Added a field named offscreenGWorld to hold
        the GWorld until it's needed.
        * Plugins/WebBaseNetscapePluginView.mm:
        (getQDPixelFormatForBitmapContext): Replaced QDPixelFormatFromCGBitmapInfo. Used the
        "get" prefix so we don't intrude on the QD namespace. Added code to handle the
        kCGBitmapByteOrderDefault case, although I'm not sure it will really come up in
        practice -- it wasn't really coming up in the buggy case.
        (getNPRect): Added helper functions. Used to make the code below clearer.
        (-[WebBaseNetscapePluginView saveAndSetNewPortStateForUpdate:]): Use getNPRect to
        streamline code. Use GetGWorld to save the port since we use SetGWorld to restore
        it later. Store the GWorld we create in the offscreenGWorld field and dispose the
        existing one. Don't treat the CGBitmapContext as an offscreen bitmap if it
        has a data pointer of 0. Set up the clip based on the result of
        -[NSView getRectsBeingDrawn:count] when setting up the port for CoreGraphics
        (after saving the port state).
        (-[WebBaseNetscapePluginView restorePortState:]): Remove now-unneeded code to
        destroy the offscreen GWorld, and simplified the code that restores the port so we
        don't need a separate case for offscreen.
        (-[WebBaseNetscapePluginView fini]): Renamed from freeAttributeKeysAndValues, since
        this method now does more than just the attributes. This is the shared method that
        does things needed in both dealloc and finalize. Added a call to DisposeGWorld here.
        (-[WebBaseNetscapePluginView dealloc]): Updated for name change.
        (-[WebBaseNetscapePluginView finalize]): Ditto.
        (-[WebBaseNetscapePluginView drawRect:]): Removed code to set clip. This is done in
        the saveAndSetNewPortStateForUpdate: method instead.

2007-03-30  Adele Peterson  <adele@apple.com>

        Reviewed by Darin.

        Call execCommand for deleteWordForward and deleteWordBackward instead of calling
        deleteWithDirection directly.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView deleteWordForward:]):
        (-[WebHTMLView deleteWordBackward:]):

2007-03-30  Anders Carlsson  <andersca@apple.com>

        Reviewed by Geoff.

        * Plugins/WebNetscapePluginPackage.m:
        (-[WebNetscapePluginPackage load]):
        Initialize pushpopupsenabledstate, poppopupsenabledstate and enumerate.
        
        * Plugins/npapi.m:
        (NPN_PushPopupsEnabledState):
        (NPN_PopPopupsEnabledState):
        Add stubs for these functions.
        
        * Plugins/npfunctions.h:
        Add new methods to NPNetscapeFuncs.

2007-03-29  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Beth Dakin, reviewed by Maciej Stachowiak.
        
        Layout test for <rdar://problem/5091330> REGRESSION: Repro crash in 
        -[WebBaseNetscapePluginView(WebNPPCallbacks) destroyStream:reason:] 
        navigating away from page with DivX movie plug-in (13203)
        
        Changed LOG_ERROR to LOG so the layout test doesn't produce console spew
        every time you run it.

        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView destroyStream:reason:]):

2007-03-29  Beth Dakin  <bdakin@apple.com>

        Reviewed by Brady.

        Fix for <rdar://problem/4674537> REGRESSION: Adobe Acrobat 8 - Text 
        blinks when mouse is moved, and is invisible otherwise

        -and-

        <rdar://problem/4992521> Please adjust WebKit's Acrobat-workaround 
        methodology

        The fix for the first bug is to compare against the bundle 
        identifiers for Adobe Reader and the non-Pro Adobe Acrobat in 
        addition to Adobe Acrobat Pro. The fix for the second bug is to 
        check the version number of Acrobat/Reader through 
        WebKitSystemInterface instead of checking which version of WebKit 
        it has been linked against.

        * English.lproj/StringsNotToBeLocalized.txt: Two new bundle 
        identifiers.
        * Misc/WebKitVersionChecks.h: Remove Acrobat quirk constant.
        * WebView/WebView.mm:
        (-[WebView _updateWebCoreSettingsFromPreferences:]):

2007-03-29  Geoffrey Garen  <ggaren@apple.com>

        Rubber stamped by Beth Dakin.
        
        WebBaseNetscapePluginStream.m => WebBaseNetscapePluginStream.mm, since
        it's ObjC++ now.

        * Plugins/WebBaseNetscapePluginStream.m: Removed.
        * WebKit.xcodeproj/project.pbxproj:

2007-03-27  Geoffrey Garen  <ggaren@apple.com>

        Reluctantly tolerated by Darin Adler.
        
        Fixed <rdar://problem/5091330> REGRESSION: Repro crash in 
        -[WebBaseNetscapePluginView(WebNPPCallbacks) destroyStream:reason:] 
        navigating away from page with DivX movie plug-in (13203)
        
        The problem was that the DivX plug-in would ask us to destroy an NPStream
        that had already been destroyed, causing us to wander off into freed
        memory. (I believe the reason this was a regression was that we never used 
        to destroy plug-in streams, period.)
        
        The solution here is to track the NPStreams belonging to a plug-in, and 
        guard against plug-ins making calls with NPStreams that don't belong to 
        them. (It turns out that NPN_DestroyStream is the only stream-based 
        plug-in call we support.)

        (CarbonPathFromPOSIXPath): Fixed up a cast to be C++ compatible.
        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView destroyStream:reason:]): The actual fix.
        Use helper method to guard against a plug-in using an NPStream that doesn't
        belong to it.
        * WebKit.xcodeproj/project.pbxproj: Made WebBaseNetscapePluginView ObjC++
        so I could use HashMap.

2007-03-28  Adele Peterson  <adele@apple.com>

        Reviewed by Brady.

        Update to last fix.

        * Misc/WebKitVersionChecks.h: Added WEBKIT_FIRST_VERSION_WITHOUT_VITALSOURCE_QUIRK.
        * WebView/WebView.mm: (-[WebView stringByEvaluatingJavaScriptFromString:]):
        Added check to only use the VitalSource workaround if the app is not linked on or after
        the defined WEBKIT_FIRST_VERSION_WITHOUT_VITALSOURCE_QUIRK version number.

2007-03-28  Adele Peterson  <adele@apple.com>

        Reviewed by Kevin M.

        WebKit part of fix for <rdar://problem/5095515> VitalSource Bookshelf should not pass return statements into stringByEvaluatingJavaScriptFromString

        Added an app specific workaround for VitalSource Bookshelf that strips "return" from the beginning of their script strings.  We used to allow this
        but now we throw a JavaScript exception for return statements that aren't in functions.

        Filed this evangelism bug so we can notify VitalSource of the problem:
        <rdar://problem/5095515> VitalSource Bookshelf should not pass return statements into stringByEvaluatingJavaScriptFromString

        * WebView/WebView.mm: (-[WebView stringByEvaluatingJavaScriptFromString:]):

2007-03-27  John Sullivan  <sullivan@apple.com>

        Reviewed by Tim
        
        - fixed <rdar://problem/5092556> Default UA spoofing is always off until explicitly toggled

        * WebView/WebView.mm:
        (-[WebView _commonInitializationWithFrameName:groupName:]):
        initialize the cached value of _private->useSiteSpecificSpoofing here; formerly it would not
        be initialized correctly in the common case of WebViews that use [WebPreferences standardPreferences]

2007-03-27  Mark Rowe  <mrowe@apple.com>

        Reviewed by Dave Harrison.

        * Configurations/WebKit.xcconfig: Include UMBRELLA_FRAMEWORKS_DIR in framework search path.

2007-03-26  Antti Koivisto  <antti@apple.com>

        Reviewed by Darin.
        
        On Mac, support fine grained wheel events generated by trackpad and Mighty Mouse.
        http://bugs.webkit.org/show_bug.cgi?id=13134
        <rdar://problem/5076249>

        * WebCoreSupport/WebSystemInterface.m:
        (InitWebCoreSystemInterface): Expose GetWheelEventDeltas()

2007-03-26  John Sullivan  <sullivan@apple.com>

        Reviewed by Dave Harrison
        
        - fixed <rdar://problem/4769772> Problem with Find on certain PDF page

        * WebView/WebPDFView.mm:
        (-[WebPDFView _scaledAttributedString:]):
        We were hitting an exception trying to set the font attribute to nil, which was happening because
        the result of -[PDFSelection attributedString] had no attributes. That PDFSelection bug is now
        filed separately, but this works around the exception.

2007-03-24  David Hyatt  <hyatt@apple.com>

        Amend the statistics reporting for the WebCore cache to include XSL and to report live/decoded sizes.

        * Misc/WebCache.mm:
        (+[WebCache statistics]):

2007-03-24  Brady Eidson  <beidson@apple.com>

        Reviewed by Adam

        RetainPtr is no longer in the WebCore namespace

        * History/WebBackForwardList.mm:
        * WebCoreSupport/WebEditorClient.h:
        * WebCoreSupport/WebFrameLoaderClient.h:
        * WebView/WebDocumentLoaderMac.h:

2007-03-24  Brady Eidson  <beidson@apple.com>

        Reviewed by Adam

        <rdar://problem/5086210> - Move RetainPtr to WTF
        
        * ForwardingHeaders/wtf/RetainPtr.h: Added.
        * History/WebBackForwardList.mm: Changed #import to <wtf/RetainPtr.h>
        * WebCoreSupport/WebEditorClient.h: Ditto
        * WebCoreSupport/WebFrameLoaderClient.h: Ditto
        * WebView/WebDocumentLoaderMac.h: Ditto

2007-03-24  John Sullivan  <sullivan@apple.com>

        Reviewed by Adele

        - fixed <rdar://problem/5084872> Need to add flickr to spoof list in WebKit
        - only do site-specific spoofing if a preference is set

        * WebView/WebPreferenceKeysPrivate.h:
        added WebKitUseSiteSpecificSpoofingPreferenceKey 
        
        * WebView/WebPreferences.m:
        (+[WebPreferences initialize]):
        initialize WebKitUseSiteSpecificSpoofingPreferenceKey to false
        (-[WebPreferences _useSiteSpecificSpoofing]):
        get value of WebKitUseSiteSpecificSpoofingPreferenceKey
        (-[WebPreferences _setUseSiteSpecificSpoofing:]):
        set value of WebKitUseSiteSpecificSpoofingPreferenceKey
        
        * WebView/WebPreferencesPrivate.h:
        declare _useSiteSpecificSpoofing and _setUseSiteSpecificSpoofing
        
        * WebView/WebView.mm:
        cache the value of WebKitUseSiteSpecificSpoofingPreferenceKey in a bool in _private
        (-[WebView _preferencesChangedNotification:]):
        update the cached value
        (-[WebView setPreferences:]):
        ditto
        (-[WebView WebCore::_userAgentForURL:WebCore::]):
        Only spoof here if the new site-specific spoofing preference is enabled. If it is, pass
        Safari 2.0.4's user agent string for flickr.com. We can remove this case when 5081617 is addressed.

2007-03-24  Mark Rowe  <mrowe@apple.com>

        Rubber-stamped by Darin.

        * Configurations/WebKit.xcconfig: Remove unnecessary INFOPLIST_PREPROCESS.

2007-03-23  Mark Rowe  <mrowe@apple.com>

        Build fix for when BUILDING_ON_TIGER is not defined.

        * Misc/WebTypesInternal.h:
        * WebView/WebHTMLView.mm:

2007-03-22  David Kilzer  <ddkilzer@apple.com>

        Reviewed by Darin.

        Use BUILDING_ON_TIGER from WebKitPrefix.h instead of local
        MAC_OS_X_VERSION_MAX_ALLOWED <= MAC_OS_X_VERSION_10_4 tests.

        * Misc/WebTypesInternal.h:
        * WebView/WebHTMLView.mm:

2007-03-22  Darin Adler  <darin@apple.com>

        Reviewed by Adele.

        - fix <rdar://problem/5074630> detachChildren call should move from WebKit to WebCore

        * WebCoreSupport/WebFrameLoaderClient.mm: (WebFrameLoaderClient::prepareForDataSourceReplacement):
        Remove call to detachChildren. This should be a WebCore responsibility.

2007-03-19  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by Dave Hyatt.

        <rdar://problem/5067983>
        iSale: Crash occurs at WebFrameLoaderClient::dispatchDecidePolicyForMIMEType() when attempting to load a HTML template
        
        Restore old behavior (broke in r14533) where the resource load and download delegates are retained for as long as the 
        data source is loading.
        
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::createDocumentLoader):
        * WebView/WebDocumentLoaderMac.h:
        * WebView/WebDocumentLoaderMac.mm:
        (WebDocumentLoaderMac::setDataSource):
        (WebDocumentLoaderMac::decreaseLoadCount):

2007-03-19  Geoffrey Garen  <ggaren@apple.com>

        Speculative fix for why ASSERT_MAIN_THREAD didn't work for me. (The
        documentation says "non-zero," not "1."

        * Misc/WebKitLogging.m:
        (WebKitRunningOnMainThread):

2007-03-19  Andrew Wellington  <proton@wiretapped.net>

        Reviewed by Maciej.

        Really set Xcode editor to use 4 space indentation (http://webkit.org/coding/coding-style.html)

        * WebKit.xcodeproj/project.pbxproj:

2007-03-19  Darin Adler  <darin@apple.com>

        * English.lproj/StringsNotToBeLocalized.txt: Update for recent changes.

2007-03-19  John Sullivan  <sullivan@apple.com>

        Reviewed by Justin
        
        - fixed <rdar://problem/5071238> REGRESSION: opt-cmd-B to show Bookmarks view does 
        nothing when form field has focus

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _handleStyleKeyEquivalent:]):
        we were counting any set of modifiers plus 'b' as the standard key equivalent for
        toggling Bold; now we only accept command+'b'

2007-03-19  Adam Roben  <aroben@apple.com>

        Reviewed by Hyatt and Maciej.

        Updated WebCoreStatistics for the conversion of WebCoreJavaScript to
        C++.

        * Misc/WebCoreStatistics.mm:
        (+[WebCoreStatistics javaScriptObjectsCount]):
        (+[WebCoreStatistics javaScriptInterpretersCount]):
        (+[WebCoreStatistics javaScriptProtectedObjectsCount]):
        (+[WebCoreStatistics javaScriptRootObjectTypeCounts]): Moved
        conversion to NSCountedSet here from WebCore.
        (+[WebCoreStatistics garbageCollectJavaScriptObjects]):
        (+[WebCoreStatistics garbageCollectJavaScriptObjectsOnAlternateThread:]):
        (+[WebCoreStatistics shouldPrintExceptions]):
        (+[WebCoreStatistics setShouldPrintExceptions:]):
        (+[WebCoreStatistics javaScriptReferencedObjectsCount]):
        (+[WebCoreStatistics javaScriptRootObjectClasses]):

2007-03-18  Andrew Wellington  <proton@wiretapped.net>

        Reviewed by Mark Rowe
        
        Set Xcode editor to use 4 space indentation (http://webkit.org/coding/coding-style.html)

        * WebKit.xcodeproj/project.pbxproj:

2007-03-19  Mark Rowe  <mrowe@apple.com>

        Rubber-stamped by Brady.

        Update references to bugzilla.opendarwin.org with bugs.webkit.org.

        * WebInspector/webInspector/inspector.css:
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView firstRectForCharacterRange:]):
        * WebView/WebView.mm:
        (-[WebView initWithFrame:frameName:groupName:]):

2007-03-18  David Hyatt  <hyatt@apple.com>

        Move frame borders out of WebKit and into WebCore.

        Reviewed by aroben, olliej

        * WebCoreSupport/WebFrameBridge.mm:
        * WebKit.xcodeproj/project.pbxproj:
        * WebView/WebFrameView.mm:
        (-[WebFrameView drawRect:]):
        (-[WebFrameView setFrameSize:]):
        * WebView/WebFrameViewInternal.h:

2007-03-17  John Sullivan  <sullivan@apple.com>

        Reviewed by Tim Hatcher
        
        Discovered while working on <rdar://problem/5070334> that many WebView calls will crash if called
        after -[WebView close] has executed because _private->page is deferenced after it's been set to 0. 
        It might be silly/wrong to call these methods after -close, but obviously it shouldn't crash. Made
        each use of _private->page robust against nil-dereferencing.

        * WebView/WebView.mm:
        (-[WebView _loadBackForwardListFromOtherView:]):
        (-[WebView _updateWebCoreSettingsFromPreferences:]):
        (-[WebView _setDashboardBehavior:to:]):
        (-[WebView _dashboardBehavior:]):
        (-[WebView goBack]):
        (-[WebView goForward]):
        (-[WebView goToBackForwardItem:]):
        (-[WebView canGoBack]):
        (-[WebView canGoForward]):
        (-[WebView setTabKeyCyclesThroughElements:]):
        (-[WebView tabKeyCyclesThroughElements]):
        (-[WebView setEditable:]):

2007-03-17  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Mark Rowe.

        Made Version.xcconfig smarter when building for different configurations.
        Now uses the 522+ OpenSource version for Debug and Release, while using the
        full 522.4 version for Production builds. The system prefix is also computed
        based on the current system, so 4522.4 on Tiger and 5522.4 on Leopard.

        * Configurations/Version.xcconfig:
        * Configurations/WebKit.xcconfig:

2007-03-16  Oliver Hunt  <oliver@apple.com>

        Reviewed by Hyatt.

        The old canSaveAsWebArchive call was necessary as stand alone
        images used to be rendered by ImageDocument.

        Fixes rdar://problem/5061252

        * WebCoreSupport/WebDragClient.h:
        * WebCoreSupport/WebDragClient.mm:
        (WebDragClient::declareAndWriteDragImage):
        * WebKit.xcodeproj/project.pbxproj:

2007-03-15  Brady Eidson  <beidson@apple.com>

        Reviewed by Maciej

        <rdar://problem/4429701>
        Implements a port blocking black list that matches Firefox's

        * English.lproj/Localizable.strings: Added localizable string for port blocked error code

        * Misc/WebKitErrors.h:
        * Misc/WebKitErrors.m:
        (registerErrors): Add new port blocked error code to WebKitErrorDomain

        * WebCoreSupport/WebFrameLoaderClient.h:
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::cancelledError): Fixed coding style
        (WebFrameLoaderClient::blockedError): Return a ResourceError with the new custom error code

2007-03-15  Timothy Hatcher  <timothy@apple.com>

        Reviewed by John.

        * Fixes: <rdar://problem/4927747> WebKit's Current Library Version number should match the Info.plist Version
        * Factored out most of our common build settings into .xcconfig files. Anything that was common in
          each build configuration was factored out into the shared .xcconfig file.
        * Adds a Version.xcconfig file to define the current framework version, to be used in other places.
        * Use the new $(BUNDLE_VERSION) (defined in Version.xcconfig) in the preprocessed Info.plist.
        * Use the versions defined in Version.xcconfig to set $(DYLIB_CURRENT_VERSION).
        * Make WebKit use the same warning flags as the other projects. This required two casts to be added to fix new warnings.

        * Configurations/Base.xcconfig: Added.
        * Configurations/DebugRelease.xcconfig: Added.
        * Configurations/Version.xcconfig: Added.
        * Configurations/WebKit.xcconfig: Added.
        * Info.plist:
        * Misc/WebKitVersionChecks.h:
        * Plugins/WebBaseNetscapePluginStream.m:
        (-[WebBaseNetscapePluginStream startStreamResponseURL:expectedContentLength:lastModifiedDate:MIMEType:]):
        * WebKit.xcodeproj/project.pbxproj:

2007-03-15  Kevin Decker  <kdecker@apple.com>

        Reviewed by Anders.

        Fixed: <rdar://problem/5001428> stationery background images do not display
       
        Change 19244 fixed the method -[WebResource _shouldIgnoreWhenUnarchiving], but also broke Mail stationery.
        
        The problem was that with archivedResourceForURL now fixed, the engine will try to decode the images.  These images wouldn't decode because
        Mail re-encodes and directly manipulates the image data in such a way that prevented WebKit from decoding the image.  Because Mail was giving
        us bad data, the images wouldn't render.  This was never an issue before because archivedResourceForURL (broken) always returned nil, thus the
        engine would never attempt to decode the resource, therefore the responsibility was delegated to Mail's protocol handler, which would do the 
        right thing and load the image.
        
        Since Mail is relying on the fact it can store arbitrary data in WebArchives, I've introduced SPI that acts as a hint for us to ignore certain 
        subresources while unarchiving. This SPI is -[WebResource _shouldIgnoreWhenUnarchiving].
        
        * WebView/WebResource.mm: Addd private ivar shouldIgnoreWhenUnarchiving.
        (-[WebResource _ignoreWhenUnarchiving]): Added.
        (-[WebResource _shouldIgnoreWhenUnarchiving]): Added.
        * WebView/WebResourcePrivate.h: Added two methods to private header.
        * WebView/WebUnarchivingState.m:
        (-[WebUnarchivingState archivedResourceForURL:]): Check if we should ignore the resource.

2007-03-15  Mark Rowe  <mrowe@apple.com>

        Reviewed by Antti.

        Fix for <rdar://problem/5065060> ASSERTION FAILURE: newUsername && newPassword
        when submitting an authentication form without password.

        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::dispatchWillSubmitForm): Don't omit form fields with empty values from the dictionary
        passed to the delegate.

2007-03-14  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by Dave Hyatt.

        Don't add the data twice, it's also done by didReceiveData.
        
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::deliverArchivedResources):

2007-03-14  Anders Carlsson  <acarlsson@apple.com>

        Fix segmentation fault when running layout tests.

        Remove bogus check that that I added on purpose to see how good Geoff is at spotting mistakes when reviewing code.
        (Turns out he's not that good!)
        
        * WebView/WebDocumentLoaderMac.mm:
        (WebDocumentLoaderMac::increaseLoadCount):

2007-03-14  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by Geoff.

        http://bugs.webkit.org/show_bug.cgi?id=13076
        REGRESSION: Multiple loading tabs cause assertion in WebDocumentLoaderMac::decreaseLoadCount(unsigned long)

        Store the identifier set in the document loader since identifiers are per-webview and not global.
        
        * WebView/WebDocumentLoaderMac.h:
        * WebView/WebDocumentLoaderMac.mm:
        (WebDocumentLoaderMac::WebDocumentLoaderMac):
        (WebDocumentLoaderMac::attachToFrame):
        (WebDocumentLoaderMac::increaseLoadCount):
        (WebDocumentLoaderMac::decreaseLoadCount):

2007-03-14  David Harrison  <harrison@apple.com>

        Reviewed by Maciej.

        <rdar://problem/5009625> REGRESSION: Aperture 1.5: Can't select entire line of text after correcting a misspelled word

        * WebCoreSupport/WebEditorClient.mm:
        (WebEditorClient::respondToChangedSelection):
        * WebCoreSupport/WebFrameBridge.mm:
        Provide compatibility by not sending WebViewDidChangeSelectionNotification if
        the app is Aperture and is linked against WebKit 2.0.

=== Safari-5522.4 ===

2007-03-14  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by Geoff.

        <rdar://problem/5058714>
        http://bugs.webkit.org/show_bug.cgi?id=13050
        
        World leaks seen on Leopard after opening then closing tab (13050)

        Add a hash set to prevent the load count to be increased twice for the same resource.
        
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::dispatchWillSendRequest):
        (WebFrameLoaderClient::dispatchDidFinishLoading):
        (WebFrameLoaderClient::dispatchDidFailLoading):
        * WebView/WebDocumentLoaderMac.h:
        * WebView/WebDocumentLoaderMac.mm:
        (loadingResources):
        (WebDocumentLoaderMac::increaseLoadCount):
        (WebDocumentLoaderMac::decreaseLoadCount):

2007-03-14 Adele Peterson  <adele@apple.com>

        Reviewed by Darin.

        Removed _insertTextWithEvent, _insertNewlineWithEvent, and _insertTextWithEvent.
        Instead, use execCommand and insertText methods on the Editor.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView insertTab:]):
        (-[WebHTMLView insertBacktab:]):
        (-[WebHTMLView insertNewline:]):
        (-[WebHTMLView insertLineBreak:]):
        (-[WebHTMLView insertParagraphSeparator:]):
        (-[WebHTMLView insertNewlineIgnoringFieldEditor:]):
        (-[WebHTMLView insertTabIgnoringFieldEditor:]):
        (-[WebHTMLView yank:]):
        (-[WebHTMLView yankAndSelect:]):
        (-[WebHTMLView doCommandBySelector:]):
        (-[WebHTMLView insertText:]):

2007-03-14  David Hyatt  <hyatt@apple.com>

        Fixes to ensure that the resource loader's shared buffer can always be used.

        Reviewed by olliej, mjs

        * Misc/WebIconDatabase.mm:
        (-[WebIconDatabase _convertToWebCoreFormat]):
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::deliverArchivedResources):

2007-03-13  Oliver Hunt  <oliver@apple.com>

        Reviewed by Brady.

        Modify subresourceForURL to take NSString argument 
        so we can avoid [NSURL absoluteString]

        * WebView/WebDataSource.mm:
        (-[WebDataSource subresourceForURL:]):

2007-03-13  Brady Eidson  <beidson@apple.com>

        Rubberstamped by Alice

        Meant to be part of my previous checkin... pruning unused code from WebKit

        * WebView/WebFrame.mm: Removed _canCachePage
        * WebView/WebFrameInternal.h: Ditto

2007-03-13  Beth Dakin  <bdakin@apple.com>

        Reviewed by Maciej.

        Fix for <rdar://problem/4277074> 8F32: Help Viewer crashed on 
        clicking link - KHTMLView::viewportMouseReleaseEvent (12647)

        Re-set the DocumentLoader's frame when loading it from the page 
        cache before setting the document view.

        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::setDocumentViewFromPageCache):

2007-03-13  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Geoff.

        <rdar://problem/5057117> Spoof user agent on Yahoo.com with Safari and WebKit as version 4xx

        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView userAgent]): Stop using the deprecated lossyCString method.
        * WebCoreSupport/WebFrameBridge.mm: Removed dead code, userAgentForURL: wasn't used.
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::userAgent): Call WebView's _userAgentForURL:.
        * WebView/WebView.mm:
        (-[WebView _cachedResponseForURL:]): Call userAgentForURL: instead of _userAgent.
        (-[WebView userAgentForURL:]): Call _userAgentForURL:.
        (-[WebView _userAgentWithApplicationName:andWebKitVersion:]): New method to construct a UA.
        (-[WebView _computeUserAgent]): Ractored out into _userAgentWithApplicationName:andWebKitVersion:
        (-[WebView _userAgentForURL:]): Tail compare for Yahoo.com, and return a UA with an older WebKit version.
        * WebView/WebViewInternal.h: Declare _userAgentForURL:.

2007-03-12  David Harrison  <harrison@apple.com>

        Reviewed by Darin.

        <rdar://problem/4743256> ctrl-y key binding (yank) should do nothing when kill ring is empty

        Test updated:
        * editing/pasteboard/emacs-cntl-y-001.html:
        
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView yank:]):
        (-[WebHTMLView yankAndSelect:]):
        Do nothing if the killring is empty.

2007-03-12  Darin Adler  <darin@apple.com>

        Reviewed by Tim Hatcher.

        - update for the new naming scheme for the Objective-C wrapper-creation
          functions: _wrapElement: instead of _elementWith:, etc.

        * WebCoreSupport/WebEditorClient.mm:
        (WebEditorClient::textFieldDidBeginEditing):
        (WebEditorClient::textFieldDidEndEditing):
        (WebEditorClient::textDidChangeInTextField):
        (WebEditorClient::doTextFieldCommandFromEvent):
        (WebEditorClient::textWillBeDeletedInTextField):
        (WebEditorClient::textDidChangeInTextArea):
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::createPlugin):
        (WebFrameLoaderClient::createJavaAppletWidget):
        * WebView/WebFrame.mm: (kit):
        Use the _wrapElement-style functions.

2007-03-12  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by Maciej.

        <rdar://problem/5057575> 
        REGRESSION: Repro Crash in FrameLoader::frame loading about:blank in PLT
        
        Always get the web view from the current web frame, since the document loader's frame can have been zeroed out
        (for example when detaching the document loader).
        
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::dispatchDidLoadResourceFromMemoryCache):
        (WebFrameLoaderClient::assignIdentifierToInitialRequest):
        (WebFrameLoaderClient::dispatchWillSendRequest):
        (WebFrameLoaderClient::dispatchDidReceiveResponse):
        (WebFrameLoaderClient::dispatchDidReceiveContentLength):
        (WebFrameLoaderClient::dispatchDidFinishLoading):

2007-03-11  Oliver Hunt  <oliver@apple.com>

        Reviewed by Adele.
        
        Moved respondToChangedSelection from FrameBridge to EditorClient
        
        * WebCoreSupport/WebEditorClient.h:
        * WebCoreSupport/WebEditorClient.mm:
        (WebEditorClient::respondToChangedSelection):
        * WebCoreSupport/WebFrameBridge.mm:
          Removed respondToChangedSelection from bridge

2007-03-11  Darin Adler  <darin@apple.com>

        Reviewed by Adele.

        - fix http://bugs.webkit.org/show_bug.cgi?id=12964
          <rdar://problem/5045717> REGRESSION: crash in -[WebBaseNetscapePluginStream _deliverData]
          at simpsonsmovie.com (12964)

        * Plugins/WebBaseNetscapePluginStream.m:
        (-[WebBaseNetscapePluginStream startStreamResponseURL:expectedContentLength:lastModifiedDate:MIMEType:]):
        At every place we call the plug-in, since it could destroy the stream, get pluginView into a local
        variable; it will be set to nil if the stream is destroyed.
        (-[WebBaseNetscapePluginStream _destroyStream]): Added calls to retain/release to handle the case where
        one of the calls to the plug-in destroys the stream. Added a call to cancelPreviousPerformRequestsWithTarget
        in case _deliverData has been scheduled but not yet delivered. Also get pluginView into a local variable
        as mentioned above, and check at strategic points and exit if the stream was already destroyed to avoid
        multiple calls to NPP_DestroyStream or NPP_URLNotify.
        (-[WebBaseNetscapePluginStream _deliverData]): Ditto.

2007-03-10  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Darin Adler.

        Fixed <rdar://problem/4587763> PAC file: lock inversion between QT and 
        JSCore causes a hang @ www.panoramas.dk
        
        See JavaScriptCore ChangeLog for details.

        Drop the JSLock before making calls through the plug-in API from functions
        that may have been called by JavaScript.
        
        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView sendEvent:]):
        (-[WebBaseNetscapePluginView setWindowIfNecessary]):
        (-[WebBaseNetscapePluginView initWithFrame:pluginPackage:URL:baseURL:MIMEType:attributeKeys:attributeValues:loadManually:DOMElement:]):
        (-[WebBaseNetscapePluginView createPluginScriptableObject]):
        (-[WebBaseNetscapePluginView evaluateJavaScriptPluginRequest:]):
        (-[WebBaseNetscapePluginView webFrame:didFinishLoadWithReason:]):
        (-[WebBaseNetscapePluginView loadPluginRequest:]):
        (-[WebBaseNetscapePluginView _printedPluginBitmap]):
        * Plugins/WebPluginController.mm:
        (+[WebPluginController plugInViewWithArguments:fromPluginPackage:]):
        (-[WebPluginController startAllPlugins]):
        (-[WebPluginController stopAllPlugins]):
        (-[WebPluginController addPlugin:]):
        (-[WebPluginController destroyPlugin:]):
        (-[WebPluginController destroyAllPlugins]):

2007-03-10  David Kilzer  <ddkilzer@webkit.org>

        Reviewed by Darin.

        - fix http://bugs.webkit.org/show_bug.cgi?id=9609
          REGRESSION: Missing image icon needs to be moved back to WebKit

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _startDraggingImage:at:operation:event:sourceIsDHTML:DHTMLWroteData:]):
        Use WebCore::Image::loadPlatformResource(const char*) to load the missingImage image.

2007-03-10  Mark Rowe  <mrowe@apple.com>

        Reviewed by John.

        <rdar://problem/5051827> HIWebView handling of kEventControlGetData is broken in 64-bit

        On Leopard the kEventParamControlDataBufferSize event parameter is of type typeByteCount.
        The 32-bit implementation of GetEventParameter will coerce between integer types and
        typeByteCount while the 64-bit version will return a failure. As typeByteCount is new
        in Leopard we must continue using typeSInt32 when building for Tiger.

        * Carbon/HIWebView.m:
        (HIWebViewEventHandler):

2007-03-09  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Darin.

        <rdar://problem/4976254> Please get off _NSSoftLinkingGetFrameworkFuncPtr

        Use dlopen and dlsym to access the DCSShowDictionaryServiceWindow function.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _lookUpInDictionaryFromMenu:]):

2007-03-09  Darin Adler  <darin@apple.com>

        Reviewed by Justin.

        - fix http://bugs.webkit.org/show_bug.cgi?id=8928
          <rdar://problem/5045708> REPRODUCIBLE ASSERT: Cannot paste HTML into a
          contenteditable region in an XHTML document (8928)

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _hasHTMLDocument]): Added.
        (-[WebHTMLView _documentFragmentFromPasteboard:forType:inContext:subresources:]):
        Don't call AppKit's conversion from the DOM to an attributed string if the document
        is not an HTML document, to work around an AppKit limitation (Radar 5052390).

2007-03-09  Darin Adler  <darin@apple.com>

        * English.lproj/StringsNotToBeLocalized.txt: Updated for recent changes.

2007-03-08  Mark Rowe  <mrowe@apple.com>

        Reviewed by Tim Hatcher.

        <rdar://problem/5051616> Mouse clicks and movement are ignored in HIWebView on 64-bit

        Mouse events are not being handled correctly as GetControlKind is returning an error
        on 64-bit.  The more modern HIObjectIsOfClass behaves correctly for this use.

        * Carbon/HIWebView.m:
        (HIWebViewDestructor):
        (WindowHandler): Use HIObjectIsOfClass in place of GetControlKind.
        (HIWebViewEventHandler): Don't leak the NSEvent.

2007-03-08  Bruce Q Hammond  <bruceq@apple.com>

        Reviewed by Darin.

        Fix for http://bugs.webkit.org/show_bug.cgi?id=13009
        Console spews "CGContextGetType: invalid context" non-stop on web site

        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView saveAndSetNewPortStateForUpdate:]):
        (-[WebBaseNetscapePluginView restorePortState:]):

2007-03-08  Mark Rowe  <mrowe@apple.com>

        Reviewed by Tim Hatcher.

        <rdar://problem/4561772> HIWebView does not exist for 64-bit

        Update HIWebView and friends to work without QuickDraw.

        Changes are gleaned from the 64-bit support inside HICocoaView.  The main
        fact of interest are that all Carbon windows must have compositing enabled
        so the code paths that aren't accessible are #ifdef'd out.  Conveniently
        these are the exact code paths that make use of QuickDraw.

        There are currently minor event-handling and invalidation issues running as
        64-bit that are not present in 32-bit.

        * Carbon/CarbonUtils.m:
        * Carbon/CarbonWindowAdapter.m:
        * Carbon/CarbonWindowFrame.m:
        * Carbon/HIViewAdapter.m:
        (SetViewNeedsDisplay):
        * Carbon/HIWebView.m:
        (Draw):
        (Click):
        (SyncFrame):
        (StartUpdateObserver):
        (StopUpdateObserver):
        (UpdateObserver):
        * WebKit.LP64.exp: Removed.
        * WebKit.xcodeproj/project.pbxproj: Always use WebKit.exp.

2007-03-08  Timothy Hatcher  <timothy@apple.com>

        Reviewed by John.

        <rdar://problem/4664697> highlighter SPI needs a node parameter to give more context

        Added new methods to the WebHTMLHighlighter protocol that include the DOMNode being painted.

        * WebCoreSupport/WebFrameBridge.mm:
        (-[WebFrameBridge customHighlightRect:forLine:representedNode:WebCore::]):
        (-[WebFrameBridge paintCustomHighlight:forBox:onLine:behindText:entireLine:representedNode:WebCore::]):
        * WebKit.xcodeproj/project.pbxproj:
        * WebView/WebHTMLViewPrivate.h:

2007-03-08  Anders Carlsson  <acarlsson@apple.com>

        Try fixing the buildbot build.
        
        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView saveAndSetNewPortStateForUpdate:]):

2007-03-07  Anders Carlsson  <acarlsson@apple.com>

        Leopard build fix.
        
        * Plugins/WebBaseNetscapePluginView.mm:

2007-03-07  Bruce Q Hammond  <bruceq@apple.com>

        Reviewed by Darin.

        - fix http://bugs.webkit.org/show_bug.cgi?id=12515
          Plug-ins that draw through the Quickdraw interface fail in a CGBitmapContex.
          <rdar://problem/4975122>

        This fixes a problem with Netscape-style Plug-ins which draw through the Quickdraw APIs
        being unable to render into offscreen bitmap contexts.

        This patches both saveAndSetNewPortStateForUpdate: and restorePortState:
        These methods now check the current context and see if appropriate setup/cleanup needs to be done
        for offscreen rendering.

        * Plugins/WebBaseNetscapePluginView.mm:
        (QDPixelFormatFromCGBitmapInfo):
        (-[WebBaseNetscapePluginView saveAndSetNewPortStateForUpdate:]):
        (-[WebBaseNetscapePluginView restorePortState:]):

2007-03-07  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by Darin.

        Use HardRetain/HardRelease.
        
        * WebView/WebDocumentLoaderMac.mm:
        (WebDocumentLoaderMac::setDataSource):
        (WebDocumentLoaderMac::attachToFrame):
        (WebDocumentLoaderMac::detachFromFrame):
        (WebDocumentLoaderMac::increaseLoadCount):
        (WebDocumentLoaderMac::decreaseLoadCount):

2007-03-07  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by Maciej.

        <rdar://problem/4961259> 
        REGRESSION: Bumper Car 2.1.1 - Crash at WebCore::FrameLoader::receivedMainResourceError when encountering a invalid URL address
        
        (The crash was already fixed, this actually makes Bumper Car load the error page correctly.)
        
        This adds a "load counter" to the document loader and keeps the data source retained for as long as something is loading. 
        
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::dispatchWillSendRequest):
        Increase the load counter.
        
        (WebFrameLoaderClient::dispatchDidFinishLoading):
        (WebFrameLoaderClient::dispatchDidFailLoading):
        Decrease the load counter,
        
        * WebView/WebDocumentLoaderMac.h:
        * WebView/WebDocumentLoaderMac.mm:
        (WebDocumentLoaderMac::WebDocumentLoaderMac):
        
        (WebDocumentLoaderMac::attachToFrame):
        If the document loader has been detached, make sure to retain its data source here.
        
        (WebDocumentLoaderMac::detachFromFrame):
        Release the data source.
        
        (WebDocumentLoaderMac::increaseLoadCount):
        Retain the data source if load count was 0.
        
        (WebDocumentLoaderMac::decreaseLoadCount):
        Release the data source if load count becomes 0

2007-03-07  Adele Peterson  <adele@apple.com>

        Reviewed by Darin.

        WebKit part of fix for:
        http://bugs.webkit.org/show_bug.cgi?id=10871
        http://bugs.webkit.org/show_bug.cgi?id=12677
        <rdar://problem/4823129> REGRESSION: IME key events different in nightly
        <rdar://problem/4759563> REGRESSION: Return key is always sent when you confirm a clause in kotoeri

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _interceptEditingKeyEvent: shouldSaveCommand:]): Added shouldSaveCommand field to WebHTMLViewInterpretKeyEventsParameters.
          When shouldSaveCommand is true, we call interpretKeyEvents and in doCommandBySelector and insertText, we just save the information without performing any action.
          When shouldSaveCommand is false, we used the saved information and call doCommandBySelector and insertText directly.
          If there's no saved command data in the KeyboardEvent, call interpretKeyEvents, and honor the shouldSaveCommand argument.  This allows repeating keypress events
          to function normally.
        (-[WebHTMLView doCommandBySelector:]): If the WebHTMLViewInterpretKeyEventsParameters shouldSaveCommand field is set, then
          just save the selector information in the KeyboardEvent, and don't perform the action.
        (-[WebHTMLView insertText:]): ditto. 
          insertText can be called from an input method or from normal key event processing
          If its from an input method, then we should go ahead and insert the text now.  
          The only way we know if its from an input method is to check hasMarkedText.  There might be a better way to do this.

        * WebView/WebHTMLViewInternal.h: Added shouldSaveCommand argument.
        * WebView/WebViewInternal.h: ditto.

        * WebCoreSupport/WebEditorClient.h:
        * WebCoreSupport/WebEditorClient.mm:
        (WebEditorClient::handleKeypress): Changed handleKeyPress to handleKeypress.  Call _interceptEditingKeyEvent with shouldSaveCommand:NO.
        (WebEditorClient::handleInputMethodKeypress):  Call _interceptEditingKeyEvent with shouldSaveCommand:YES.

2007-03-07  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by Brady.

        Update to match WebCore.
        
        * Plugins/WebNetscapePluginStream.mm:
        (-[WebNetscapePluginStream start]):

2007-03-07  Jim Correia  <jim.correia@pobox.com>

        Reviewed by Darin.

        - WebCore part of fix for http://bugs.webkit.org/show_bug.cgi?id=12463
          WebArchiver - attempt to insert nil exception when archive empty iframe

        When dealing with an iframe element with no src attribute, the element contains
        a src attribute in the DOM with a URL of "about:blank" and some HTML to implement
        the blank page.  In the original page source, however, the iframe element does
        not include a src attribute, which caused a nil archive to be returned for the
        childFrameArchive and thus caused the bug.  The fix is a simple nil check.

        Test: webarchive/archive-empty-frame-source.html

        * WebView/WebArchiver.mm:
        (+ (NSArray *)_subframeArchivesForFrame:(WebFrame *)frame): Don't add childFrameArchive 
        to the subframeArchives array if it is nil.

2007-03-06  John Sullivan  <sullivan@apple.com>

        Reviewed by Darin
        
        Made WebAuthenticationHandler.h SPI so Safari can call it directly.

        * WebKit.exp:
        added .objc_class_name_WebPanelAuthenticationHandler
        * WebKit.xcodeproj/project.pbxproj:
        changed status of WebAuthenticationHandler.h from "project" to "private"

2007-03-06  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Darin.

        - Rename a function to clarify its purpose.

        * WebView/WebView.mm:
        (+[WebView registerURLSchemeAsLocal:]):
        * WebView/WebViewPrivate.h:

2007-03-06  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by Adam.

        Update for WebCore changes.
        
        * WebCoreSupport/WebFrameLoaderClient.h:
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::userAgent):

2007-03-05  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by Adam, Darin.
 
        <rdar://problem/5025212>
        In Mail, a crash occurs at WebCore::Frame::tree() when clicking on embedded flash object

        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView loadPluginRequest:]):
        Handle the case where the web view returned from the delegate method is null. Also, send out an error notification
        in that case so we can catch it.

2007-03-05  John Sullivan  <sullivan@apple.com>

        Reviewed by Darin and Kevin D

        - fixed <rdar://problem/5038087> Header and footer on printed page are too large after certain steps

        * WebView/WebView.mm:
        (-[WebView _adjustPrintingMarginsForHeaderAndFooter]):
        This method was modifying the margins in the NSPrintInfo object without any sort of check whether
        this had already been done. In some cases this can be called multiple times with the same 
        NSPrintInfo, so now we stash information in the NSPrintInfo's dictionary such that we always
        start with a fresh copy of the original margins.

2007-03-02  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Geoff.

        - rdar://problem/4922454
        - This fixes a security issue by making remote referrers not able to access local
        resources, unless they register their schemes to be treated as local. The result is
        that those schemes can access local resources and cannot be accessed by remote
        referrers.
        Because this behavior is new a link-on-or-after check is made to determine if the
        app should use the older, less safe, behavior.

        * Misc/WebKitVersionChecks.h: added linked-on-or-after check
        * Misc/WebNSAttributedStringExtras.mm: Moved functionalit into the base class.
        (fileWrapperForElement):
        * Plugins/WebNetscapePluginStream.mm: uses new canLoad functions
        * Plugins/WebPluginContainerCheck.mm: uses new canLoad functions
        (-[WebPluginContainerCheck _isForbiddenFileLoad]):
        * WebView/WebView.mm: make linked-on-or-after check and cache value, exposes SPI
        for registering a scheme as local. 
        (-[WebView _commonInitializationWithFrameName:groupName:]):
        (+[WebView registerSchemeAsLocal:]):
        * WebView/WebViewPrivate.h: exposes SPI for registering a scheme as local.

2007-03-01  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by harrison
        
        <rdar://problem/4838199>
        Integrate Mail and WebKit paste operations
        
        Provide subresources used to create the fragment as a
        convenience.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _documentFragmentFromPasteboard:inContext:allowPlainText:chosePlainText:]):
        Update the calls to the changed method.
        (-[WebHTMLView _documentFragmentFromPasteboard:forType:inContext:subresources:]):
        Give the caller the subresources in the WebArchive and RTF cases.
        * WebView/WebHTMLViewPrivate.h:

2007-02-28  Oliver Hunt  <oliver@apple.com>

        Reviewed by Maciej.

        Fixes <rdar://problem/5012009>
        
        When looking for a requested resource we should also check
        the set of manually added subresources if WebCore can't find it. 

        * WebView/WebDataSource.mm:
        (-[WebDataSource subresourceForURL:]):

2007-02-28  Brady Eidson  <beidson@apple.com>

        Reviewed by Beth

        Start using the Thread Safety Check implemented in WebCore for the DOM bindings in the rest of
        the WebKit API instead of the ASSERT_MAIN_THREAD() hack

        * History/WebBackForwardList.mm:
        (-[WebBackForwardList initWithWebCoreBackForwardList:]):
        (-[WebBackForwardList init]):
        (-[WebBackForwardList dealloc]):
        (-[WebBackForwardList finalize]):
        * History/WebHistoryItem.mm:
        (-[WebHistoryItem initWithURLString:title:lastVisitedTimeInterval:]):
        (-[WebHistoryItem dealloc]):
        (-[WebHistoryItem finalize]):
        (-[WebHistoryItem copyWithZone:]):
        (-[WebHistoryItem initWithWebCoreHistoryItem:]):
        * Misc/WebIconDatabase.mm:
        (-[WebIconDatabase init]):

2007-02-28  Adele Peterson  <adele@apple.com>

        Reviewed by Beth.

        Fix for <rdar://problem/4887423> REGRESSION: search results popup menu strings are not localized
        and <rdar://problem/3517227> accessibility-related strings in WebCore are not localized

        * WebCoreSupport/WebViewFactory.mm:
        (-[WebViewFactory searchMenuNoRecentSearchesText]):
        (-[WebViewFactory searchMenuRecentSearchesText]):
        (-[WebViewFactory searchMenuClearRecentSearchesText]):
        (-[WebViewFactory AXWebAreaText]):
        (-[WebViewFactory AXLinkText]):
        (-[WebViewFactory AXListMarkerText]):
        (-[WebViewFactory AXImageMapText]):
        (-[WebViewFactory AXHeadingText]):

2007-02-28  Mark Rowe  <mrowe@apple.com>

        Reviewed by Maciej.

        <rdar://problem/5028473> WebKit allocates a huge number of NSCalendarDates while loading history file

        * History/WebHistory.mm:
        (-[WebHistoryPrivate insertItem:atDateIndex:]): Use lastVisitedTimeInterval rather than _lastVisitedDate to avoid allocating NSCalendarDates.

2007-02-28  Mark Rowe  <mrowe@apple.com>

        Reviewed by Tim Hatcher.

        <rdar://problem/4985524> Problem with Blot and ToT WebKit (decoding WebCoreScrollView)

        References to WebCoreScrollView as a subview of a WebHTMLView may be present in some NIB
        files, so NSUnarchiver must be still able to look up the WebCoreScrollView class.

        * WebKit.exp: Export WebCoreScrollView symbol.
        * WebView/WebHTMLView.mm: Add empty WebCoreScrollView class.

2007-02-27  Adam Roben  <aroben@apple.com>

        Reviewed by Beth.

        Fix <rdar://problem/5011905> REGRESSION: "Open Link" contextual menu
        item appears twice

        * WebCoreSupport/WebContextMenuClient.mm:
        (fixMenusToSendToOldClients): Remove the "Open Link" item from the
        default menu items array before sending it off to Tiger Mail.
        (WebContextMenuClient::getCustomMenuFromDefaultItems): Set the
        representedObject on every NSMenuItem to match our old (correct) API
        behavior.

2007-02-27  Mitz Pettel  <mitz@webkit.org>

        Reviewed by Darin.

        - http://bugs.webkit.org/show_bug.cgi?id=12906
          REGRESSION: Canvas is pixelated when the page is opened in a background tab

        * WebCoreSupport/WebChromeClient.mm:
        (WebChromeClient::scaleFactor): If the view is not in a window, use the main
        screen's scale factor as a best guess.

2007-02-26  John Sullivan  <sullivan@apple.com>

        Reviewed by Darin and Geoff

        * WebView/WebHTMLView.mm:
        (coreGraphicsScreenPointForAppKitScreenPoint):
        This method was copied from WebBrowser, and it was wrong. Fixed it. This only
        affects the Dictionary pop-up panel.

2007-02-26  David Hyatt  <hyatt@apple.com>

        Update web inspector to account for border-fit.

        Reviewed by darin

        * WebInspector/webInspector/inspector.js:

2007-02-26  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Darin Adler.
        
        Re-arranged things to put deprecated methods at the bottom.

        * Misc/WebCoreStatistics.h:
        * Misc/WebCoreStatistics.mm:
        (+[WebCoreStatistics javaScriptNoGCAllowedObjectsCount]):
        (+[WebCoreStatistics javaScriptReferencedObjectsCount]):
        (+[WebCoreStatistics javaScriptRootObjectClasses]):
        * WebKit.xcodeproj/project.pbxproj:

2007-02-26  Maciej Stachowiak  <mjs@apple.com>

        Rubber stamped by Mitz.
        
        - fix layout tests by fixing discrepancy in feature macros.

        * WebInspector/WebInspector.m:
        (-[WebInspector _highlightNode:]):
        * WebKit.xcodeproj/project.pbxproj:

2007-02-23  Mitz Pettel  <mitz@webkit.org>

        Reviewed by Maciej.

        - fix http://bugs.webkit.org/show_bug.cgi?id=11573
          REGRESSION: pressing option-left arrow while in suggestion popup moves the insertion point to the left

        * WebView/WebHTMLView.mm:
        (-[WebTextCompleteController endRevertingChange:moveLeft:]):

2007-02-23  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Brady.

        <rdar://problem/5016395> _recursive_pauseNullEventsForAllNetscapePlugins still gone

        * WebView/WebFrameInternal.h: Remove _recursive_pauseNullEventsForAllNetscapePlugins
        * WebView/WebFramePrivate.h: Add _recursive_pauseNullEventsForAllNetscapePlugins
        * WebView/WebFrame.mm: More _recursive_pauseNullEventsForAllNetscapePlugins

2007-02-22  Adele Peterson  <adele@apple.com>

        Reviewed by John.

        Updating this image to match the one in WebCore.

        * WebKit.vcproj/textAreaResizeCorner.png:

2007-02-22  Beth Dakin  <bdakin@apple.com>

        Reviewed by Adam.

        Fix for http://bugs.webkit.org/show_bug.cgi?id=12399 REGRESSION: 
        Unable to prevent default context menu from appearing. <rdar://
        problem/5017416>

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView menuForEvent:]): Clear the controller's context menu 
        before propagating a new context menu event through the DOM.

2007-02-22  John Sullivan  <sullivan@apple.com>

        Reviewed by Darin
        
        Removed some unused keyView-related code that I happened to run across.
        Replacement code is now in WebChromeClient.

        * WebCoreSupport/WebFrameBridge.h:
        * WebCoreSupport/WebFrameBridge.mm:
        removed unused stuff

2007-02-22  Mitz Pettel  <mitz@webkit.org>

        Reviewed by Maciej.

        - fix http://bugs.webkit.org/show_bug.cgi?id=12804
          REGRESSION (r19043-r19063): suggestion popup doesn't work after pressing Option+Esc

        This patch also fixes a bug where using the arrow keys while
        the suggestion popup is open moves the caret instead of changing the
        selection in the popup (for up/down) or accepting the selection and
        closing the popup (for left/right).

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView keyDown:]): Changed to close the popup only if it was open
        before the current event, so that the Option-Esc that opens the popup will
        not close it immediately.
        (-[WebHTMLView _interceptEditingKeyEvent:]): Give the completion popup a
        chance to intercept keydown events.
        (-[WebTextCompleteController popupWindowIsOpen]): Added. Returns whether the
        suggestion popup is open.

2007-02-22  Mitz Pettel  <mitz@webkit.org>

        Reviewed by Mark (age 21).

        - fix http://bugs.webkit.org/show_bug.cgi?id=12805
          REGRESSION: suggestion popup has a disabled scroll bar

        * WebView/WebHTMLView.mm:
        (-[WebTextCompleteController _buildUI]): Uncommented the call to the NSWindow
        SPI that forces the scroll bar to look active. Also replaced a call to
        the deprecated NSTableView method setAutoresizesAllColumnsToFit: with
        the new method setColumnAutoresizingStyle: to eliminate console spew.

2007-02-20  Beth Dakin  <bdakin@apple.com>

        Reviewed by Maciej.

        WebKit changes needed to implement writeImage() in WebCore's 
        Pasteboard class.

        * Misc/WebKitNSStringExtras.m: Call into WebCore for these 
        implementations.
        (-[NSString _webkit_hasCaseInsensitiveSuffix:]):
        (-[NSString _webkit_hasCaseInsensitiveSubstring:]):
        (-[NSString _webkit_filenameByFixingIllegalCharacters]):
        * Misc/WebNSURLExtras.m: Same.
        (-[NSURL _webkit_suggestedFilenameWithMIMEType:]):
        * WebCoreSupport/WebContextMenuClient.h: Remove 
        copyImageToClipboard()
        * WebCoreSupport/WebContextMenuClient.mm:
        * WebCoreSupport/WebSystemInterface.m: Expose 
        GetExtensionsForMIMEType and GetPreferredExtensionForMIMEType to 
        WebCore.
        (InitWebCoreSystemInterface):
        * WebCoreSupport/WebViewFactory.mm: New localized string for 
        WebCore. 
        (-[WebViewFactory copyImageUnknownFileLabel]):

2007-02-20  Adam Roben  <aroben@apple.com>

        Reviewed by Darin and Anders.

        Update WebKit for WebCore fix for <rdar://problem/4736215> Make
        WebCoreStringTruncator use WebCore types.

        * Misc/WebStringTruncator.m:
        (defaultMenuFont): Moved from WebCoreStringTruncator.mm.
        (core): Added.
        (+[WebStringTruncator centerTruncateString:toWidth:]):
        (+[WebStringTruncator centerTruncateString:toWidth:withFont:]):
        (+[WebStringTruncator rightTruncateString:toWidth:withFont:]):
        (+[WebStringTruncator widthOfString:font:]):
        * WebKit.xcodeproj/project.pbxproj: Changed WebStringTruncator to ObjC++.

2007-02-20  Timothy Hatcher  <timothy@apple.com>

        Reviewed by John.

        Fixes the version number returned when using a CFBundleVersion of "420+".

        * WebView/WebView.mm:
        (-[WebView _userVisibleBundleVersionFromFullVersion:]): Check the length up to the first
        non-decimal digit, so this works with versions that have "." and "+".

2007-02-20  John Sullivan  <sullivan@apple.com>

        Reviewed by Kevin Decker
        
        - fixed <rdar://problem/4989344> REGRESSION: After clicking on page, Find
        won't find anything if all hits are before the clicked point
        
        This was caused by a mismatch between WebCore's search code's notion of "selection" and
        WebView's search code's notion of "selection". WebCore's search code was starting 
        just before or just after the "selection", which included collapsed, zero-length
        selections. WebKit's search code was only considering non-zero-length selections,
        and would not search all of the content when there was a zero-length selection.
        The fix was to make WebKit ignore the selection. This has a side effect of increasing 
        the amount of redundantly-searched content in the case where no matches are found. To
        compensate for that, I special-cased the most common case of WebViews with a single frame, 
        to avoid ever searching redundantly in those.

        * WebView/WebView.mm:
        (-[WebView searchFor:direction:caseSensitive:wrap:startInSelection:]):
        remove startHasSelection ivar; special-case WebViews with only one frame; clarify the
        code that leads to redundant searching with comments.

2007-02-20  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Darin.

        <rdar://problem/4900579> WebKit -finalize methods are not thread-safe; design change needed

        Call WebCoreObjCFinalizeOnMainThread from the initialize method of all the classes
        that have a finalizer that needs called on the main thread. Assert in finalize that we
        are on the main thread.

        * Carbon/CarbonWindowAdapter.m:
        (+[CarbonWindowAdapter initialize]):
        (-[CarbonWindowAdapter finalize]):
        * History/WebBackForwardList.mm:
        (+[WebBackForwardList initialize]):
        (-[WebBackForwardList finalize]):
        * History/WebHistoryItem.mm:
        (+[WebHistoryItem initialize]):
        * Misc/WebElementDictionary.mm:
        (+[WebElementDictionary initialize]):
        (-[WebElementDictionary finalize]):
        * Plugins/WebBaseNetscapePluginStream.m:
        (+[WebBaseNetscapePluginStream initialize]):
        (-[WebBaseNetscapePluginStream finalize]):
        * Plugins/WebBaseNetscapePluginView.mm:
        (+[WebBaseNetscapePluginView initialize]):
        (-[WebBaseNetscapePluginView finalize]):
        * Plugins/WebBasePluginPackage.m:
        (+[WebBasePluginPackage initialize]):
        (-[WebBasePluginPackage finalize]):
        * Plugins/WebNetscapePluginStream.mm:
        (-[WebNetscapePluginStream finalize]):
        * WebCoreSupport/WebEditorClient.mm:
        (+[WebEditCommand initialize]):
        (-[WebEditCommand finalize]):
        * WebCoreSupport/WebFrameBridge.mm:
        (+[WebFrameBridge initialize]):
        (-[WebFrameBridge finalize]):
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (+[WebFramePolicyListener initialize]):
        (-[WebFramePolicyListener finalize]):
        * WebView/WebHTMLView.mm:
        (+[WebHTMLView initialize]):
        (-[WebHTMLView finalize]):
        * WebView/WebView.mm:
        (+[WebViewPrivate initialize]):
        (-[WebViewPrivate finalize]):

2007-02-20  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by darin
        
        <rdar://problem/4838199>
        Integrate Mail and WebKit paste operations
        
        Mail overrides paste: because it has different
        preferred pasteboard types, but it should use our
        fragment creation code.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _documentFragmentFromPasteboard:inContext:allowPlainText:chosePlainText:]):
        Moved fragment creation code into a new method.
        (-[WebHTMLView _documentFragmentFromPasteboard:forType:inContext:]):
        Moved fragment creation code here.
        * WebView/WebHTMLViewPrivate.h: Exposed 
        _documentFragmentFromPasteboard:forType:inContext: as SPI.

2007-02-20  John Sullivan  <sullivan@apple.com>

        Reviewed by Tim Hatcher

        * Misc/WebKitNSStringExtras.h:
        * Misc/WebKitNSStringExtras.m:
        removed _webkit_userVisibleBundleVersionFromFullVersion; we decided to do this without
        adding SPI for it.

        * WebView/WebView.mm:
        (-[WebView _userVisibleBundleVersionFromFullVersion:]):
        new method, moved here from WebKitNSStringExtras, and is now a WebView method rather than
        an NSString method
        (-[WebView _computeUserAgent]):
        updated for method signature change

2007-02-20  Timothy Hatcher  <timothy@apple.com>

        Reviewed by John.

        * Misc/WebKitNSStringExtras.h: Added _webkit_userVisibleBundleVersionFromFullVersion.
        * Misc/WebKitNSStringExtras.m:
        (-[NSString _webkit_userVisibleBundleVersionFromFullVersion]): If the version is 4 digits long or longer,
        then the first digit represents the version of the OS. Our user agent string should not
        include this first digit, so strip it off and report the rest as the version.
        * WebView/WebView.mm:
        (-[WebView _computeUserAgent]): Call _webkit_userVisibleBundleVersionFromFullVersion on the CFBundleVersion.

2007-02-20  Darin Adler  <darin@apple.com>

        Reviewed by Anders.

        * Plugins/WebPluginController.mm: (-[WebPluginController pluginView:receivedResponse:]):
        Call cancelMainResourceLoad on the document loader instead of the frame loader.

2007-02-20  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by Mitz.

        <rdar://problem/5009627> REGRESSION: Repro overrelease of WebView in failed load, seen in DumpRenderTree
        
        * WebView/WebView.mm:
        (-[WebView _removeObjectForIdentifier:]):
        Return early if the identifier can't be found in the map.

2007-02-19  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Darin Adler.

        <rdar://problem/4841078> Remove the Mail.app editable link clicking behavior workaround when it is no longer needed

        * WebKit.xcodeproj/project.pbxproj:
        * WebView/WebView.mm:
        (-[WebView setPreferences:]):

2007-02-19  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by Adam.

        <rdar://problem/4868242>
        http://bugs.webkit.org/show_bug.cgi?id=12670
        REGRESSION: Many 3rd Party Apps crash in WebCore::DocumentLoader::frameLoader() (12670)
        
        Bring back the semantic we had that a web view should be retained for as long as something is loading. Use the identifier
        to object hash map for this.

        * WebView/WebView.mm:
        (-[WebView _addObject:forIdentifier:]):
        (-[WebView _removeObjectForIdentifier:]):

2007-02-18  Brady Eidson  <beidson@apple.com>

        Reviewed by Oliver

        <rdar://problem/4985321> - Can't edit templates for Web Gallery/Web Page Export in Aperture

        * Misc/WebKitVersionChecks.h: Add a #define for this APERTURE quirk
        * WebView/WebView.mm:
        (-[WebView _shouldChangeSelectedDOMRange:toDOMRange:affinity:stillSelecting:]):
         If the current app is Aperture and it was linked against Tiger WebKit, always allow selection change

2007-02-17  Lars Knoll <lars@trolltech.com>

        Reviewed by Maciej.

        Additional coding by Maciej, additional review by Oliver.

        Added implementations for the new callbacks in EditorClient
        and ChromeClient (basically moved from WebFrameBridge).
        Cleaned up some code paths that are not called anymore
        and done fully inside WebCore now.

        * DefaultDelegates/WebDefaultContextMenuDelegate.mm:
        * Misc/WebElementDictionary.mm:
        * Misc/WebNSAttributedStringExtras.mm:
        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView getVariable:value:]):
        * Plugins/WebNetscapePluginEmbeddedView.mm:
        * Plugins/WebNetscapePluginStream.mm:
        * Plugins/WebPluginContainerCheck.mm:
        * WebCoreSupport/WebChromeClient.h:
        * WebCoreSupport/WebChromeClient.mm:
        (WebChromeClient::shouldInterruptJavaScript):
        * WebCoreSupport/WebEditorClient.h:
        * WebCoreSupport/WebEditorClient.mm:
        (WebEditorClient::shouldChangeSelectedRange):
        * WebCoreSupport/WebFrameBridge.mm:
        (-[WebFrameBridge finishInitializingWithPage:frameName:frameView:ownerElement:]):
        (-[WebFrameBridge fini]):
        * WebCoreSupport/WebFrameLoaderClient.mm:
        * WebView/WebArchiver.mm:
        * WebView/WebFrame.mm:
        (core):
        (kit):
        (-[WebFrame _updateBackground]):
        * WebView/WebFrameInternal.h:
        * WebView/WebFrameView.mm:
        * WebView/WebHTMLRepresentation.mm:
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _updateMouseoverWithEvent:]):
        (-[WebHTMLView _isEditable]):
        (-[WebHTMLView validateUserInterfaceItem:]):
        (-[WebHTMLView maintainsInactiveSelection]):
        (-[WebHTMLView scrollWheel:]):
        (-[WebHTMLView acceptsFirstMouse:]):
        (-[WebHTMLView shouldDelayWindowOrderingForEvent:]):
        (-[WebHTMLView cut:]):
        (-[WebHTMLView paste:]):
        (-[WebHTMLView selectedAttributedString]):
        * WebView/WebScriptDebugDelegate.mm:
        * WebView/WebView.mm:
        (-[WebView _dashboardRegions]):
        (-[WebView setProhibitsMainFrameScrolling:]):
        (-[WebView _setInViewSourceMode:]):
        (-[WebView _inViewSourceMode]):
        (-[WebView shouldClose]):
        (-[WebView setEditable:]):

2007-02-18  Oliver Hunt  <oliver@apple.com>

        Reviewed by Adam.

        Moving the drag initiation logic to WebCore.
        The redundant code in webkit will be moved out in a later patch.

        * WebCoreSupport/WebDragClient.h:
        * WebCoreSupport/WebDragClient.mm:
        (getTopHTMLView):
          Helper function
        (WebDragClient::willPerformDragSourceAction):
        (WebDragClient::startDrag):
        (WebDragClient::createDragImageForLink):
          Implemented new DragClient methods
        (WebDragClient::declareAndWriteDragImage):
          Helper function for the Mac to allow new drag and drop
          code to match behaviour
          
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _dragImageForURL:withLabel:]):
        (-[WebHTMLView _dragImageForLinkElement:]):
          Refactoring old _dragImageForLinkElement function so that 
          the link drag image can be created with just a URL and label, 
          rather than requiring the original element
        (-[WebHTMLView dragImage:at:offset:event:pasteboard:source:slideBack:]):
          Removed logic that is no longer necessary                 
        (-[WebHTMLView _mouseDownEvent]):
          The WebDragClient may need the original mouseDownEvent of a drag when initiating
          a drag
        * WebView/WebHTMLViewInternal.h:
          Declaring _mouseDownEvent

        * WebView/WebHTMLViewPrivate.h:
          Declaring _dragImageForURL

2007-02-16  John Sullivan  <sullivan@apple.com>

        Reviewed by Tim Hatcher

        - fixed <rdar://problem/4811446> "Check Grammar" checkbox in Spelling+Grammar window doesn't 
        live update with menu change in WebKit

        * WebView/WebView.mm:
        (-[WebView setGrammarCheckingEnabled:]):
        Use sekrit AppKit knowledge to tell NSSpellChecker about the change, since there's no API
        for this yet. Also restructured a little to avoid extra work when the value hasn't changed.

2007-02-15  Brady Eidson  <beidson@apple.com>

        Reviewed by Adam

        Save scroll state for back/forward navigation in FrameLoader, not the client

        * WebCoreSupport/WebFrameLoaderClient.h: Renamed the save/restore methods
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::saveViewStateToItem): Save viewstate only
        (WebFrameLoaderClient::restoreViewState): Restore viewstate only

2007-02-14  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin.

        http://bugs.webkit.org/show_bug.cgi?id=12643
        NPN_Status is using latin-1 encoding for the message instead of UTF-8

        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView status:]): Check for possible conversion failure.

2007-02-13  Oliver Hunt  <oliver@apple.com>

        Reviewed by John.

        Modify entry point ASSERTs for dragging functions to allow for the case
        where a load has occurred mid-drag.  The load may detach the HTMLView 
        from the WebView so it is no longer possible to check _isTopHTMLView.

        The assertion changes match that of revision 14897 which fixed the 
        more common case ([WebHTMLView draggedImage:endedAt:operation:])

        It's also necessary to check for a null Page now prior to accessing 
        the DragController, which is necessary in all of these methods.

        See rdar://problem/4994870
                                             
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView draggingSourceOperationMaskForLocal:]):
        (-[WebHTMLView draggedImage:movedTo:]):
        (-[WebHTMLView draggedImage:endedAt:operation:]):
        (-[WebHTMLView namesOfPromisedFilesDroppedAtDestination:]):

2007-02-13  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Maciej.

        http://bugs.webkit.org/show_bug.cgi?id=12643
        NPN_Status is using latin-1 encoding for the message instead of UTF-8

        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView status:]): Use kCFStringEncodingUTF8.

2007-02-13  Mark Rowe  <mrowe@apple.com>

        Reviewed by Timothy Hatcher.

        Fix http://bugs.webkit.org/show_bug.cgi?id=12745
        Bug 12745: REGRESSION: Webkit will not load a plugin that Safari can load (symbol missing _objc_msgSend_fpret)

        Treat libobjc as a sub-library of WebKit in Debug/Release so that plugins and applications linked against an
        umbrella framework version of WebKit that expect to find libobjc symbols in WebKit can do so.

        * WebKit.xcodeproj/project.pbxproj:

2007-02-12  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by .

        - reverting change to not cause regressions and performance problems.

        * Misc/WebNSAttributedStringExtras.mm:
        (fileWrapperForElement):

2007-02-12  Darin Adler  <darin@apple.com>

        Reviewed by Oliver.

        - fix http://bugs.webkit.org/show_bug.cgi?id=12677
          <rdar://problem/4759563> REGRESSION: Return key is always sent when you confirm
          a clause in kotoeri (12677)

        - fix http://bugs.webkit.org/show_bug.cgi?id=12596
          <rdar://problem/4794346> REGRESSION: Tab key shifts form field focus instead of
          navigating prediction window (12596)

        - fix http://bugs.webkit.org/show_bug.cgi?id=10010
          <rdar://problem/4822935> REGRESSION: Pressing Return with unconfirmed text in
          Hangul inserts carriage return (10010)

        - fix http://bugs.webkit.org/show_bug.cgi?id=12531
          <rdar://problem/4975126> REGRESSION: Inline text input types repeated keys in
          latest nightly (r19336) (12531)

        - fix http://bugs.webkit.org/show_bug.cgi?id=12539
          <rdar://problem/4975130> REGRESSION: Pressing Backspace while in inline input
          area moves to the previous page in history (12539)

        * WebCoreSupport/WebEditorClient.h:
        * WebCoreSupport/WebEditorClient.mm: (WebEditorClient::markedTextAbandoned):
        Added.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView menuForEvent:]): Added explicit constructor needed now that the
        function takes a const&.
        (-[WebHTMLView becomeFirstResponder]): Removed fake event code, no longer needed
        since advanceFocus now works fine with 0 for a DOM event.
        (-[WebHTMLView _expandSelectionToGranularity:]): Changed to use the normal
        selection controller function instead of selectRange.
        (-[WebHTMLView insertTab:]): Changed to call bottleneck that receives the DOM
        event.
        (-[WebHTMLView insertBacktab:]): Ditto.
        (-[WebHTMLView insertNewline:]): Ditto.
        (-[WebHTMLView insertLineBreak:]): Ditto.
        (-[WebHTMLView insertParagraphSeparator:]): Ditto.
        (-[WebHTMLView insertNewlineIgnoringFieldEditor:]): Ditto.
        (-[WebHTMLView insertTabIgnoringFieldEditor:]): Ditto.
        (-[WebHTMLView yank:]): Updated to call Editor directly since the insertText
        code now works via a text input event which is not what we want for paste-like
        things such as yank.
        (-[WebHTMLView yankAndSelect:]): Ditto.
        (-[WebHTMLView selectToMark:]): Changed to use the normal selection controller
        function instead of selectRange, which also allows us to remove the ObjC exception
        handling code.
        (-[WebHTMLView swapWithMark:]): Ditto.
        (-[WebHTMLView transpose:]): Ditto.
        (-[WebHTMLView unmarkText]): Since this is one of the calls back from the input
        manager, added code to set the "event was handled" flag. Moved the actual work
        into the Editor class in WebCore and just call that from here.
        (-[WebHTMLView _selectRangeInMarkedText:]): Changed to use the normal selection
        controller function instead of selectRange.
        (-[WebHTMLView setMarkedText:selectedRange:]): Since this is one of the calls
        back from the input manager, added code to set the "event was handled" flag.
        Also changed the ignoreMarkedTextSelectionChange to use the flag over on the
        WebCore side, since we moved it there and to call selectMarkedText over on
        the WebCore side too.
        (-[WebHTMLView doCommandBySelector:]): Added special cases for newline and tab
        selectors so that the event is passed along. These selectors are special because
        they are ones that turn into text input events.
        (-[WebHTMLView _discardMarkedText]): Moved the body of this function into the
        Editor class in WebCore and just call that from here.
        (-[WebHTMLView insertText:]): Added code to send a text input event instead of
        calling the editor to do text insertion. The insertion is then done in the
        default handler for the text input event.
        (-[WebHTMLView _insertNewlineWithEvent:isLineBreak:]): Added. Sends a text
        input event.
        (-[WebHTMLView _insertTabWithEvent:isBackTab:]): Ditto.
        (-[WebHTMLView _updateSelectionForInputManager]): Changed to use the
        ignoreMarkedTextSelectionChange flag in Editor now that the one here is gone.

        * WebView/WebHTMLViewInternal.h: Remove ignoreMarkedTextSelectionChange field.

        * WebView/WebView.mm: (-[WebView setSelectedDOMRange:affinity:]): Changed to
        use the normal selection controller function instead of selectRange.

2007-02-11  Sam Weinig  <sam@webkit.org>

        Reviewed by Mark.

        Switch the initial value of box-sizing property from "border-box" to "content-box".

        * WebInspector/webInspector/inspector.js:

2007-02-10  Mitz Pettel  <mitz@webkit.org>

        Reviewed by Maciej.

        - fix http://bugs.webkit.org/show_bug.cgi?id=11847
          REGRESSION (SearchField): Dragging to select in the Web Inspector's search fields drags the inspector window

        * WebInspector/webInspector/inspector.css: Added the search field to the
        undraggable dashboard-region.

2007-02-09  Kevin Decker <kdecker@apple.com>

        Reviewed by Darin & Maciej.

        Fixed: <rdar://problem/4930688> REGRESSION: missing images when reloading webarchives (11962)
        
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::canUseArchivedResource): The bug here is that because a reload sets a cache
        policy of NSURLRequestReloadIgnoringCacheData (rightfully so), this method was refusing to load
        subresources in WebArchives. It's OK to use archive subresources for the NSURLRequestReloadIgnoringCacheData
        cache policy because we're not worried about the actual contents of a WebArchive changing on disk. 

2007-02-09  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by darin
        
        <rdar://problem/4975120>
        REGRESSION: double-cursor after switching window away/back (11770)
        <http://bugs.webkit.org/show_bug.cgi?id=11328>
        Gmail Editor: Caret can simultaneously appear in both the TO: and message body fields

        * WebCoreSupport/WebFrameBridge.mm: Removed unused methods.
        * WebView/WebHTMLView.mm: Ditto.
        (-[WebHTMLView _web_firstResponderCausesFocusDisplay]): Don't 
        appear focused if a descendant view is firstResponder.
        (-[WebHTMLView _updateActiveState]): Removed the check for a BOOL
        that was always false.
        * WebView/WebHTMLViewInternal.h: Removed a BOOL that's always false.

2007-02-09  Beth Dakin  <bdakin@apple.com>

        Reviewed by Darin.

        Fix for <rdar://problem/4674537> REGRESSION: Adobe Acrobat 8 - Text 
        blinks when mouse is moved, and is invisible otherwise

        Allow quirk if the Application was linked before 3.0 and if the 
        application is Adobe Acrobat.

        * Misc/WebKitVersionChecks.h:
        * WebView/WebView.mm:
        (-[WebView _updateWebCoreSettingsFromPreferences:]):

2007-02-09  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Brady.

        * WebKit.exp: Add WebBaseNetscapePluginView to the export list.

2007-02-09  John Sullivan  <sullivan@apple.com>

        Reviewed by Beth

        - WebKit part of fix for radar 4939636, problems with context menu items and binaries linked
          against WebKit 2.0.

        * WebKit.xcodeproj/project.pbxproj:
        Changed DYLIB_CURRENT_VERSION to 2 (was 1)

        * Misc/WebKitVersionChecks.h:
        Added constant WEBKIT_FIRST_VERSION_WITH_3_0_CONTEXT_MENU_TAGS, which is 2 but in the weird
        format that these version checks use.

        * WebView/WebUIDelegatePrivate.h:
        Tweaked comments; included the old values for three tags for context menu items that changed
        from SPI to API in 3.0; renamed WEBMENUITEMTAG_SPI_START to WEBMENUITEMTAG_WEBKIT_3_0_SPI_START 
        for clarity, and bumped its value to avoid conflict with the three old values

        * WebCoreSupport/WebContextMenuClient.mm:
        (isAppleMail):
        new helper function that checks the bundle identifier
        (fixMenusToSendToOldClients):
        Removed return value for clarity; now checks linked-on version and also makes special case
        for Mail; now replaces three API tags with their old SPI values for clients that linked
        against old WebKit version, in addition to replacing new API with WebMenuItemTagOther for
        items that had no specific tag before.
        (fixMenusReceivedFromOldClients):
        Removed return value for clarity; removed defaultMenuItems parameter because it's no longer 
        necessary; removed code that tried to recognize menus that got confused by the SPI -> API 
        change (we now pass the old SPI values to these clients to avoid confusing them); now 
        restores the tags for the items whose tags were replaced in fixMenusToSendToOldClients 
        (this used to restore the tags of the default items rather than the new items, which was 
        incorrect but happened to work since the clients we tested were using the objects from the
        default items array in their new items array)
        (WebContextMenuClient::getCustomMenuFromDefaultItems):
        Updated to account for the removed return values for the two fix-up methods; moved the
        autorelease of newItems here, which is clearer and was the source of a leak before.

2007-02-08  Kevin McCullough  <KMcCullough@apple.com>

        Reviewed by

        - fixing a build breakage. 

        * Misc/WebNSAttributedStringExtras.mm:
        (fileWrapperForElement):

2007-02-07  Charles Ying  <charles_ying@yahoo.com>

        Reviewed by Adam.

        Code suggestion by aroben
        
        Fix http://bugs.webkit.org/show_bug.cgi?id=12688

        REGRESSION (r19469): ASSERT when right clicking on hyperlinks! in TOT webkit
        
        * WebCoreSupport/WebContextMenuClient.mm:
        (fixMenusReceivedFromOldClients):

        - fixMenusReceivedFromOldClients was hitting an ASSERT incorrectly
        because it could not match [item title] to any of the contentMenuItemTags
        using pointer comparison ==. Instead, it needs to do a string comparison
        between [item title] and the various contentMenuItemTags using
        isEqualToString instead of ==. You would encounter this whenever the
        context menu was activated, e.g., from a hyperlink right click (or
        control click).


2007-02-07  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by Maciej.

        Move shouldInterruptJavaScript to the Chrome.
        
        * WebCoreSupport/WebChromeClient.h:
        * WebCoreSupport/WebChromeClient.mm:
        (WebChromeClient::shouldInterruptJavaScript):
        * WebCoreSupport/WebFrameBridge.mm:

2007-02-07  John Sullivan  <sullivan@apple.com>

        Reviewed by Kevin Decker

        - fixed all places in WebKit where _web_userVisibleString was used where
        _web_originalDataAsString should have been used instead.

        * History/WebURLsWithTitles.m:
        (+[WebURLsWithTitles writeURLs:andTitles:toPasteboard:]):
        use _web_originalDataAsString when writing since these aren't displayed to the user
        (+[WebURLsWithTitles URLsFromPasteboard:]):
        use _web_URLWithDataAsString when reading, to match what we used when writing

        * Misc/WebNSPasteboardExtras.mm:
        (-[NSPasteboard _web_writeURL:andTitle:types:]):
        use _web_originalDataAsString when writing the NSURL type; continue using
        _web_userVisibleString when writing the plain text type

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _documentFragmentWithPaths:]):
        added comment about why _web_userVisibleString is appropriate here
        (-[WebHTMLView _documentFragmentFromPasteboard:inContext:allowPlainText:chosePlainText:]):
        use _web_originalDataAsString when setting the href attribute of an anchor tag

2007-02-07  David Harrison  <harrison@apple.com>

        Reviewed by Adam.

        <rdar://problem/4943650> REGRESSION: insertion point blink redraws entire web page, making everything slow

        Problem is that AppKit recently changed NSControl to trigger a full redraw if the control has a focus ring.
        WebHTMLView is a subclass of NSControl, but the focus ring type was the default value, though we actually
        draw no focus ring. Fix is to formally set our focus ring type.

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView initWithFrame:]):
        Send [self setFocusRingType:NSFocusRingTypeNone].

2007-02-07  John Sullivan  <sullivan@apple.com>

        Undid changes that I hadn't intended to check in

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _documentFragmentWithPaths:]):
        (-[WebHTMLView _documentFragmentFromPasteboard:inContext:allowPlainText:chosePlainText:]):

2007-02-07  John Sullivan  <sullivan@apple.com>

        Reviewed by Ollie and Geoff

        - fixed <rdar://problem/4982345> KURL::createCFURL leak inside -[WebFrameBridge startDraggingImage...] 
        reported by buildbot

        (-[WebHTMLView _startDraggingImage:at:operation:event:sourceIsDHTML:DHTMLWroteData:]):
        don't retain the imageURL we pass to the drag controller -- it's just automagically
        converted to a KURL anyway

2007-02-07  John Sullivan  <sullivan@apple.com>

        Reviewed by Darin

        - fixed <rdar://problem/4974420> REGRESSION: Dragging a saved image into the browser window 
        displays a error (No File exists at the address "null") (12662)

        * WebCoreSupport/WebPasteboardHelper.mm:
        (WebPasteboardHelper::urlFromPasteboard):
        use _web_originalDataAsString instead of _web_userVisibleString, since _web_userVisibleString
        can return a string with non-ASCII characters -- suitable for display but not for code

2007-02-07  John Sullivan  <sullivan@apple.com>

        Reviewed by Darin

        - added some clarity to some menu-handling shenanigans

        * WebCoreSupport/WebContextMenuClient.mm:
        (fixMenusToSendToOldClients):
        renamed from fixMenusForOldClients; added comments, FIXME, and assertion
        (fixMenusReceivedFromOldClients):
        renamed from fixMenusFromOldClients; added comments, FIXME, and assertion
        (WebContextMenuClient::getCustomMenuFromDefaultItems):
        updated for name changes

2007-02-06  Kevin Decker <kdecker@apple.com>

        Fixed: <rdar://problem/4976681> ASSERTION failure on quit @ talkcrunch.com in _NPN_ReleaseObject
        
        Reviewed by Anders.

        * Plugins/WebPluginDatabase.m:
        (+[WebPluginDatabase sharedDatabase]): Removed NSApplicationWillTerminateNotification observer and thus
        also removed code that would unload the entire plug-in database when receiving that notification. 
        
        The bug here was that this notification callback would happen first before anything else thus unloading
        plug-ins and releasing plug-in memory. That was crash prone because the JavaScriptCore collector would at
        a later time attempt to release its CInstance references (references that point to plug-in memory)
        without knowing WebKit already unloaded the plug-in out from underneath it. The WebPluginDatabase simply
        does not have enough context to make this decision.
        
        * WebView/WebView.mm: Added two statics: applicationIsTerminating, pluginDatabaseClientCount.
        (+[WebView initialize]): Added NSApplicationWillTerminateNotification observer.
        (+[WebView _applicationWillTerminate]): Added. 
        (-[WebView _close]): WebKit has both a global plug-in database and a separate, per WebView plug-in database. 
         We need to release both sets of plug-ins because Netscape plug-ins have "destructor functions" that should be
         called when the browser unloads the plug-in.  These functions can do important things, such as closing/deleting
         files so it is important to ensure that they are properly called when the application terminates.
         
         The new change is that on app shutdown, we unload WebKit's global plug-in database if and only if the last WebView
         was closed. To do so otherwise would unload plug-ins out from underneath other WebViews.
         
2007-02-06  Darin Adler  <darin@apple.com>

        Reviewed by John Sullivan.

        - fix http://bugs.webkit.org/show_bug.cgi?id=11080
          <rdar://problem/4826648> REGRESSION: Incorrect vertical positioning of Safari
          status bar text containing @ character (11080)

        * Misc/WebKitNSStringExtras.m:
        (canUseFastRenderer): Fix code that mistakenly used the slow renderer for strings
        that have a direction of "other neutral", which includes the "@" character.
        (-[NSString _web_drawAtPoint:font:textColor:]): Add code to make the baseline of
        the text in the status bar right. AppKit's rule for rounding is complicated enough
        that this is obviously not perfectly correct, but it does make both code paths
        use the same baseline in all the places this is currently used in AppKit.

2007-02-06  Darin Adler  <darin@apple.com>

        Spotted by Steve F.

        * Misc/WebNSURLExtras.m:
        (-[NSString _web_mapHostNameWithRange:encode:makeString:]):
        Fix obvious logic mistake I introduced back in revision 8255.
        I can't see how to exercise this code path, but I also can't
        bear to leave this obviously-broken code as-is.

2007-02-05  David Kilzer  <ddkilzer@webkit.org>

        Reviewed by Darin.

        http://bugs.webkit.org/show_bug.cgi?id=7266
        Webarchive format saves duplicate WebSubresources to .webarchive file

        Tests: webarchive/test-duplicate-resources.html
               webarchive/test-frameset.html

        * WebView/WebArchiver.mm:
        (+[WebArchiver _archiveWithMarkupString:fromFrame:nodes:]): Use an NSMutableSet to prevent
        duplicate subresources from being added to the webarchive.

2007-02-06  Mark Rowe  <mrowe@apple.com>

        Roll out incomplete support for font-stretch (r19350) at Dave Hyatt's request.
        See http://bugs.webkit.org/show_bug.cgi?id=12530#c9 for more info.

        * WebInspector/webInspector/inspector.js:
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _addToStyle:fontA:fontB:]):

2007-02-05  Beth Dakin  <bdakin@apple.com>

        Reviewed by Adam.

        Fix for <rdar://problem/4975161> REGRESSION: With BumperCar 2.1.1, 
        the contextual menu fails to appear when I ctrl-click on page

        * WebCoreSupport/WebContextMenuClient.mm:
        (WebContextMenuClient::getCustomMenuFromDefaultItems): If the 
        delegate does not respond to contextMenuItemsForElement, return the 
        default menu instead of nil.

2007-02-01  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Maciej Stachowiak.
        
        Added support for selectively ignoring WebCore::Node leaks during layout
        tests, so that we can ignore known leaks in other components.

        * Misc/WebCoreStatistics.h:
        * Misc/WebCoreStatistics.mm:
        (+[WebCoreStatistics startIgnoringWebCoreNodeLeaks]):
        (+[WebCoreStatistics stopIgnoringWebCoreNodeLeaks]):

2007-02-01  Nicholas Shanks  <webkit@nickshanks.com>

        Reviewed by Mark.

        Add support for CSS2 font-stretch property.

        * WebInspector/webInspector/inspector.js:
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _addToStyle:fontA:fontB:]):

2007-02-01  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Adam.
        
        <rdar://problem/4730469> REGRESSION: Assertion failure in -[WebDataSource(WebInternal) _bridge] when forwarding message

        * WebView/WebDataSource.mm:
        (-[WebDataSource subresources]): Check for being uncommitted and return emtpy result.
        (-[WebDataSource subresourceForURL:]): ditto

2007-01-31  Oliver Hunt  <oliver@apple.com>

        Reviewed by Adam.     

        Migrating methods to WebCore

        * WebCoreSupport/WebFrameBridge.mm:
        * WebView/WebHTMLView.mm:
        * WebView/WebHTMLViewPrivate.h:

2007-01-31  Anders Carlsson  <acarlsson@apple.com>

        Reviewed by Maciej.

        <rdar://problem/4886776>
        REGRESSION: After opening a web archive, location shows the actual URL, not the webarchive file
        
        "Revert" the change done in 13734.
        
        * WebView/WebHTMLRepresentation.mm:
        (-[WebHTMLRepresentation loadArchive]):
        Don't do a new load here, as this would cancel the current load and call the resource load
        delegate's didFailLoadingWithError: method. Instead, call continueLoadWithData.

2007-02-01  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Maciej.

        Fix run-pageloadtest to actually work again.

        * Misc/WebNSWindowExtras.m:
        (+[NSWindow _webkit_displayThrottledWindows]):

2007-01-31  Adele Peterson  <adele@apple.com>

        Reviewed by Darin.

        WebKit part of fix for <rdar://problem/4521461> REGRESSION: when keyPress event changes form focus, inserted key goes to wrong control

        * WebCoreSupport/WebEditorClient.mm: (WebEditorClient::handleKeyPress): Instead of using the selected frame, use the
          frame for the target of the keyboard event.  Also, don't do the canEdit check here, since the target's frame might not
          have a selection at this point.  Do the canEdit check within Editor::insertText, where we determine which selection to use
          for inserting text.
        * WebView/WebEditingDelegatePrivate.h: Added forward declaration of DOMHTMLElement. This is needed after reordering includes in WebEditorClient.mm.

2007-01-31  Alice Liu  <alice.liu@apple.com>

        Reviewed by Tim Hatcher.

        Turning an accidental API change to an SPI change

        * WebView/WebEditingDelegate.h:
        * WebView/WebEditingDelegatePrivate.h:
        move some declarations into private header.  

2007-01-31  Darin Adler  <darin@apple.com>

        - fix build

        * ForwardingHeaders/wtf/ListHashSet.h: Added.

2007-01-31  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Anders.

        - related fix for <rdar://problem/4964407> REGRESSION: Mail hangs when replying, forwarding , or creating a new message
        
        * WebView/WebFrame.mm:
        (-[WebFrame loadArchive:]): This method also needs to add the lame WebDataRequest property or other things, like
        Mail Contents of Page, break.

2007-01-31  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Eric.
        
        - add back no-op version of silly method so that shipping Safari can still run the PLT

        * Misc/WebNSWindowExtras.m:
        (-[NSWindow _webkit_displayThrottledWindows]):

2007-01-31  Mark Rowe  <mrowe@apple.com>

        More build fixing.

        * Misc/WebKitLogging.h: Use !defined() rather than !.
        * Plugins/WebNetscapePluginStream.h: Remove #if __cplusplus as this file is only included from Obj-C++ files.
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _lookUpInDictionaryFromMenu:]): Use #ifdef rather than #if.
        * WebView/WebView.mm:
        (-[WebView isGrammarCheckingEnabled]): Ditto.

2007-01-31  Mark Rowe  <mrowe@apple.com>

        Build fix.

        * WebView/WebView.mm:
        (-[WebView initWithFrame:frameName:groupName:]):

2007-01-31  Mark Rowe  <mrowe@apple.com>

        Reviewed by Oliver.

        Enable -Wundef in WebKit, and change misuses of #if to #ifdef or #ifndef as appropriate.

        * Misc/WebKitLogging.h:
        * WebKit.xcodeproj/project.pbxproj:
        * WebView/WebFrame.mm:
        * WebView/WebFrameInternal.h:
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView validateUserInterfaceItem:]):
        (-[WebHTMLView delete:]):
        (-[WebHTMLView showGuessPanel:]):
        (-[WebHTMLView copy:]):
        (-[WebHTMLView cut:]):
        (-[WebHTMLView paste:]):
        * WebView/WebHTMLViewInternal.h:
        * WebView/WebView.mm:
        (-[WebViewPrivate init]):
        (-[WebView validateUserInterfaceItem:]):
        * WebView/WebViewPrivate.h:

2007-01-30  Brady Eidson  <beidson@apple.com>

        Reviewed by Oliver

        This is a corollary to <rdar://problem/4944887> where certain things happened on an alternate thread.
        To help catch such behavior in the future, add ASSERT_MAIN_THREAD() to key WebKit API points

        * History/WebHistoryItem.mm: Added ASSERT_MAIN_THREAD() to suspected API entry points
        (-[WebHistoryItem dealloc]):
        (-[WebHistoryItem finalize]):
        (-[WebHistoryItem copyWithZone:]):
        (-[WebHistoryItem URLString]):
        (-[WebHistoryItem originalURLString]):
        (-[WebHistoryItem title]):
        (-[WebHistoryItem lastVisitedTimeInterval]):
        (-[WebHistoryItem isEqual:]):
        (-[WebHistoryItem description]):
        (-[WebHistoryItem initWithWebCoreHistoryItem:]):
        (-[WebHistoryItem initFromDictionaryRepresentation:]):
        (-[WebHistoryItem scrollPoint]):
        (-[WebHistoryItem dictionaryRepresentation]):
        (-[WebHistoryItem target]):
        (-[WebHistoryItem visitCount]):
        (-[WebHistoryItem children]):
        (-[WebHistoryItem URL]):
        (-[WebHistoryItem _lastVisitedDate]):
        (-[WebHistoryItem targetItem]):

        * Misc/WebIconDatabase.mm: Added ASSERT_MAIN_THREAD() to suspected API entry points
        (-[WebIconDatabase iconForURL:withSize:cache:]):
        (-[WebIconDatabase iconURLForURL:]):
        (-[WebIconDatabase defaultIconWithSize:]):
        (-[WebIconDatabase retainIconForURL:]):
        (-[WebIconDatabase releaseIconForURL:]):
        (-[WebIconDatabase removeAllIcons]):
        (-[WebIconDatabase _iconForFileURL:withSize:]):
        (webGetNSImage):

        * Misc/WebKitLogging.h: Added ASSERT_MAIN_THREAD()
        * Misc/WebKitLogging.m:
        (WebKitRunningOnMainThread): Added

        * WebKit.xcodeproj/project.pbxproj: Define DISABLE_THREAD_CHECK until it is
          safe to run with ASSERT_MAIN_THREAD() active

2007-01-30  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Darin.

        <rdar://problem/4961953> Stop using NSString deprecated methods like initWithCString:

        * Misc/WebNSImageExtras.m:
        (-[NSImage _web_saveAndOpen]):
        * WebKit.xcodeproj/project.pbxproj:

2007-01-30  Mitz Pettel  <mitz@webkit.org>

        Reviewed by Geoff.

        - fix http://bugs.webkit.org/show_bug.cgi?id=12050
          REGRESSION: Assertion failure in -[WebBaseNetscapePluginView willCallPlugInFunction] (plugin)

        Test: plugins/createScriptableObject-before-start.html

        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView createPluginScriptableObject]): Return NULL if
        the plugin is not started.

2007-01-30  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Anders.
        
        <rdar://problem/4964407> REGRESSION: Mail hangs when replying, forwarding , or creating a new message
        
        * WebView/WebFrame.mm:
        (-[WebFrame _loadData:MIMEType:textEncodingName:baseURL:unreachableURL:]): Set WebDataRequest property on data
        load requests since Mail specifically checks for this.

2007-01-30  Graham Dennis  <graham.dennis@gmail.com>

        Reviewed by Maciej.

        Part of fix for http://bugs.webkit.org/show_bug.cgi?id=10725
        Image data in from RTFD clipboard data thrown away
        
        The URLs for images in RTFD data must not be loaded until the resources
        have been added to the WebUnarchivingState. This can't happen until
        after the RTFD data has been parsed, so we must delay loading while this
        RTFD data is being parsed to a document fragment.

        * WebView/WebHTMLView.mm:
        (uniqueURLWithRelativePart):
        (-[WebHTMLView _documentFragmentFromPasteboard:inContext:allowPlainText:chosePlainText:]): defer loading the resources while RTFD data is being parsed.
        (+[NSURL _web_uniqueWebDataURL]): Added this back because AppKit uses it.
        * WebView/WebUnarchivingState.m:
        (-[WebUnarchivingState archivedResourceForURL:]): orkaround for workaround for rdar://problem/4699166 so that other people can use archivedResourceForURL: too.

2007-01-29  Jim Correia  <jim.correia@pobox.com>

        Reviewed by Mark.

        Added support for -allowsUndo/-setAllowsUndo: to allow editable WebView
        clients to completely disable undo registration. This is functionally
        equivalent to the methods with the same names on NSTextView.

        * WebView/WebView.mm:
        (-[WebViewPrivate init]):
        (-[WebView initWithCoder:]):
        (-[WebView encodeWithCoder:]):
        (-[WebView allowsUndo]):
        (-[WebView setAllowsUndo:]):
        (-[WebView undoManager]):
        * WebView/WebViewPrivate.h:

2007-01-29  Ada Chan  <adachan@apple.com>

        Reviewed by Brady.

        Moved the update of the title of the current entry in the backforward list to WebCore.

        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::setTitle):

2007-01-29  Adele Peterson  <adele@apple.com>

        Reviewed by Darin.

        More preparation for event handling fixes.

        * WebCoreSupport/WebEditorClient.h: Removed EventTargetNode parameter, since you can
          just get this from the KeyboardEvent.
        * WebCoreSupport/WebEditorClient.mm: (WebEditorClient::handleKeyPress): ditto.

        * WebView/WebHTMLViewInternal.h: Added interpretKeyEventsParameters struct.
        * WebView/WebViewInternal.h: Changed parameter from NSEvent to WebCoreKeyboardEvent in _interceptEditingKeyEvent.
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView yankAndSelect:]): Updated for new triggeringEvent parameter.
        (-[WebHTMLView _interceptEditingKeyEvent:]): Set the WebHTMLViewInterpretKeyEventsParameters.
        (-[WebHTMLView doCommandBySelector:]): Access WebHTMLViewInterpretKeyEventsParameters.
        (-[WebHTMLView insertText:]): ditto.
        (-[WebHTMLView _insertText:selectInsertedText:triggeringEvent:]): Added parameter for triggeringEvent.

2007-01-29  Oliver Hunt  <oliver@apple.com>

        build fix  

        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _startDraggingImage:at:operation:event:sourceIsDHTML:DHTMLWroteData:]):

2007-01-25  Oliver Hunt  <oliver@apple.com>

        Reviewed by Adam.

        Migrated drag state and logic to WebCore, removed superfluous methods

        * ChangeLog:
        * WebCoreSupport/WebDragClient.h:
        * WebCoreSupport/WebDragClient.mm:
        (WebDragClient::dragSourceActionMaskForPoint):
        * WebCoreSupport/WebFrameBridge.mm:
           allowDHTMLDrag move to WebCore::EventHandler
        * WebView/WebHTMLView.mm:
        (-[WebHTMLView _startDraggingImage:at:operation:event:sourceIsDHTML:DHTMLWroteData:]):
        (-[WebHTMLView draggedImage:movedTo:]):
        (-[WebHTMLView draggedImage:endedAt:operation:]):
          dragOffset and dragSourecAction is now stored in WebCore::DragController
          migrated _delegateDragSourceActionMask to WebCore::DragController
        * WebView/WebHTMLViewInternal.h:
          Removed dragOffset declaration, migrated to WebCore::DragController
        * WebView/WebView.mm:
          removed unnecessary method, _loadingDragOperationForDraggingInfo

2007-01-29  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Mark.

        - updated for cross-platform data loading support
        
        * WebCoreSupport/WebFrameLoaderClient.h:
        * WebCoreSupport/WebFrameLoaderClient.mm:
        (WebFrameLoaderClient::createDocumentLoader):
        * WebView/WebDataSource.mm:
        (-[WebDataSource initWithRequest:]):
        * WebView/WebDocumentLoaderMac.h:
        * WebView/WebDocumentLoaderMac.mm:
        (WebDocumentLoaderMac::WebDocumentLoaderMac):
        * WebView/WebFrame.mm:
        (-[WebFrame _loadData:MIMEType:textEncodingName:baseURL:unreachableURL:]):
        (-[WebFrame loadData:MIMEType:textEncodingName:baseURL:]):
        (-[WebFrame _loadHTMLString:baseURL:unreachableURL:]):
        (-[WebFrame loadArchive:]):
        * WebView/WebFrameInternal.h:
        * WebView/WebHTMLView.mm:
        (uniqueURLWithRelativePart):
        (-[WebHTMLView _documentFragmentFromPasteboard:inContext:allowPlainText:chosePlainText:]):

2007-01-27  David Kilzer  <ddkilzer@webkit.org>

        Reviewed by Adam.

        - fix http://bugs.webkit.org/show_bug.cgi?id=12260
          Windows platform build is not maintained

        * COM/ChromeClientWin.cpp:
        (ChromeClientWin::canTakeFocus):
        (ChromeClientWin::takeFocus):
        * COM/ChromeClientWin.h:
        * COM/ContextMenuClientWin.cpp:
        (ContextMenuClientWin::getCustomMenuFromDefaultItems):
        (ContextMenuClientWin::searchWithGoogle):
        * COM/ContextMenuClientWin.h:
        * COM/WebFrameLoaderClient.cpp:
        (WebFrameLoaderClient::assignIdentifierToInitialRequest):
        (WebFrameLoaderClient::dispatchWillSendRequest):
        (WebFrameLoaderClient::dispatchDidReceiveAuthenticationChallenge):
        (WebFrameLoaderClient::dispatchDidCancelAuthenticationChallenge):
        (WebFrameLoaderClient::dispatchDidReceiveResponse):
        (WebFrameLoaderClient::dispatchDidReceiveContentLength):
        (WebFrameLoaderClient::dispatchDidFinishLoading):
        (WebFrameLoaderClient::dispatchDidFailLoading):
        (WebFrameLoaderClient::dispatchDidLoadResourceFromMemoryCache):
        (WebFrameLoaderClient::dispatchDidFailProvisionalLoad):
        (WebFrameLoaderClient::dispatchDidFailLoad):
        (WebFrameLoaderClient::dispatchCreatePage):
        (WebFrameLoaderClient::dispatchDecidePolicyForMIMEType):
        (WebFrameLoaderClient::dispatchDecidePolicyForNewWindowAction):
        (WebFrameLoaderClient::dispatchDecidePolicyForNavigationAction):
        (WebFrameLoaderClient::dispatchUnableToImplementPolicy):
        (WebFrameLoaderClient::setMainDocumentError):
        (WebFrameLoaderClient::incrementProgress):
        (WebFrameLoaderClient::completeProgress):
        (WebFrameLoaderClient::startDownload):
        (WebFrameLoaderClient::committedLoad):
        (WebFrameLoaderClient::cancelledError):
        (WebFrameLoaderClient::cannotShowURLError):
        (WebFrameLoaderClient::interruptForPolicyChangeError):
        (WebFrameLoaderClient::cannotShowMIMETypeError):
        (WebFrameLoaderClient::fileDoesNotExistError):
        (WebFrameLoaderClient::shouldFallBack):
        (WebFrameLoaderClient::willUseArchive):
        (WebFrameLoaderClient::createDocumentLoader):
        (WebFrameLoaderClient::download):
        * COM/WebFrameLoaderClient.h:

2007-01-27  David Harrison  <harrison@apple.com>

        Reviewed by Kevin.

        <rdar://problem/4958902> REGRESSION: Dashboard widgets fail to load
        
        This was caused by the WebView preferences rework in r18417. Specifically, in
        _updateWebCoreSettingsFromPreferences when calling setUserStyleSheetLocation,
        [NSURL URLWithString:] is now messaged directly with the result of
        [[preferences userStyleSheetLocation] _web_originalDataAsString]], which will
        be nil if the userStyleSheetLocation has not been set yet. [NSURL URLWithString:]
        throws an exception when the string is nil. DashboardClient.app calls
        setUserStyleSheetEnabled *before* calling setUserStyleSheetLocation.

        * WebView/WebView.mm:
        (-[WebView _updateWebCoreSettingsFromPreferences:]):
        Pass empty string instead of nil string to [NSURL URLWithString:].

2007-01-26  Darin Adler  <darin@apple.com>

        Reviewed by Timothy.

        Fixes crash drawing avatar on mail.yahoo.com.

        * Plugins/WebBaseNetscapePluginStream.m: Retain the object since destroyStreamWithError: might
        release the last reference to it.

2007-01-26  Darin Adler  <darin@apple.com>

        Reviewed by Beth.

        * WebInspector/webInspector/inspector.js: Updated for new computed style properties.

2007-01-26  Kevin Decker <kdecker@apple.com>

        Reviewed by andersca.

        Fixed: <rdar://problem/4946922> WebBaseNetscapePluginView leaks memory
        http://bugs.webkit.org/show_bug.cgi?id=11523

        * Plugins/WebBaseNetscapePluginStream.m:
       (-[WebBaseNetscapePluginStream setPlugin:]): Calls -[WebBaseNetscapePluginView disconnectStream:]
        * Plugins/WebBaseNetscapePluginView.h: Added disconnectStream: to header.
        * Plugins/WebBaseNetscapePluginView.mm:
        (-[WebBaseNetscapePluginView stop]): Make a copy of the streams collection prior to calling stop all streams.
        This is necessary because calling stop has the side effect of removing the stream from this same collection.
